2025-04-10  Jim Meyering  <meyering@meta.com>

	version 3.12
	* NEWS: Record release date.

2025-04-09  Jim Meyering  <meyering@meta.com>

	tests: mb-non-UTF8-perf-Fw: undo previous change
	* tests/mb-non-UTF8-perf-Fw: Ugh. I misread the code and
	didn't even test.  Given circumstances and the new timing that's
	well within the 30-second timeout, I think there's no point
	in trying to accommodate systems that are so overburdened they
	trigger this failure. Reported by Grisha Levit.

	tests: mb-non-UTF8-perf-Fw:: avoid false failure on overloaded systems
	* tests/mb-non-UTF8-perf-Fw: Raise timeout from 1 to 3s
	to accommodate slow systems.  Reported by Nelson Beebe in
	https://lists.gnu.org/r/grep-devel/2025-04/msg00027.html

2025-04-08  Jim Meyering  <meyering@meta.com>

	build: fix module name typo
	* bootstrap.conf (gnulib_modules): Fix module name typo I introduced.
	s/realloc-gnu-h/realloc-posix/. Reported by Bruno Haible in
	https://bugs.gnu.org/77654

	build: avoid new bootstrap failure
	* bootstrap.conf (bootstrap_post_import_hook): Append "|| :", fixing
	my previous change. Otherwise, bootstrap would fail with this:
	./bootstrap: bootstrap_post_import_hook failed

2025-04-08  Bruno Haible  <bruno@clisp.org>

	doc: temper a Unicode support claim: it's not quite done
	* NEWS: clarify that the "Unicode characters outside the Basic
	Multilingual Plane" item is not quite done.

2025-04-08  Jim Meyering  <meyering@meta.com>

	tests: hash-collision-perf: avoid test hang on GNU/Hurd
	This test would hang on GNU/Hurd because the perl code we use to measure
	subsecond duration isn't ported, and that loop would never terminate.
	* tests/hash-collision-perf: Detect the always-0 small_ms, and skip the test.
	Reported by Bruno Haible in https://bugs.gnu.org/77613

	grep: avoid regression with -mN and any of -q, -l, -L
	* src/grep.c (grepbuf): Handle this case: echo x|grep -l -m1 .
	making it print only the file name, and not the matched line.
	(main): Set out_quiet also when exit_on_match (-q) is set, so
	"echo x|grep -q -m1 ." no longer prints the matched line.
	* tests/max-count-overread: Add those tests, from
	https://bugs.gnu.org/68989#21

2025-04-06  Jim Meyering  <meyering@meta.com>

	build: avoid using pkg-config's pkg.m4 serial 12
	* bootstrap.conf (bootstrap_post_import_hook): Add code to ensure we
	do not use pkg.m4 serial 12. For the record, I've temporarily copied
	the version of pkg.m4 from grep-3.11 into $(aclocal --print-ac-dir),
	so that when I run bootstrap, it always gets that serial 11 version.
	Reported by Bruno Haible in
	https://lists.gnu.org/r/grep-devel/2025-04/msg00005.html

2025-04-04  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2025-03-27  Jim Meyering  <meyering@meta.com>

	maint: ensure that new "make syntax-check"-run sc_codespell passes
	* cfg.mk (codespell_ignore_words_list): Ignore some false-positives.

2025-03-25  Jim Meyering  <meyering@meta.com>

	build: use gnulib's new c-strcasecmp module, rather than c-strcase
	* bootstrap.conf (gnulib_modules): Use new c-strcasecmp module, rather
	than c-strcase, since grep uses c_strcasecmp and not c_strncasecmp.

	build: update gnulib to latest; and update bootstrap

	grep: remove long-deprecated --unix-byte-offsets (-u) option
	* src/grep.c (main): Remove vestiges of --unix-byte-offsets (-u).
	In grep-3.7 (2021-08-14) it became a warning-only no-op.
	Before then, it was a Windows-only no-op.
	* NEWS (Changes in behavior): Mention it.

2025-03-21  Paul Eggert  <eggert@cs.ucla.edu>

	doc: update man for groff 1.23.0 and apostrophes
	* doc/grep.in.1: Merge from groff 1.23.0 tmac/an-ext.tmac.
	On Groff, fix usage neutral apostrophes;
	they cannot be reliably fixed in traditional troff.

	doc: use \w@...@ not \w|...|
	* doc/grep.in.1: Avoid warnings in bleeding-edge groff.

	doc: fix troff typo
	* doc/grep.in.1: .BR → .B (Bug#77000).

2025-02-08  Jim Meyering  <meyering@meta.com>

	grep: support gnulib-l10n
	* src/grep.c (main): Call bindtextdomain for gnulib-l10n.

	maint: continue writing base64-encoded checksums to announcement
	* cfg.mk (announce_gen_args): Set to --cksum-checksums.

2025-02-01  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest; and update bootstrap

	maint: reflect gnulib module renamings
	* bootstrap.conf: Some gnulib modules are now deprecated, in
	favor of new names with a "-h" suffix (and stdbool->bool).
	Induce this change with the following:
	  re='inttypes|locale|realloc-gnu|stdckdint|stddef|stdlib|string'
	  re="$re|sys_stat|unistd"
	  perl -pi -e 's{^('"$re"')$}{$1-h};s{^stdbool$}{bool}' bootstrap.conf

2025-01-15  Jim Meyering  <meyering@meta.com>

	doc: clarify a --help sentence
	* src/grep.c (usage): Prompted by a suggestion at
	https://bugs.gnu.org/75582 by Anton Samokat.
	* THANKS.in: Add that name.

2025-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	maint: update all copyright dates via "make update-copyright"

	maint: update bootstrap from Gnulib
	* bootstrap: sync from Gnulib

	build: update gnulib submodule to latest

2024-12-16  Paul Eggert  <eggert@cs.ucla.edu>

	grep: revert recent \d change
	I misread the email thread and thought there was consensus
	for the \d change, but there was wasn’t so revert the change.
	Also, document the resulting confusion
	somewhat better than it was documented before.
	* src/pcresearch.c, tests/pcre-ascii-digits, tests-pcre-utf8-w:
	Revert recent \d change, restoring the behavior to that of grep 3.11.

	doc: give an example non-ASCII digit
	* doc/grep.texi: Give ‘٣’ as an example of a non-ASCII digit.

	doc: don’t send “ſ” to PDF
	* doc/grep.texi: Don’t output “ſ” (U+017F LATIN SMALL LETTER LONG S)
	to PDF, since pdfTeX can’t handle it.

	doc: more improvements for -P discussion
	* doc/grep.texi (grep Programs): Also mention git grep
	and pcre2grep.

2024-12-14  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve -P discussion
	* doc/grep.texi (grep Programs): Improve discussion of how grep -P
	differs from Perl.

	grep: go back to 3.9 -P '\d' behavior
	Treating \d differently from Perl was more trouble than it was worth.
	* NEWS, doc/grep.texi (grep Programs): Document this.
	* src/pcresearch.c (PCRE2_EXTRA_ASCII_BSD):
	Remove.  All uses removed.
	* tests/pcre-ascii-digits: Adjust to this change.
	* tests/pcre-utf8-w: Revert to 3.9.

2024-11-26  Grisha Levit  <grishalevit@gmail.com>

	tests: fix define for glibc-infloop
	* configure.ac (USE_INCLUDED_REGEX): fix condition for definition.
	This doesn't affect anything right now since the value is examined
	only by an unconditionally skipped test.

2024-11-04  Paul Eggert  <eggert@cs.ucla.edu>

	doc: more consistent style for ‘...’
	Problem reported by Martin Schulte <https://bugs.gnu.org/74205>.
	* doc/grep.in.1, doc/grep.texi:
	Use a more consistent style for [OPTION]... and [FILE]... in usage.
	This doesn’t match what POSIX does but seems to be common in GNU doc.
	Also, ‘...’ -> ‘@dots{}’ in grep.texi.

2024-11-01  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix -q suppression of diagnostics
	Problem reported by Jan Černohorský (Bug#74159).
	* src/grep.c (grepbuf): If exit_on_match, set stdout_errno to
	avoid screwups on buggy OSes.  Also, ignore errseen since it
	cannot be true here.
	(main): Do not clear exit_failure if -q is given, as exit status
	should be zero only if an input line is selected.
	* tests/write-error-msg: Check that -q suppresses diagnostics
	of output errors only if a match is found.

2024-09-21  Paul Eggert  <eggert@cs.ucla.edu>

	doc: warn re using ‘grep’ to detect binary files
	This is in response to a bug report by Rodrigo Jorge
	<https://bugs.gnu.org/73360>.
	* doc/grep.texi (File and Directory Selection):
	Warn that ‘grep’ shouldn’t be used to determine whether
	a file is binary for other applications’ purposes, as
	their definition of “binary” may well differ.
	Improve documentation for discovery of null input.

	grep: avoid huge reads
	The previous code could call 'read' with a nearly unbounded size
	if the input had long lines, and this unbounded size persisted
	from one file to the next once the input buffer grew.
	This could have bad effects on the CPU's data cache,
	and also could cause 'grep' to make counterintuitive decisions as
	to whether a file is binary <https://bugs.gnu.org/73360>.
	Instead, pick a good read size and stick with it; this is
	more consistent, and more likely to fit in a cache.
	* src/grep.c (good_readsize): New static var.
	(GOOD_READSIZE_MIN): Rename from INITIAL_BUFSIZE.  All uses changed.
	(fillbuf): Read good_readsize bytes rather than trying to
	fill the rest of the input buffer.
	(drain_input): Read good_readsize rather than GOOD_READSIZE_MIN
	bytes.
	(main): Initialize good_readsize.

	grep: simplify non-usage of rawmemrchr
	* src/grep.c (grep): Simplify by not assuming that the
	code will eventually use a nonexistent rawmemrchr function.

	grep: adjust to safe_read change
	* src/grep.c (fillbuf): Adjust to Gnulib safe_read API change;
	it now returns ptrdiff_t, with -1 signifying error.

	maint: port GNULIB_WARN_CFLAGS to gcc 14
	* configure.ac (GNULIB_WARN_CFLAGS): Add -Wmissing-declarations,
	-Wmissing-prototypes, -Wmissing-variable-declarations,
	-Wnull-dereference, -Wsuggest-attribute=cold.

	build: update gnulib submodule to latest

2024-09-08  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2024-09-08  Jim Meyering  <meyering@meta.com>

	maint: placate GCC's -Wunterminated-string-initialization
	This new GCC warning triggered a false alert. But it's simple,
	cleaner and just as efficient to use pointers and strlen:
	* src/pcresearch.c (Pcompile): Declare prefix and suffix
	variables as pointers to literal strings, rather than as
	arrays of characters that deliberately omitted the trailing
	NUL byte, and which provoked these warnings from the very
	latest GCC:

	pcresearch.c:220:23: error: initializer-string for array of
	'char' is too long [-Werror=unterminated-string-initialization]
	220 |  wprefix[10] = "(?<!\\w)(?:", wsuffix[7] = ")(?!\\w)";
	    |                            ^~~~~~~~~~~~~

2024-09-08  Jim Meyering  <meyering@meta.com>

	maint: modernize GNU GPL license comments
	To accommodate a new syntax-check rule, ...
	Make comments that suggested to write to an old FSF Franklin Street
	address refer to https://www.gnu.org/licenses instead:

	  git grep -l 'if not, write' |xargs \
	  perl -0777 -pi -e 's{program; if not, write .*? USA\.}{program.  If not, see <https://www.gnu.org/licenses/>.}ms'

2024-07-09  Bruno Haible  <bruno@clisp.org>

	tests: Fix recognition of cs_CZ.UTF-8 locale on FreeBSD.
	* tests/fmbtest: Use 'locale charmap' to determine the locale's encoding.
	* tests/foad1: Likewise.

2024-07-04  Collin Funk  <collin.funk1@gmail.com>

	maint: import tests/init.sh from Gnulib during bootstrap
	* bootstrap.conf (bootstrap_post_import_hook): Use gnulib-tool
	--copy-file to import tests/init.sh.
	* tests/init.sh: Remove file.
	* .gitignore (/tests/init.sh): Add entry.

2024-07-04  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest and update bootstrap

2024-06-11  Bruno Haible  <bruno@clisp.org>

	maint: Avoid test-mbrlen-1.sh failure on CentOS 7.
	* configure.ac: Pre-set gl_cv_func_mbrlen_empty_input.
	* bootstrap.conf (avoided_gnulib_modules): Avoid also mbrlen-tests.

2024-05-21  Paul Eggert  <eggert@cs.ucla.edu>

	doc: fix troff typos
	* doc/grep.in.1: Fix troff typos found by mandoc and groff.
	Problem reported by Bjarni Ingi Gislason (bug#71087).

	build: update bootstrap to latest

	build: update gnulib submodule to latest

2024-02-18  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

	maint: avoid syntax-check failure: use <>, not "" for system headers
	* src/dfasearch.c: As above.
	* src/grep.c: Likewise.
	* src/kwsearch.c: Likewise.
	* src/pcresearch.c: Likewise.
	* src/searchutils.c: Likewise.

2024-02-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix ‘grep -m2 pattern <file >/dev/null’
	Problem reported by Grisha Levit <https://bugs.gnu.org/68989>.
	* src/grep.c (grep, main): Don’t set done_on_match if -m is used.
	* tests/max-count-overread: Add a test case.

2024-01-28  Paul Eggert  <eggert@cs.ucla.edu>

	Improve doc for range expressions
	grep currently doesn’t implement rational ranges or any other
	particular behavior for range expressions outside the C locale.
	Adjust the documentation to match the behavior more closely.
	Problem reported by Ronan Pigott in:
	https://lists.gnu.org/r/grep-devel/2024-01/msg00000.html
	* doc/grep.texi (Character Classes and Bracket Expressions):
	Be more careful about terminology.  Don’t say “sorts” because
	the collation sequence is not the same as the sort order.
	Don’t make promises about behavior outside the C locale,
	as the current code might not fulfill them.
	* doc/grep.in.1: Adjust wording to match.  The old wording
	was out-of-sync anyway.

2024-01-05  Jim Meyering  <meyering@meta.com>

	maint: update all copyright dates via "make update-copyright"

	build: update gnulib to latest; also update bootstrap and init.sh

2023-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	grep: prefer nullptr to NULL
	* bootstrap.conf (gnulib_modules): Add nullptr.
	All uses of NULL eliminated or changed to nullptr,
	modernizing us from C89 to C23.

2023-09-11  Paul Eggert  <eggert@cs.ucla.edu>

	grep: simplify wordchars_count
	* src/searchutils.c (wordchars_count): Simplify slightly
	by using a pointer rather than an offset.

	grep: use mbszero
	* bootstrap.conf (gnulib_modules): Add mbszero.
	* src/grep.c (buf_has_encoding_errors, contains_encoding_error)
	(setup_ok_fold, fgrep_icase_available, fgrep_to_grep_pattern)
	(try_fgrep_pattern):
	* src/searchutils.c (mb_goback, wordchars_count):
	Use it.

2023-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	maint: wchar-single, no strtou*
	* bootstrap.conf (gnulib_modules): Remove strtoull, strtoumax.
	They are no longer used.  Use wchar-single instead of wchar,
	since grep does not change locale.

	grep: omit propername, as it’s not used
	Omit Gnulib’s propername module, as it has not been used since my
	commit 3c0a36e514237132db711bfef57a74c64592c4e2 dated Thu Dec 20
	16:35:55 2018 -0800.
	* bootstrap.conf (avoided_gnulib_modules):
	Do not avoid mbchar, as it is no longer pulled in by propername.
	(gnulib_modules): Remove propername.
	* src/Makefile.am (LDADD):
	* tests/Makefile.am (LDADD): Remove $(LIBICONV); no longer needed.
	* src/grep.c: Do not include propername.h.

	maint: prefer mcel
	* bootstrap.conf (avoided_gnulib_modules):
	Avoid mbchar, mbuiter, mbuiterf.
	(gnulib_modules): Add mcel-prefer.

	build: update gnulib submodule to latest

2023-08-20  Jim Meyering  <meyering@meta.com>

	tests: actually package and run the new 100k-entries test
	* tests/Makefile.am (TESTS): Include the new test file name,
	100k-entries.

2023-08-05  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify -- role
	This should fix bug#65046 reported by Helmut Waltzmann.

2023-07-21  Jim Meyering  <meyering@meta.com>

	doc: mention the 100,000-entry ENOTSUP bug
	* NEWS: document the fixed bug.
	* tests/100k-entries: New file, to test for this.
	Reported by Vincent Lefevre via Santiago Ruano Rincón in
	https://bugs.gnu.org/64773
	Fixed by gnulib commit v0.1-6175-gd4d8abb39e.

2023-07-11  Paul Eggert  <eggert@cs.ucla.edu>

	maint: link with mbrtc32-required libraries
	Add libraries now suggested by gnulib-tool.
	* src/Makefile.am (LDADD):
	* tests/Makefile.am (LDADD):
	Add $(HARD_LOCALE_LIB), $(LIBC32CONV), $(LIBSIGSEGV),
	$(LIBUNISTRING), $(MBRTOWC_LIB), $(SETLOCALE_NULL_LIB).
	* tests/Makefile.am (LDADD):
	Also add $(LIBCSTACK), $(LIBICONV), $(LIBTHREAD).

2023-07-10  Paul Eggert  <eggert@cs.ucla.edu>

	maint: fix NEWS typo

	maint: sync bootstrap from Gnulib

2023-07-10  Paul Eggert  <eggert@cs.ucla.edu>

	maint: omit obsolescent Autoconf macros
	* configure.ac: Don’t use the obsolescent macros AC_TYPE_SIZE_T,
	AC_C_CONST, AC_HEADER_DIRENT, AC_FUNC_CLOSEDIR_VOID.

	maint: remove isascii check
	* configure.ac (isascii): Stop checking for this function,
	as it’s not used.

2023-07-10  Paul Eggert  <eggert@cs.ucla.edu>

	grep: switch from wchar_t to char32_t
	* bootstrap.conf (gnulib_modules): Add c32isalnum, c32rtomb,
	mbrtoc32-regular.  Remove mbrtowc, wcrtomb, wctob, wctype-h.
	wctob appears to be stray, as I don’t think was needed before
	this change either.
	* src/grep.c: Include uchar.h.
	(setup_ok_fold, fgrep_icase_charlen):
	Use char32_t, not wchar_t.
	* src/search.h: Do not include wctype.h.
	* src/searchutils.c: Include uchar.h.
	(wordchar): Use c32isalnum, not iswalnum.
	(wordchars_count): Use char32_t, not wchar_t.

2023-07-10  Bruno Haible  <bruno@clisp.org>

	build: update gnulib submodule to latest
	* src/grep.c (setup_ok_fold, fgrep_icase_charlen):
	Change the element type of the 'folded' array, to match the new
	signature of case_folded_counterparts.

2023-07-10  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	grep: dynamically allocate buffer for -P version
	* src/pcresearch.c (Pprint_version): Allocate version buffer
	dynamically rather than aborting if a fixed-size buffer
	is too small.

2023-06-24  Bruno Haible  <bruno@clisp.org>

	build: Ensure that makeinfo ≥ 6.8 checks the @menu structure.
	See <https://lists.gnu.org/archive/html/bug-texinfo/2023-06/msg00015.html>.

	* doc/Makefile.am (MAKEINFO): New variable.
	* cfg.mk (_makefile_at_at_check_exceptions): New variable.

2023-06-24  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-05-27  Jim Meyering  <meyering@fb.com>

	build: modernize bootstrap prerequsite tools
	Following Pádraig Brady's example from coreutils, ...
	* bootstrap.conf: Add an explicit requirement on m4.
	Add an explicit requirement on texi2pdf -- often packaged separately
	rather than with makeinfo -- its absence would otherwise induce a
	failure late in the build process.
	Replace the rsync dependency with wget,
	which gnulib changed to in 2018.
	Also, add an xz requirement and a version for autopoint.

2023-05-13  Jim Meyering  <meyering@meta.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.11
	* NEWS: Record release date.

2023-05-10  Josh Soref  <jsoref@gmail.com>

	doc: spelling fixes in doc/, comments and old ChangeLog
	* ChangeLog-2009: Fix spelling errors.
	* bootstrap: Likewise.
	* doc/grep.texi: Likewise.

2023-05-04  Jim Meyering  <meyering@fb.com>

	tests: reenable gnulib's strtoll and strtoull tests
	* bootstrap.conf (avoided_gnulib_modules): Restore those tests.
	The failures I saw must have been due to a stale config.cache.

2023-04-30  Jim Meyering  <meyering@fb.com>

	tests: temporarily omit gnulib's strtoll and strtoull tests
	* bootstrap.conf (avoided_gnulib_modules): Omit strtoll and strtoull
	tests, because the edge-case 0[bx] tests fail on recent systems.

2023-04-30  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-04-30  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	pcre: work around a PCRE2_MATCH_INVALID_UTF bug
	PCRE2 has a bug when using PCRE2_MATCH_INVALID_UTF: it would
	sometimes fail to match patterns using negative classes
	like \W and \D.

	* NEWS (Bug fixes): Mention it.
	* src/pcre2search.c: Restrict impact of the bug.
	Do not use the problematic flag with broken versions of PCRE2.
	Also, generate locale tables only for single-byte locales,
	as the PCRE2 documentation recommends this.
	* tests/Makefile.am (TESTS): Add the file name
	* tests/pcre-utf8-bug224: New file, to test for this.

2023-04-29  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve doc for -P '\d'
	This follows up to Carlo Marcelo Arenas Belón’s email
	<https://lists.gnu.org/r/grep-devel/2023-04/msg00017.html>
	that proposed changing the code too.  These patches change
	only the documentation since we’re so near a release.
	* NEWS: Be less optimistic about the fix for -P '\d',
	and warn that behavior is likely to change again.
	* doc/grep.texi (grep Programs): Be less specific about -P \d
	behavior, since it’s still in flux.  Warn about mismatching
	Unicode versions, or disagreements about obscure constructs.

	build: support explicit ‘PCRE_CFLAGS= PCRE_LIBS=’
	* m4/pcre.m4 (gl_FUNC_PCRE): Check whether PCRE_CFLAGS and
	PCRE_LIBS are set, not whether they are set to a nonempty value.

2023-04-29  Jim Meyering  <meyering@fb.com>

	doc: say that `-f -` reads patterns from stdin
	* doc/grep.texi (Matching Control): Mention that when -f's FILE is -,
	grep reads patterns from stdin.
	* doc/grep.in.1: Likewise.
	* THANKS.in: Add the name.
	Suggested by Sebastian Carlos in https://bugs.gnu.org/63146

2023-04-22  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	build: prevent pkg-config from overriding PCRE_* settings
	The use of PCRE_CFLAGS and PCRE_LIBS, as documented in the output of
	`--help`, is meant to override those settings from pkg-config.

	* NEWS: mention this
	* m4/pcre.m4: avoid overriding user provided settings

2023-04-20  Jim Meyering  <meyering@fb.com>

	doc: note when a bug was introduced
	* NEWS: say that the \d bug was introduced in 3.10.

2023-04-20  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-04-13  Paul Eggert  <eggert@cs.ucla.edu>

	grep: make -P survive JIT compilation failure
	* src/pcresearch.c (Pcompile): Ignore failure returns
	from pcre2_jit_compile.

2023-04-10  Paul Eggert  <eggert@cs.ucla.edu>

	grep: improve PCRE2 version output
	* src/grep.c: No need to include pcre2.h.
	(main) [HAVE_LIBPCRE]: Call Pprint_version instead of
	doing it ourselves.
	* src/pcresearch.c (Pprint_version): New function.
	It also checks belatedly for buffer overflow, and
	says "grep -P uses PCRE2" instead of "Built with PCRE".
	* tests/version-pcre: Adjust test to match.

2023-04-10  Jim Meyering  <meyering@fb.com>

	tests: skip y2038 test upon touch setup failure
	* tests/y2038-vs-32-bit: Skip rather than fail, when
	the touch -t 2039... setup fails.  That command failed
	on a solaris10 sparc build farm host.

2023-04-09  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-04-09  Jim Meyering  <meyering@fb.com>

	tests: add a known-failing glibc-infloop test
	* tests/glibc-infloop: New file.
	Based on the command from Koen Claessen
	reported in https://bugs.gnu.org/62483
	* configure.ac (USE_INCLUDED_REGEX): define.
	* tests/Makefile.am (TESTS): Add the file name
	* THANKS.in: Add name of reporter.

	grep: --version: print pcre version info
	PCRE is integral to the functioning of grep's -P option, so it is in our
	interest to make it easy to see which version of PCRE grep uses.
	* src/grep.c [HAVE_LIBPCRE]: Include <pcre2.h>.
	[HAVE_LIBPCRE] (main): Print pcre version info.
	* tests/version-pcre: New test for this.
	* tests/Makefile.am (TESTS): Add the file name.
	* NEWS (Changes in behavior): Mention it.

	tests: test for the year-2038 bug
	* tests/y2038-vs-32-bit: New file.
	* tests/Makefile.am (TESTS): Add the file name

2023-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	grep: re-fix Y2038 bug on glibc 2.34+ x86, ARM
	The meaning of AC_SYS_LARGEFILE has changed to no longer even try
	to use wider time_t if available.  So use AC_SYS_YEAR2038 as well.
	A more-aggressive change would be to use the next Autoconf’s
	AC_SYS_YEAR2038_REQUIRED but at least let’s restore the grep 3.8
	behavior.
	* NEWS: Mention this.
	* bootstrap.conf: Add year2038.

2023-04-02  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix -P [\d] by fixing \w only if PCRE2 10.43
	Our prepass-based fixes for the -P \d bug have caused repeated
	further bugs.  Avoid the need for a prepass, by using PCRE2_UCP
	only if PCRE2_EXTRA_ASCII_BSD is also supported.  Since the -P \w
	bug was present from grep 2.5 through 3.8 it’s OK if we wait a
	little longer to fix it.
	* NEWS: Mention this.
	* src/pcresearch.c (pcre_pattern_expand_backslash_d}: Remove.
	Remove its use.
	(Pcompile): Use PCRE2_UCP only if PCRE2_EXTRA_ASCII_BSD.
	* tests/pcre-ascii-digits, tests/pcre-utf8-w:
	Skip tests on older PCRE2 implementations.

2023-03-22  Jim Meyering  <meyering@meta.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.10
	* NEWS: Record release date.

2023-03-22  Paul Eggert  <eggert@cs.ucla.edu>

	doc: avoid capital sharp S with TeX
	Do not use “ẞ” (U+1E9E, LATIN CAPITAL LETTER SHARP S) in tex, as
	texinfo version 2023-03-04.12 complains “Character missing, sorry:
	LONG S.”

2023-03-22  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-03-20  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-03-20  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify BRE vs ERE (bug#62272)

2023-03-19  Jim Meyering  <meyering@fb.com>

	grep: -P (--perl-regexp) \D once again works like [^0-9]
	* NEWS: Mention \D, too.
	* doc/grep.texi: Likewise
	* src/pcresearch.c (pcre_pattern_expand_backslash_d): Handle \D.
	Also, ifdef-out this new function and its call site when not needed.
	* tests/pcre-ascii-digits: Test \D, too.
	Tighten one test by using returns_ 1.
	Add comments and tests that work only with 10.43 and newer.
	Paul Eggert raised the issue of \D in https://bugs.gnu.org/62267#8

2023-03-19  Paul Eggert  <eggert@cs.ucla.edu>

	grep: forward port to PCRE2 10.43
	* doc/grep.texi: Document this.
	* src/grep.c: Move recent changes into pcresearch.c.
	(P_MATCHER_INDEX): Remove.
	(pcre_pattern_expand_backslash_d): Move from here ...
	* src/pcresearch.c: ... to here.
	(PCRE2_EXTRA_ASCII_BSD): Default to 0.
	(Pcompile): Use PCRE2_EXTRA_ASCII_BSD if available,
	and expand \d to [0-9] otherwise.

	doc: distinguish Perl from PCRE
	* doc/grep.texi: Mention that PCRE might not match Perl exactly.

2023-03-18  Jim Meyering  <meyering@fb.com>

	grep: -P (--perl-regexp) \d: match only ASCII digits
	Prior to grep-3.9, the PCRE matcher had always treated \d just
	like [0-9]. grep-3.9's fix for \w and \b mistakenly relaxed \d
	to also match multibyte digits.
	* src/grep.c (P_MATCHER_INDEX): Define enum.
	(pcre_pattern_expand_backslash_d): New function.
	(main): Call it for -P.
	* NEWS (Bug fixes): Mention it.
	* doc/grep.texi: Document it: with -P, \d matches only ASCII digits.
	Provide a PCRE documentation URL and an example of how
	to use (?s) with -z.
	* tests/pcre-ascii-digits: New test.
	* tests/Makefile.am (TESTS): Add that file name.
	Reported as https://bugs.gnu.org/62267

2023-03-18  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-03-09  Jim Meyering  <meyering@fb.com>

	doc: remove mention of unused _N_GNU_nonoption_argv_flags_ envvar
	* doc/grep.texi (Environment Variables): This environment variable
	has not been usable for decades. Remove its documentation.
	* doc/grep.in.1: Likewise.
	Reported by Emanuele Torre torreemanuele6@gmail.com
	in https://bugs.gnu.org/62052
	* THANKS.in: Add the name.

2023-03-05  Jim Meyering  <meyering@meta.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.9
	* NEWS: Record release date.

	build: update gnulib to latest

2023-03-05  Bruno Haible  <bruno@clisp.org>

	tests: avoid failure on Alpine Linux 3.17, due to non-POSIX compliant tr
	* tests/fmbtest: Don't use [x*n] syntax in the tr options, since tr from
	BusyBox 1.35 does not support it.

2023-02-26  Jim Meyering  <meyering@meta.com>

	build: update gnulib to latest

2023-02-19  Jim Meyering  <meyering@fb.com>

	build: avoid --enable-gcc-warnings clang-vs-sprintf build failure
	* configure.ac (WERROR_CFLAGS): Disable -Wdeprecated-declarations
	to accommodate Apple's clang 14 that's installed as "gcc".

2023-02-04  Jim Meyering  <meyering@fb.com>

	maint: remove stray character
	* HACKING: Remove a stray "[" alone on a line.

	maint: prefer https: to git:
	The idea is to defend against some adversary-in-the-middle attacks.
	Also prefer git.savannah.gnu.org over its shorter alias, git.sv.gnu.org
	to avoid a warning e.g., from git clone.
	Also, drop any final ".git" suffix on the resulting URIs.
	Inspired by Paul Eggert's nearly identical changes to coreutils.
	Induced by running these commands:
	git grep -l 'git clone git:'|xargs perl -pi -e \
	  's{(git clone) git://(\S+)/([^/]+)\b}{$1 https://$2/git/$3}'
	git grep -l git.sv.gn \
	  |xargs perl -pi -e 's{git\.sv\.gnu}{git\.savannah\.gnu}'
	perl -pi -e \
	  's{(url =) git://(\S+)/([^/.]+)(\.git)?\b}{$1 https://$2/git/$3}'\
	  .gitmodules
	* .gitmodules: As above.
	* HACKING: Likewise.
	* README-hacking: Likewise.
	* src/grep.c (main): Likewise.

2023-01-30  Bruno Haible  <bruno@clisp.org>

	Don't require 'rsync' as a prerequisite. It is no longer needed since 2018.
	* bootstrap.conf (buildreq): Remove rsync.
	* README-prereq: Likewise.

2023-01-21  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	maint: stop including getprogname.h
	It’s obsolete in bleeding-edge Gnulib.
	* src/grep.c, tests/get-mb-cur-max.c: Don’t include getprogname.h.
	Instead, rely on stdlib.h to declare getprogname.

	build: update gnulib submodule to latest

2023-01-18  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2023-01-16  Paul Eggert  <eggert@cs.ucla.edu>

	maint: spelling fixes

2023-01-15  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix test -eq problem
	Do not use ‘test "" -eq 1’ when get-mb-cur-max fails,
	as Bash complains about this.  Problem found on AIX.

	build: update gnulib submodule to latest

	tests: port U+10000+ to AIX 7.2
	* tests/hangul-syllable, tests/surrogate-search:
	32-bit AIX has WCHAR_MAX == 0xFFFF, and so cannot handle
	U+10000 and greater.  Skip tests involving such chars
	on this platform.

	tests: update tests/init.sh
	* tests/init.sh: Update from Gnulib.

	grep: fix rawmemrchr etc. comments
	* src/grep.c: Fix comments.

2023-01-14  Paul Eggert  <eggert@cs.ucla.edu>

	tests: omit duplicate tests
	* tests/skip-read: Omit duplicates.  Reported by Bruno Haible in:
	https://lists.gnu.org/r/grep-devel/2023-01/msg00003.html

	build: update gnulib submodule to latest

2023-01-12  Paul Eggert  <eggert@cs.ucla.edu>

	tests: better diagnostic for -P sans Unicode
	* tests/init.cfg (require_pcre_): When in a UTF-8 locale, test
	also for Unicode support so that it can be diagnosed differently
	(Bug#60708).

	grep: diagnose no UTF-8 support (Bug#60708)
	* src/pcresearch.c (Pcompile): Issue a diagnostic and exit instead
	of misbehaving if libpcre2 does not support the requested locale.

2023-01-11  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	pcre: use UTF only when available in the library
	Before this change, if linked with a PCRE library without unicode
	any invocations of grep when using a UTF locale will error with:

	  grep: this version of PCRE2 does not have Unicode support

	* src/pcresearch.c: Check whether Unicode was compiled in.
	* tests/pcre-utf8-w: Add check to skip test.
	* tests/pcre-utf8: Update check.

2023-01-07  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	pcre: use UCP in UTF mode
	This fixes a serious bug affecting word-boundary and word-constituent regular
	expressions when the desired match involves non-ASCII UTF8 characters.
	* src/pcresearch.c: Set PCRE2_UCP together with PCRE2_UTF
	* tests/pcre-utf8-w: New file.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Mention this.
	* THANKS.in: Add Gro-Tsen and Karl Petterson.
	Reported by Gro-Tsen https://twitter.com/gro_tsen/status/1610972356972875777
	via Karl Pettersson in https://github.com/PCRE2Project/pcre2/issues/185
	This bug was present from grep-2.5, when --perl-regexp (-P) support was added.

2023-01-01  Jim Meyering  <meyering@fb.com>

	maint: update copyright dates

	build: update gnulib to latest

	maint: avoid warnings about unportable grep -q
	* cfg.mk (local-checks-to-skip): This is grep itself,
	so using grep -q is not a problem here, as long as it
	is running the just-built grep.

2022-12-10  Jim Meyering  <meyering@fb.com>

	maint: src/dfasearch.c: remove unnecessary re_set_syntax call
	* src/dfasearch.c (GEAcompile): Don't call "re_set_syntax (syntax_bits)"
	just before regex_compile; that function does the same thing already.

2022-12-05  Paul Eggert  <eggert@cs.ucla.edu>

	grep: bug: backref in last of multiple patterns
	* NEWS: Mention this.
	* src/dfasearch.c (GEAcompile): Trim trailing newline from
	the last pattern, even if it has back-references and follows
	a pattern that lacks back-references.
	* tests/backref: Add test for this bug.

2022-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	maint: prefer stdckdint.h to intprops.h
	Prefer the standard C23 ckd_* macros to Gnulib’s *_WRAPV macros.
	* bootstrap.conf (gnulib_modules): Add stdckdint.
	* src/grep.c, src/kwset.c, src/pcresearch.c:
	Include stdckdint.h, and prefer ckd_* to *_WRAPV.
	Include intprops.h only if needed.

	maint: add missing include
	* src/pcresearch.c: Include intprops.h.

	maint: prefer C23 style for static_assert
	* bootstrap.conf (gnulib_modules): Add assert-h,
	for static_assert.
	* src/dfasearch.c (regex_compile): Prefer static_assert to verify.

	build: update gnulib submodule to latest

2022-09-10  Paul Eggert  <eggert@cs.ucla.edu>

	Assume C23-like bool
	Gnulib’s stdbool module now provides C23-like semantics,
	so there’s no longer any need to include stdbool.h.
	* src/die.h, src/grep.h, src/kwset.h: Don’t include stdbool.h.

	build: update gnulib submodule to latest

2022-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve GREP_COLORS doc (Bug#57696)

2022-09-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix obsolescence doc for egrep, fgrep

2022-09-02  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.8
	* NEWS: Record release date.

2022-07-10  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

2022-07-09  Jim Meyering  <meyering@fb.com>

	tests: long-pattern-perf: avoid FP failure on unusual systems
	* tests/long-pattern-perf: Skip this test whenever the base
	case takes more than 800ms.  See comment for details.
	Reported by Bruno Haible in
	https://lists.gnu.org/r/grep-devel/2022-07/msg00004.html
	https://lists.gnu.org/r/grep-devel/2022-07/msg00006.html

2022-07-03  Jim Meyering  <meyering@fb.com>

	tests: long-pattern-perf: better handle exhausted virtual memory
	* tests/long-pattern-perf: Don't fail due to a syntax error
	when one of the subtests exhausts virtual memory. The larger
	test (with a 2MiB regexp) needs about 870MiB of virtual memory.
	Require that each timing run exit with status 0, else fail with
	a framework_failure_. Reported by Bruno Haible in
	https://lists.gnu.org/r/grep-devel/2022-07/msg00006.html

	tests: note that triple-backref is still not fixed
	* tests/triple-backref: I noticed that our sole XFAIL is still
	required, in spite of a glibc comment that bug 11053 is fixed,
	so confirmed that it no longer evokes an abort, but still fails
	to produce the expected match.  I.e., this prints nothing:
	echo a | grep -E '(.?)(.?)(.?)\3\2\1' -- it should print its input.

	tests: do not emit ratio of test durations
	* tests/hash-collision-perf (ratio): Remove stray diagnostic.

2022-06-30  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	maint: remove reference to gnulib module, alloca
	* bootstrap.conf (gnulib_modules): Remove alloca; we do not
	use it directly.

2022-06-29  Jim Meyering  <meyering@fb.com>

	build: add parentheses to placate clang-14
	* src/dfasearch.c (regex_compile): Parenthesize to avoid
	this warning:
	  dfasearch.c:154:43: error: operator '?:' has lower precedence
	  than '|'; '|' will be evaluated first
	  [-Werror,-Wbitwise-conditional-parentheses]

2022-06-24  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix regex compilation memory leaks
	Problem reported by Jim Meyering in:
	https://lists.gnu.org/r/grep-devel/2022-06/msg00012.html
	* src/dfasearch.c (regex_compile): Fix memory leaks when SYNTAX_ONLY.

2022-06-08  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	maint: stop using obsolete iswctype gnulib module
	* bootstrap.conf (gnulib_modules): Remove iswctype, an unused and obsolete module.

2022-06-06  Paul Eggert  <eggert@cs.ucla.edu>

	grep: don’t diagnose "grep '\-c'"
	* src/grep.c (main): Skip past leading backslash of a pattern that
	begins with "\-".  Inspired by a remark by Bruno Haible in:
	https://lists.gnu.org/r/bug-gnulib/2022-06/msg00022.html

2022-06-04  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document \] and \}
	* doc/grep.texi (Special Backslash Expressions)
	(Problematic Expressions): Document that grep supports
	\] and \} as extensions to POSIX.

	build: update gnulib submodule to latest

2022-06-03  Paul Eggert  <eggert@cs.ucla.edu>

	build: update bootstrap to gnulib latest

	build: update gnulib submodule to latest

	maint: spelling fixes

2022-05-31  Paul Eggert  <eggert@cs.ucla.edu>

	grep: sanity-check GREP_COLOR
	This patch closes a longstanding security issue with GREP_COLOR that I
	just noticed, where if the attacker has control over GREP_COLOR's
	settings the attacker can trash the victim's terminal or have 'grep'
	generate misleading output.  For example, without the patch
	the shell command:
	GREP_COLOR="$(printf '31m\33[2J\33[31')" grep --color=always PATTERN
	mucks with the screen, leaving behind only the trailing part of
	the last matching line.  With the patch, this GREP_COLOR is ignored.
	* src/grep.c (main): Sanity-check GREP_COLOR contents the same way
	GREP_COLORS values are checked, to not trash the user's terminal.
	This follows up the recent fix to Bug#55641.

2022-05-29  Jim Meyering  <meyering@fb.com>

	tests: placate syntax-check's sorted-test rule
	* tests/Makefile.am (TESTS): Insert color-colors in sorted order.

	maint: include fdl.texi in version control, per gnulib module advice
	* bootstrap.conf (gnulib_modules): Remove fdl.
	* doc/.gitignore: Do not list fdl.texi
	* doc/fdl.texi: New file.
	* cfg.mk (FILTER_LONG_LINES): Add doc/fdl.texi.

	maint: po/POTFILES.in: add src/dfasearch.c to avoid syntax-check failure
	* po/POTFILES.in: Add src/dfasearch.c.

	build: sync init.sh from gnulib

2022-05-29  Paul Eggert  <eggert@cs.ucla.edu>

	grep: document --color[=WHEN] more carefully

	tests: new test color-colors
	* tests/Makefile.am (TESTS): Add it.
	* tests/color-colors: New file.

	grep: deprecate GREP_COLOR
	This is to avoid confusion such as that reported by Cholden in:
	https://bugs.gnu.org/55641
	* src/grep.c (main): Warn if GREP_COLOR has an effect.

2022-05-24  Paul Eggert  <eggert@cs.ucla.edu>

	maint: fix typo in bug number

	grep: warn about ‘(+x)’ etc.
	These expressions are not portable and don’t always work as
	expected, so warn about them.  For example, “grep -E '(+)'”
	doesn’t act like “grep '\(\+\)'”.
	* src/dfasearch.c (GEAcompile): Warn about a repetition op at the
	start of a regular expression or subexpression, except for ‘*’ in
	BREs which is portable.

	build: update gnulib submodule to latest

2022-05-23  Paul Eggert  <eggert@cs.ucla.edu>

	grep: warn about stray backslashes
	This papers over a problem reported by Benno Schulenberg and
	Tomasz Dziendzielski <https://bugs.gnu.org/39678> involving
	regular expressions like \a that have unspecified behavior.
	* src/dfasearch.c (dfawarn): Just output a warning.
	Don’t exit, as DFA_CONFUSING_BRACKETS_ERROR now
	does that for us, and we need the ability to warn
	without exiting to diagnose \a etc.
	(GEAcompile): Use new dfa options DFA_CONFUSING_BRACKETS_ERROR and
	DFA_STRAY_BACKSLASH_WARN.

	build: update gnulib submodule to latest

2022-05-22  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document regex corner cases better
	* doc/grep.texi (Environment Variables)
	(Fundamental Structure, Character Classes and Bracket Expressions)
	(Special Backslash Expressions, Back-references and Subexpressions)
	(Basic vs Extended): Say more precisely what happens with
	problematic regular expressions.
	(Problematic Expressions): New section.

2022-05-21  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port to platforms lacking Perl
	* tests/init.cfg (require_perl_): New function.
	* tests/big-hole, tests/hash-collision-perf, tests/long-pattern-perf:
	* tests/many-regex-performance, tests/mb-non-UTF8-performance:
	Use it.

	build: be more careful about Perl
	Problem reported by Serge Belyshev for Coreutils (Bug#52844).
	I observed the same problem with current Grep on Fedora 35
	without Perl installed.
	* configure.ac (HAVE_PERL): Rely on latest Gnulib gl_PERL, which
	sets gl_cv_prog_perl.

	doc: document regex corner cases better
	* doc/grep.texi (Environment Variables)
	(Fundamental Structure, Character Classes and Bracket Expressions)
	(The Backslash Character and Special Expressions)
	(Back-references and Subexpressions, Basic vs Extended)
	(Basic vs Extended): Say more precisely what happens with oddball
	regular expressions.

	grep: assume POSIX.1-2017 for [:space:]
	* src/dfasearch.c (dfawarn): Always call dfaerror now,
	regardless of POSIXLY_CORRECT.
	* tests/warn-char-classes: Omit test of POSIX.1-2008 behavior,
	since POSIX.1-2017 allows the GNU behavior.

	tests: make spencer1.tests more POSIX-compliant
	* tests/spencer1.tests: Do not test the regular expression a\x as
	POSIX says the interpretation of \x is undefined and we may want
	to warn about it in the future, to allow for future extensions.
	Instead, test a\\x, a[\]x, and ax.

2022-05-19  Paul Eggert  <eggert@cs.ucla.edu>

	doc: omit -y from grep man page
	The obsolete -y option has been omitted from --help for a while, and
	now’s a good time to omit it from the man page too.

2022-05-17  Paul Eggert  <eggert@cs.ucla.edu>

	tests: improve tests of ‘.’
	* tests/hangul-syllable: Test some encoding errors too.

2022-05-16  Paul Eggert  <eggert@cs.ucla.edu>

	grep: document -m better
	* doc/grep.in.1, doc/grep.texi: Document behavior of -m 0 and -m -1.
	This documents longstanding behavior, and is consistent with
	how git grep -m will likely behave.

2022-05-14  Paul Eggert  <eggert@cs.ucla.edu>

	maint: spelling fixes

2022-05-13  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix bug with . and some Hangul Syllables
	* NEWS: Mention the fix, which comes from the recent Gnulib update.
	* tests/hangul-syllable: New file.
	* tests/Makefile.am (TESTS): Add it.

	build: update gnulib submodule to latest

2022-04-02  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest, for glob improvements

2022-03-22  Paul Eggert  <eggert@cs.ucla.edu>

	grep: Remove recent PCRE2 bug workarounds
	* src/pcresearch.c (Pcompile): Remove recent workaround for PCRE2
	bugs; apparently it’s not needed.  This reverts back to where
	things were before today.  Suggested by Carlo Arenas in:
	https://lists.gnu.org/r/grep-devel/2022-03/msg00006.html

	grep: work around another potential PCRE2 bug
	Potential problem reported by René Scharfe in:
	https://lore.kernel.org/git/99b0adb6-26ba-293c-3a8f-679f59e7cb4d@web.de/T
	* src/pcresearch.c (Pcompile): Mimic git grep’s workarounds
	for PCRE2 bugs more closely; this is more conservative.

	grep: work around PCRE2 bug 2642
	Problem reported by Carlo Arenas in:
	https://lists.gnu.org/r/grep-devel/2022-03/msg00004.html
	* src/pcresearch.c (Pcompile) [PCRE2_MATCH_INVALID_UTF]:
	In PCRE2 10.35 and earlier, disable start optimization if doing a
	caseless UTF-8 search.

	Pacify GCC 11.2.0
	* configure.ac: Re-disable -Wstack-protector, to pacify GCC Ubuntu
	11.2.0-7ubuntu2 x86-64 on knuth_morris_pratt and
	knuth_morris_pratt_multibyte.

2022-03-20  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest, for bootstrap long-line fix

	build: Re-disable -Winline
	* configure.ac: Re-disable -Winline. It is still needed.

	build: update gnulib to latest; also bootstrap and init.sh

	build: avoid build failure on systems that must compile regexec.c
	With --enable-gcc-warnings, compiling regexec.h would fail due to
	its use of a single variable-length array.
	* configure.ac: Add -Wvla to the list of disabled warnings and
	remove most of the others, that no longer need to be disabled.

	grep: very long lines no longer evoke unwarranted "memory exhausted"
	When calling xpalloc (NULL, &n, incr_min, alloc_max, 1) with
	nontrivial ALLOC_MAX, this must hold: N + INCR_MIN <= ALLOC_MAX.
	With a very long line, it did not, and grep would mistakenly fail
	with a report of "memory exhausted".
	* src/grep.c (fillbuf): When using nontrivial ALLOC_MAX, ensure it
	is at least N+INCR_MIN.
	* tests/fillbuf-long-line: New file, to test for this.
	* tests/Makefile.am (TESTS): Add its name.

2022-02-27  Paul Eggert  <eggert@cs.ucla.edu>

	doc: more on leading ‘-’
	* doc/grep.texi (Usage): Expand on leading ‘-’ problems (Bug#54174).

2022-02-24  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention issues with set -e
	* doc/grep.texi (Usage, Performance): Mention early exits (Bug#54035).

2022-02-15  Ulrich Eckhardt  <ulrich.eckhardt@base-42.de>  (tiny change)

	grep: Remove comment
	The comment was introduced in 500f07fee50ab16a70fe2946b85318020c7f4017 and
	relates to absent cleanup code at the end of main(), not the code following
	it. It relates to fallible flushing of stdout and related error handling,
	but even then it doesn't explain much.

2022-02-15  Ulrich Eckhardt  <ulrich.eckhardt@base-42.de>

	tests: remove redundant test
	* tests/empty: Test #4 is identical to test #1. Remove it.

2022-01-02  Ondřej Fiala  <temp.xanomes@volny.cz>  (tiny change)

	bug#52958: [PATCH] doc: fix man page syntax errors
	* doc/grep.in.1: Fix syntax errors.
	Introduced by commit v3.6-5-g91ce9cd.

2022-01-01  Jim Meyering  <meyering@fb.com>

	maint: make update-copyright

	build: update gnulib to latest; also bootstrap and init.sh

2021-12-26  Jim Meyering  <meyering@fb.com>

	build: disable some expensive compiler warnings by default
	* configure.ac (gl_GCC_VERSION_IFELSE): Copy from coreutils.
	(gcc-warnings): Update from coreutils.

2021-12-24  Jim Meyering  <meyering@fb.com>

	maint: avoid new syntax-check failures
	* cfg.mk (local-checks-to-skip): Add sc_indent, to skip it.
	Otherwise, "make syntax-check" would fail.
	(_gl_TS_unmarked_extern_functions): Add imbrlen to the list.

2021-12-20  Helge Kreutzmann  <debian@helgefjell.de>

	doc: --invert-match is described "above" --count, not below
	* doc/grep.in.1 (--count): s/below/above/.

2021-11-24  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2021-11-23  Paul Eggert  <eggert@cs.ucla.edu>

	tests: skip surrogate-search test on Cygwin
	Cygwin does not support surrogate-pair search strings, so
	skip the test there (Bug#27555).
	* tests/Makefile.am (TESTS): Add surrogate-search.
	* tests/surrogate-pair: Remove surrogate-search test,
	which is now done by surrogate-search.
	* tests/surrogate-search: New test, which is skipped on Cygwin.

2021-11-22  Paul Eggert  <eggert@cs.ucla.edu>

	doc: update to match recent "Binary files" change
	Suggested by Duncan Roe (Bug#51860#25).

2021-11-20  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -s does not suppress “binary file matches”
	* src/grep.c (grep): Implement this.
	* tests/binary-file-matches: Add regression test.

	doc: "binary file matches" -> stderr [Bug#51860]

2021-11-14  Paul Eggert  <eggert@cs.ucla.edu>

	grep: port to PCRE2 10.20
	* src/pcresearch.c (PCRE2_SIZE_MAX): Default to SIZE_MAX.

	grep: fix minor -P memory leak
	* src/pcresearch.c (Pcompile): Free ccontext when no longer needed.

	grep: use ximalloc, not xcalloc
	* src/pcresearch.c (Pcompile): Use ximalloc, not xcalloc,
	and explicitly initialize the two slots that should be null.
	This is more likely to catch future errors if we use valgrind.

	grep: improve memory exhaustion checking with -P
	* src/pcresearch.c (struct pcre_comp): New member gcontext.
	(private_malloc, private_free): New functions.
	(jit_exec): It is OK to call pcre2_jit_stack_free (NULL), so simplify.
	Use gcontext for allocation.  Check for pcre2_jit_stack_create
	failure, since sljit bypasses private_malloc.  Redo to avoid two
	‘continue’s.
	(Pcompile): Create and use gcontext.

	grep: simplify JIT setup
	* src/pcresearch.c (Pcompile): Simplify since ‘die’ cannot return.

	grep: use PCRE2_EXTRA_MATCH_LINE
	* src/pcresearch.c (Pcompile): If available, use
	PCRE2_EXTRA_MATCH_LINE instead of doing it by hand.
	Simplify construction of substitute regular expression.

	grep: prefer signed integers
	* src/pcresearch.c (struct pcre_comp, jit_exec, Pexecute):
	Prefer signed to unsigned types when either will do.
	(jit_exec): Use INT_MULTIPLY_WRAPV instead of doing it by hand.
	(Pexecute): Omit line length limit test that is no longer
	needed with PCRE2.

	grep: speed up, fix bad-UTF8 check with -P
	* src/pcresearch.c (bad_utf8_from_pcre2): New function.  Fix bug
	where PCRE2_ERROR_UTF8_ERR1 was not treated as an encoding error.
	Improve performance when PCRE2_MATCH_INVALID_UTF is defined.
	(Pexecute): Use it.

	grep: improve pcre2_get_error_message comments
	* src/pcresearch.c (Pcompile): Improve comments re
	pcre2_get_error_message buffer.

	grep: Don’t limit jitstack_max to INT_MAX
	* src/pcresearch.c (jit_exec): Remove arbitrary INT_MAX limit on JIT
	stack size.

	maint: minor rewording and reindenting

2021-11-14  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	grep: migrate to pcre2
	Mostly a bug by bug translation of the original code to the PCRE2 API.
	Code still could do with some optimizations but should be good as a
	starting point.

	The API changes the sign of some types and therefore some ugly casts
	were needed, some of the changes are just to make sure all variables
	fit into the newer types better.

	Includes backward compatibility and could be made to build all the way
	to 10.00, but assumes a recent enough version and has been tested with
	10.23 (from CentOS 7, the oldest).

	Performance seems equivalent, and it also seems functionally complete.

	* m4/pcre.m4 (gl_FUNC_PCRE): Check for PCRE2, not the original PCRE.
	* src/pcresearch.c (struct pcre_comp, jit_exec)
	(Pcompile, Pexecute):
	Use PCRE2, not the original PCRE.
	* tests/filename-lineno.pl: Adjust to match PCRE2 diagnostics.

2021-11-11  Paul Eggert  <eggert@cs.ucla.edu>

	maint: update README-prereq for Gperf, Rsync, Wget

2021-11-10  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix pcre test typo
	* tests/pcre-context: Initialize ‘fail’ earlier.

2021-11-10  Carlo Marcelo Arenas Belón  <carenas@gmail.com>

	tests: fix test logic for pcre-context
	Included in the original bug #20957, but corrupted somehow in
	transit as the required NUL characters are missing.

	Add a simpler version of the test case that uses plain characters
	and match the -z data and output to show the equivalence.

	Note the output is still not correct as it is missing the expected
	LF characters, but a full fix will have to wait until PCRE2.

	Fixes Bug#51735.

2021-11-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: work around PCRE bug
	Problem reported by Carlo Marcelo Arenas Belón (Bug#51710).
	* src/pcresearch.c (jit_exec): Don’t attempt to grow the JIT stack
	over INT_MAX - 8 * 1024.

	build: update gnulib submodule to latest

2021-10-30  Paul Eggert  <eggert@cs.ucla.edu>

	maint: modernize README-{hacking,prereq}

2021-10-28  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2021-08-27  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document interval expression limitations
	* doc/grep.texi (Basic vs Extended, Performance):
	Document limitations of interval expressions (Bug#44538).

	build: update gnulib submodule to latest
	* src/system.h: Update decls to match current Gnulib.

2021-08-25  Paul Eggert  <eggert@cs.ucla.edu>

	grep: prefer signed to unsigned integers
	This improves runtime checking for integer overflow when compiling
	with gcc -fsanitize=undefined and the like.  It also avoids
	the need for some integer casts, which can be error-prone.
	* bootstrap.conf (gnulib_modules): Add idx.
	* src/dfasearch.c (struct dfa_comp, kwsmusts):
	(possible_backrefs_in_pattern, regex_compile, GEAcompile)
	(EGexecute):
	* src/grep.c (struct patloc, patlocs_allocated, patlocs_used)
	(n_patterns, update_patterns, pattern_file_name, poison_len)
	(asan_poison, fwrite_errno, compile_fp_t, execute_fp_t)
	(buf_has_encoding_errors, buf_has_nulls, file_must_have_nulls)
	(bufalloc, pagesize, all_zeros, fillbuf, nlscan)
	(print_line_head, print_line_middle, print_line_tail, grepbuf)
	(grep, contains_encoding_error, fgrep_icase_available)
	(fgrep_icase_charlen, fgrep_to_grep_pattern, try_fgrep_pattern)
	(main):
	* src/kwsearch.c (struct kwsearch, Fcompile, Fexecute):
	* src/kwset.c (struct trie, struct kwset, kwsalloc, kwsincr)
	(kwswords, treefails, memchr_kwset, acexec_trans, kwsexec)
	(treedelta, kwsprep, bm_delta2_search, bmexec_trans, bmexec)
	(acexec):
	* src/kwset.h (struct kwsmatch):
	* src/pcresearch.c (Pcompile, Pexecute):
	* src/search.h (mb_clen):
	* src/searchutils.c (kwsinit, mb_goback, wordchars_count)
	(wordchars_size, wordchar_next, wordchar_prev):
	Prefer idx_t to size_t or ptrdiff_t for nonnegative sizes,
	and prefer ptrdiff_t to size_t for sizes plus error values.
	* src/grep.c (uword_size): New constant, used for signed
	size calculations.
	(totalnl, add_count, totalcc, print_offset, print_line_head, grep):
	Prefer intmax_t to uintmax_t for wide integer calculations.
	(fgrep_icase_charlen): Prefer ptrdiff_t to int for size offsets.
	* src/grep.h: Include idx.h.
	* src/search.h (imbrlen): New function, like mbrlen except
	with idx_t and ptrdiff_t.

2021-08-24  Paul Eggert  <eggert@cs.ucla.edu>

	grep: scan back thru UTF-8 a bit faster
	* src/searchutils.c (mb_goback): When scanning backward through
	UTF-8, check the length implied by the putative byte 1 before
	bothering to invoke mb_clen.  This length check also lets us use
	mbrlen directly rather than calling mb_clen, which would
	eventually defer to mbrlen anyway.

	grep: tweak mb_goback performance
	* src/searchutils.c (mb_goback): Set *MBCLEN only in
	non-UTF-8 encodings, since that’s the only time it’s needed,
	and this lets us see more clearly that the UTF-8 clen value
	is not useful to the caller.

	grep: tweak wordchar_prev performance
	* src/searchutils.c (wordchar_prev): Tweak performance by using a
	value already in a local variable rather than consulting a table.

	grep: tweak mb_goback and comment it better
	* src/searchutils.c (mb_goback): Improve the comment to better
	describe this confusing function.  And remove an unnecessary
	test of cur vs end.

	grep: omit unused maxd member
	* src/kwset.c (struct kwset.maxd): Remove.  All uses removed.

	grep: avoid some size_t casts
	This helps move the code away from unsigned types.
	* src/grep.c (buf_has_encoding_errors, contains_encoding_error):
	* src/searchutils.c (mb_goback):
	Compare to MB_LEN_MAX, not to (size_t) -2.  This is a bit safer
	anyway, as grep relies on MB_LEN_MAX limits elsewhere.
	* src/search.h (mb_clen): Compare to -2 before converting to size_t.

2021-08-22  Jim Meyering  <meyering@fb.com>

	tests: mb-non-UTF8-perf-Fw: use head rather than sed
	* tests/mb-non-UTF8-perf-Fw: Use head -n 10000000 rather than the
	work-alike sed command.  This provides a 4x speedup and saves 0.5s.
	* tests/null-byte: Likewise.

2021-08-21  Paul Eggert  <eggert@cs.ucla.edu>

	grep: avoid sticky problem with ‘-f - -f -’
	Inspired by bug#50129 even though this is a different bug.
	* src/grep.c (main): For ‘-f -’, use clearerr (stdin) after
	reading, so that ‘grep -f - -f -’ reads stdin twice even
	when stdin is a tty.  Also, for ‘-f FILE’, report any
	I/O error when closing FILE.

2021-08-18  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port mb-non-UTF8-perf-Fw to strict POSIX
	* tests/mb-non-UTF8-perf-Fw: Prefer ‘sed 10q’ to ‘head -10’,
	which doesn’t conform to POSIX.

	grep: djb2 correction
	Problem reported by Alex Murray (bug#50093).
	* src/grep.c (hash_pattern): Use a nonzero initial value.

2021-08-16  Paul Eggert  <eggert@cs.ucla.edu>

	doc: modernize portability advice
	* doc/grep.texi (General Output Control, Basic vs Extended):
	No need to complicate the portability advice by talking about 7th
	edition grep, since it’s no longer a practical porting target.
	Instead, mention only Solaris 10 grep, the last practical holdout
	of somewhat-traditional grep.

	egrep, fgrep: now obsolete
	* NEWS: Mention this (see bug#49996).
	* doc/Makefile.am (egrep.1 fgrep.1): Remove.  All uses removed.
	* doc/grep.in.1, doc/grep.texi (grep Programs):
	Remove documentation for egrep, fgrep.
	* doc/grep.texi (Usage): Add FAQ for egrep and fgrep.
	* src/Makefile.am (shell_does_substrings): Substitute for ${0##*/},
	not for ${0%/\*} (which was not being used anyway).
	* src/egrep.sh: Issue an obsolescence warning.
	* tests/fedora: Use "grep -F" instead of "fgrep" in diagnostics,
	as this tests "grep -F" not "fgrep".

2021-08-14  Paul Eggert  <eggert@cs.ucla.edu>

	doc: update cites and authors

2021-08-14  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.7
	* NEWS: Record release date.

2021-08-09  Jim Meyering  <meyering@fb.com>

	tests: provide an awk-based seq replacement
	...so we can continue to use seq, but the wrapper when needed.
	* tests/init.cfg (seq): Some systems lask seq.
	Provide a replacement.
	* tests/hash-collision-perf: Use seq once again.
	* tests/long-pattern-perf: Likewise. And remove a comment about seq.

2021-08-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: simplify EGexecute
	* src/dfasearch.c (EGexecute): Remove a label and goto.
	This also makes the machine code a bit shorter, on x86-64 gcc.

	grep: simplify data movement slightly
	* src/grep.c (fillbuf): Simplify movement of saved data.

	grep: pointer-integer cast nit
	* src/grep.c (ALIGN_TO): When converting pointers to unsigned
	integers, convert to uintptr_t not size_t, as size_t in theory
	might be too narrow.

	tests: use awk, not seq
	Portability problem reported by Dagobert Michelsen in:
	https://lists.gnu.org/r/grep-devel/2021-08/msg00004.html
	* tests/hash-collision-perf, tests/long-pattern-perf:
	Don’t assume seq is installed; use awk instead.

2021-08-08  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	build: update gnulib to latest

2021-08-06  Kevin Locke  <kevin@kevinlocke.name>

	doc: usage: --group-separator/--no-group-separator
	* src/grep.c (usage): Document --group-separator
	and --no-group-separator.

	doc: man: add --group-separator/--no-group-separator
	* doc/grep.in.1:
	Add copy of docs for --group-separator from doc/grep.texi.
	Add copy of docs for --no-group-separator from doc/grep.texi.

2021-08-06  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

2021-06-19  Mateusz Okulus  <mmokulus@gmail.com>

	doc: note that -H is a GNU extension in man page, too
	* doc/grep.in.1 (-H): Mention that this is a GNU extension.

2021-06-13  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2021-06-11  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2021-06-10  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve examples and wording
	* doc/grep.texi (The Backslash Character and Special Expressions)
	(Usage): Improve doc (Bug#48948).

2021-01-31  Jim Meyering  <meyering@fb.com>

	doc: man: fix -L description and improve -l's
	* doc/grep.texi (-L): Remove erroneous sentence about stopping early.
	With -L, grep cannot stop scanning early.
	(-l): Tweak existing wording.
	* doc/grep.in.1: Remove the -L sentence here, too.
	(-l): Copy the sentence from grep.texi, to clarify: it's only per-file
	scanning that stops upon match.  Reported by Robert Bruntz
	in http://debbugs.gnu.org/46179

2021-01-05  Jim Meyering  <meyering@fb.com>

	build: avoid long-string warnings in gnulib tests
	* configure.ac (GNULIB_TEST_WARN_CFLAGS): Add
	-Woverlength-strings to avoid clang warnings.

2021-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	doc: further clarify regexp structure
	* doc/grep.texi (Fundamental Structure)
	(Back-references and Subexpressions, Basic vs Extended):
	Further clarifications.

	maint: copy bootstrap, tests/init.sh from Gnulib

	doc: update grep.texi cite to 2021

	maint: run "make update-copyright"

	build: update gnulib submodule to latest

2020-12-30  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest
	* gnulib: update for clang-10 warning warning-avoidance
	fixes in hash and regex-tests.

	maint: add parentheses to avoid new clang-10 warning
	* src/dfasearch.c (regex_compile): Parenthesize arith-OR vs
	ternary, to placate clang-10.

2020-12-29  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify special chars and }
	* doc/grep.texi (Fundamental Structure)
	(Character Classes and Bracket Expressions)
	(The Backslash Character and Special Expressions, Anchoring)
	(Basic vs Extended): Clarify which characters are special,
	and why \ is needed before } in grep even though } is not special.
	Use Posix terminology for ordinary and special characters and for
	interval expressions.

2020-12-29  Marek Suppa  <mr@shu.io>

	doc: fix missing right curly brace
	* doc/grep.texi (Basic vs Extended Regular Expressions): Mention that
	the right curly brace (}) meta-character must be backslash-escaped.
	It had been omitted from the list.

2020-12-25  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	grep: use of --unix-byte-offsets (-u) now elicits a warning
	* NEWS (Change in behavior): Mention this.
	* src/grep.c (main): Warn about each use of obsolete
	--unix-byte-offsets (-u).
	* doc/grep.in.1 (-u): Remove its documentation.

2020-12-23  Helge Kreutzmann  <debian@helgefjell.de>

	doc: adjust man page syntax
	* doc/grep.in.1: Mark some manual names with B<...>.
	Mark PATTERNS with I<...>.
	Drop final period in SEE ALSO.
	With suggestions from of several members of the manpage-l10n
	translation community.  This resolves https://bugs.gnu.org/45353

2020-11-26  Jim Meyering  <meyering@fb.com>

	grep: avoid performance regression with many patterns
	* src/grep.c (hash_pattern): Switch from PJW to DJB2, to avoid an
	O(N) to O(N^2) performance regression due to hash collisions with
	patterns from e.g., seq 500000|tr 0-9 A-J
	Reported by Frank Heckenbach in https://bugs.gnu.org/44754
	* NEWS (Bug fixes): Mention it.
	* tests/hash-collision-perf: New file.
	* tests/Makefile.am (TESTS): Add it.

	build: update gnulib to latest for warning fixes
	* gnulib: Update submodule to latest.
	* src/grep.c (printf_errno): Reflect gnulib's renaming: change
	_GL_ATTRIBUTE_FORMAT_PRINTF to
	_GL_ATTRIBUTE_FORMAT_PRINTF_STANDARD

	tests: enable warnings for the gnulib-tests subdir
	* gnulib-tests/Makefile.am (AM_CFLAGS): Enable gnulib
	warning options for these tests.
	* configure.ac (GNULIB_TEST_WARN_CFLAGS): Disable the same three
	warning options that coreutils does, and a few more for GCC11.

2020-11-08  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.6
	* NEWS: Record release date.

2020-11-05  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest for test improvements

2020-11-03  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest for C++-ready dfa.h and test-verify.c fix

2020-11-03  Paul Eggert  <eggert@cs.ucla.edu>

	grep: remove GREP_OPTIONS
	* NEWS: Mention this.
	* doc/grep.in.1:
	Remove GREP_OPTIONS documentation.
	* doc/grep.texi (Environment Variables):
	Move GREP_OPTIONS stuff into a “no longer implemented” paragraph.
	* src/grep.c (prepend_args, prepend_default_options): Remove.
	(main): Do not look at GREP_OPTIONS.
	* tests/Makefile.am (TESTS_ENVIRONMENTS):
	* tests/init.cfg (vars_): Remove GREP_OPTIONS.

2020-11-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: use RE_NO_SUB when calling regex solely to check syntax
	* src/dfasearch.c (regex_compile): New parameter. All callers changed.
	(GEAcompile): Move setting syntax for regex into regex_compile()
	function.  This addresses a performance problem exposed by extreme
	regular expressions, as described in https://bugs.gnu.org/43862 .

	tests: add the test for bugfix in gnulib's dfa
	* tests/ere.tests: Add new test.

2020-11-01  Jim Meyering  <meyering@fb.com>

	grep: avoid erroneous matches for e.g., a+a+a+
	* gnulib: Update to latest, for dfa's invalid-merge fix.
	* NEWS (Bug fixes): Mention this.

2020-10-11  Jim Meyering  <meyering@fb.com>

	grep: -P: report input filename upon PCRE execution failure
	Without this, it could be tedious to determine which input
	file evokes a PCRE-execution-time failure.
	* src/pcresearch.c (Pexecute): When failing, include the
	error-provoking file name in the diagnostic.
	* src/grep.c (input_filename): Make extern, since used above.
	* src/search.h (input_filename): Declare.
	* tests/filename-lineno.pl: Test for this.
	($no_pcre): Factor out.
	* NEWS (Bug fixes): Mention this.

2020-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor kwset cleanups
	* src/kwsearch.c (Fexecute):
	Assume C99 to put declarations nearer uses.
	* src/kwset.c (bmexec): Omit unnecessary test.
	* src/kwset.h (struct kwsmatch): Make OFFSET and SIZE individual
	elements, not arrays of size 1 (a revenant of an earlier API).
	All uses changed.

2020-10-11  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: remove unused code
	* src/kwsearch.c (Fcompile, Fexecute): Remove unused code.  No longer these
	are used after commit 016e590a8198009bce0e1078f6d4c7e037e2df3c.

2020-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2020-10-05  Jim Meyering  <meyering@fb.com>

	tests: correct filename-lineno.pl
	* tests/filename-lineno.pl: Remove a stray envvar
	that somehow slipped into expected output string.

2020-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix tests when PCRE is not used
	* tests/Makefile.am (TESTS_ENVIRONMENT):
	Set PATH before setting PCRE_WORKS, so that the latter test
	uses the just-built grep.
	* tests/filename-lineno.pl (invalid-re-P-paren)
	(invalid-re-P-star-paren): Adjust non-PCRE case to match
	recently-changed behavior.

	build: update gnulib submodule to latest

2020-10-03  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document --include/--exclude better
	Problem reported by John Ruckstuhl (Bug#43782).
	* doc/grep.texi (File and Directory Selection):
	Document what happens if contradictory options are given,
	or if no option matches a file name.
	* doc/grep.in.1:

2020-10-01  Jim Meyering  <meyering@fb.com>

	maint: add technically-required quotes
	* configure.ac: Quote args of AC_CONFIG_AUX_DIR, AC_CONFIG_SRCDIR
	and AC_CHECK_FUNCS_ONCE.

2020-09-28  Jim Meyering  <meyering@fb.com>

	tests: restore deleted -P tests
	v3.4-almost-45-g8577dda deleted these two -P-using tests because a
	grep built without PCRE support would fail those tests. This sets
	an envvar with the equivalent of the result from the require_pcre_
	function and restores the now-guarded tests. Tested by running this:
	  ./configure --disable-perl-regexp && make check
	* tests/Makefile.am (PCRE_WORKS): Set this envvar.
	* tests/filename-lineno.pl: Restore invalid-re-P-paren and
	invalid-re-P-star-paren, now each with a guard.

2020-09-27  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.5
	* NEWS: Record release date.

	maint: avoid autoconf warnings * configure.ac (AC_HEADER_STDC): Remove.  It's been assumed for ages. * m4/pcre.m4 (gl_FUNC_PCRE): Use AS_HELP_STRING, not AC_HELP_STRING.

	build: update gnulib to latest

2020-09-26  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	tests: skip stack-overflow test when built with ASAN
	* tests/stack-overflow: Skip this test when the binary was built
	with ASAN, to avoid spurious failures.

2020-09-25  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	build: update gnulib submodule to latest

2020-09-24  Jim Meyering  <meyering@fb.com>

	tests: fix surrogate-pair test to work on 16-bit wchar_t systems
	* tests/surrogate-pair: Avoid new failure on systems with
	16-bit wchar_t.  Detect the condition and exit before the
	otherwise-failing tests.  Remove the now-incorrect in-loop
	test for that alternate failure mode.  This was exposed by
	testing on gcc119.fsffrance.org, a power8 AIX 7.2 system.

2020-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	grep: don't assume PCRE in tests
	* tests/filename-lineno.pl: Remove invalid-re-P-paren and
	invalid-re-P-star-paren as they assume PCRE support, which
	causes a false alarm "grep: Perl matching not supported in a
	--disable-perl-regexp build" on platforms without PCRE.

	grep: pacify Sun C 5.15
	This suppresses a false alarm '"grep.c", line 720: warning:
	initializer will be sign-extended: -1'.
	* src/grep.c (uword_max): New static constant.
	(initialize_unibyte_mask): Use it.

2020-09-23  Paul Eggert  <eggert@cs.ucla.edu>
	    Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: fix more Turkish-eyes bugs
	Fix more bugs recently uncovered by Norihiro Tanaka (Bug#43577).
	* NEWS: Mention new bug report.
	* src/grep.c (ok_fold): New static var.
	(setup_ok_fold): New function.
	(fgrep_icase_charlen): Reject single-byte characters
	if they match some multibyte characters when ignoring case.
	This part of the patch is partly derived from
	<https://bugs.gnu.org/43577#14>, which means it is:
	(main): Call setup_ok_fold if ok_fold might be needed.
	* src/searchutils.c (kwsinit): With the grep.c changes,
	this code can now revert to classic 7th Edition Unix style;
	aborting would be wrong.
	* tests/turkish-eyes: Add tests for these bugs.

2020-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest
	* NEWS: Mention Bug#43577, which this fixes.

	grep: fix recently-introduced performance glitch
	* src/grep.c (main): Do not double-increment update_patterns.
	update_patterns increments n_patterns now; do not increment it
	again, as the incorrect count would hurt performance heuristics later.

2020-09-22  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve --line-buffer doc
	* doc/grep.texi (Other Options): Document --line-buffered more
	carefully, and say what happens when it is not used.  Problem
	reported by Dan Jacobson (Bug#35339).

	tests: port timeout test to Alpine
	Problem reported by Bruno Haible in:
	https://lists.gnu.org/r/grep-devel/2020-09/msg00080.html
	* tests/init.cfg (require_timeout_): Check that ‘timeout 0.01
	sleep 0.02’ works as expected, to avoid spurious test failure
	on Alpine.

2020-09-22  Jim Meyering  <meyering@fb.com>

	tests: test for many-regexp N^2 RSS regression
	* tests/many-regex-performance: New test for this performance
	regression.
	* tests/Makefile.am: Add it.
	* NEWS (Bug fixes): Describe it.

2020-09-22  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: avoid unnecessary regex compilation
	Grep resorts to using the regex engine when the precision of either
	-o or --color is required, or when the pattern is not supported by
	our DFA engine (e.g., backref). Otherwise, grep would perform regex
	compilation solely to check the syntax. This change makes grep skip
	that compilation in the common case for which it is unnecessary.

	The compilation we are avoiding is quite costly, consuming O(N^2)
	RSS for N regular expressions.

	* src/dfasearch.c (GEAcompile): Add new argument, and avoid unneeded
	compilation of regex.
	* src/grep.c (compile_fp_t): Update prototype.
	(main): Update caller.
	* src/kwsearch.c (Fcompile): Update caller and add new argument.
	* src/pcresearch.c (Pcompile): Add new argument.
	* src/search.h (GEAcompile, Fcompile, Pcompile): Update prototype.

2020-09-22  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

	tests: skip stack-overflow test on midnightbsd*
	* tests/stack-overflow: skip_ when run on this OS. See details
	in https://lists.gnu.org/r/grep-devel/2020-09/msg00062.html
	* tests/Makefile.am (host_triplet): Export.

2020-09-21  Paul Eggert  <eggert@cs.ucla.edu>

	doc: say how to match chars by code
	From a suggestion in Bug#41004.
	* doc/grep.texi (Character Encoding, Matching Non-ASCII):
	New sections.  Move some material from Environment Variables
	into these sections.

2020-09-18  Paul Eggert  <eggert@cs.ucla.edu>

	* src/dfasearch.c (struct dfa_comp): Fix out-of-date comment.

	grep: "grep '\)'" reports an error again
	* src/grep.c (try_fgrep_pattern): With -G, pass \) through to
	GEAcompile so that it can complain.  This fixes an unexpected
	change in behavior from grep 3.4 and earlier.
	* tests/filename-lineno.pl: Add tests for this sort of thing.

	grep: tweak by using mempcpy
	* src/grep.c (try_fgrep_pattern): Tweak previous change
	by using mempcpy.

2020-09-18  Jim Meyering  <meyering@fb.com>

	grep: make echo .|grep '\.' match once again
	The same applied for many other backslash-escaped bytes, not just
	metacharacters.  The switch to rawmemchr in v3.4-almost-10-g9393b97
	made some parts of the code require the usually-guaranteed newline
	sentinel at the end of each pattern. Before, some consumers used a
	(correct) pattern length and did not care that try_fgrep_pattern could
	transform a pattern (with sentinel) like "\\.\n" to "..\n", thus
	violating that assumption.
	* src/grep.c (try_fgrep_pattern): Preserve the invariant
	that each regexp is newline-terminated.
	* tests/backslash-dot: New file. Test for this.
	* tests/Makefile.am (TESTS): Add it.

	tests: triple-backref: print a reference to glibc bug
	* tests/triple-backref (MALLOC_CHECK_): And tell glibc not to
	bother with a core dump.  Suggested by Pádraig Brady.

2020-09-18  Paul Eggert  <eggert@cs.ucla.edu>

	grep: be more consistent about diagnostic format
	* NEWS: Mention this.
	* bootstrap.conf (gnulib_modules): Remove 'quote'.
	* src/grep.c: Do not include quote.h.
	(grep, grepdirent, grepdesc): Put the three unusual diagnostics
	into the same "grep: FOO: message" form that grep uses elsewhere.
	* tests/binary-file-matches, tests/in-eq-out-infloop:
	Adjust tests to match new diagnostic format.

2020-09-17  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

2020-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/triple-backref: Add comment.

2020-09-17  Jim Meyering  <meyering@fb.com>

	tests: make new test executable, to placate distcheck
	* tests/binary-file-matches: Make this executable.

	tests: add coverage for code that emits the new diagnostic
	* tests/binary-file-matches: New file.
	* tests/Makefile.am (TESTS): Add it.

	maint: avoid syntax-check failure
	* src/grep.c (grep): Lower-case the "B" in "Binary file... matches"
	diagnostic that we now emit to stderr. This avoids the following
	when running "make syntax-check":
	  maint.mk: found capitalized error message
	  make: *** [maint.mk:469: sc_error_message_uppercase] Error 1

2020-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	Send "Binary file FOO matches" to stderr
	* NEWS, doc/grep.texi: Mention this change (Bug#29668).
	* src/grep.c (grep): Send "Binary file FOO matches" to stderr
	instead of stdout.
	* tests/encoding-error, tests/invalid-multibyte-infloop:
	* tests/null-byte, tests/pcre-count, tests/surrogate-pair:
	* tests/symlink, tests/unibyte-binary:
	Adjust tests to match new behavior.  In all cases this
	simplifies the tests, which is a good sign.

	Suppress "Binary file FOO matches" if -I
	Problem reported by Jason Franklin (Bug#33552).
	* NEWS: Mention this.
	* src/grep.c (grep): Do not output "Binary file FOO matches" if -I.
	* tests/encoding-error: Add test for this bug.

2020-09-15  Jim Meyering  <meyering@fb.com>

	maint: keep two blank lines before each old Noteworthy line.
	* NEWS: Insert a blank line.

2020-09-15  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2020-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2020-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2020-09-11  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest

2020-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix logic for growing PCRE JIT stack
	* src/pcresearch.c (jit_exec) [PCRE_EXTRA_MATCH_LIMIT_RECURSION]:
	When growing the match_limit_recursion limit, do not use the old
	value if ! (flags & PCRE_EXTRA_MATCH_LIMIT_RECURSION), as it is
	uninitialized in that case.

	grep: fix PCRE JIT test when JIT not available
	Problem reported by Thomas Deutschmann (Bug#29446#23).
	* src/pcresearch.c (Pexecute): Diagnose PCRE_ERROR_RECURSIONLIMIT.
	* tests/pcre-jitstack: Treat recursion limit overflow like stack
	overflow.

	grep: fix -w bug in UTF-8 locales
	Problem reported by Mayo Fark (Bug#43225).
	* src/searchutils.c (wordchar_prev): In a UTF-8 locale, do not
	assume that an encoding-error byte cannot be part of a word
	constituent, as this assumption is incorrect for the last byte
	of a multibyte word constituent.
	* tests/word-delim-multibyte: Add a test for the bug.

	Distribute a gzip tarball again
	Requested by Issam E. Maghni in:
	https://lists.gnu.org/r/grep-devel/2020-09/msg00000.html
	* configure.ac (AM_INIT_AUTOMAKE): Remove no-dist-gzip.

	* README-prereq: Also mention xz.

2020-09-07  Paul Eggert  <eggert@cs.ucla.edu>

	Prefer rawmemchr to memchr when it’s easy
	* bootstrap.conf (gnulib_modules): Add rawmemchr.
	* src/dfasearch.c (GEAcompile, EGexecute):
	* src/grep.c (update_patterns, prpending, prtext):
	* src/kwsearch.c (Fcompile, Fexecute):
	* src/pcresearch.c (Pcompile, Pexecute):
	Simplify (and presumably speed up a little) by using rawmemchr
	with a sentinel, instead of using memchr.

	Simplify pattern_file_name
	* src/grep.c (pattern_file_name): Make first argument
	origin-0, not origin-1, as this simplifies both caller and
	callee.  All uses changed.

	Simplify regex_compile
	* src/dfasearch.c (regex_compile): "" suffices; we don’t need "\0".
	No need to initialize pat_lineno.

	Omit duplicate regexps
	Do not pass two copies of the same regexp to the
	regular-expression engine.  Although the engines should
	perform nearly as well even with the copies, in practice they do not.
	Problem reported by Luca Borzacchiello (Bug#43040).
	* bootstrap.conf (gnulib_modules): Add hash.
	* src/grep.c: Include stdint.h, for SIZE_WIDTH.
	Include hash.h.
	(struct patloc, patloc, patlocs_allocated, patlocs_used):
	Rename from struct FL_pair, fl_pair, n_fl_pair_slots, n_pattern_files,
	respectively, since the data type is no longer a pair.
	All uses changed.
	(struct patloc): New member FILELINE.  The lineno member is now
	ptrdiff_t since nowadays we prefer signed types.
	(pattern_array, patterns_table): New static vars.
	(count_nl_bytes, fl_add): Remove; no longer used.
	(hash_pattern, compare_patterns, update_patterns): New functions.
	update_patterns does what fl_add used to do, plus remove dups.
	(pattern_file_name): Adjust to change from fl_pair to patloc.
	(main): Move some variables to inner blocks for clarity.
	Maintain the pattern_table hash of all patterns.
	Update pattern_array to match keys, and use update_patterns
	instead of fl_add to remove duplicate keys.
	* tests/filename-lineno.pl (invalid-re-2-files)
	(invalid-re-2-files2, invalid-re-2e): Ensure regexps are unique in
	tests so that dups aren’t removed in diagnostics.
	(invalid-re-line-numbers): New test.

2020-08-23  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest
	* gnulib: Update submodule to latest.
	* bootstrap.conf (gnulib_modules): Add explicit dependency on dirname-lgpl.
	Before, we pulled this in via a dependency.
	* bootstrap: Update from gnulib.

	build: require autoconf-2.64
	* configure.ac: Require autoconf-2.64, up from 2.63, to align with gnulib.

2020-08-22  Paul Eggert  <eggert@cs.ucla.edu>

	Revert -L exit status change introduced in grep 3.2
	Problems reported by Antonio Diaz Diaz in:
	https://bugs.gnu.org/28105#29
	* NEWS, doc/grep.texi (Exit Status), src/grep.c (usage):
	Adjust documentation accordingly.
	* src/grep.c (grepdesc, main): Go back to old behavior.
	* tests/skip-read: Adjust tests accordingly.

2020-01-20  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix permission issue in previous change

	tests: work around GCC -fprofile-generate bug
	* tests/triple-backref: Add a 10 s timeout to work around
	what appears to be a GCC bug with -fprofile-generate.
	Problem reported by Martin Liška, with diagnosis by
	Andreas Schwab (Bug#21513).

2020-01-02  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.4
	* NEWS: Record release date.

	build: update gnulib to latest, for mbrtowc-vs-Irix build fix

2020-01-02  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention glibc bug 24269
	* doc/grep.texi (Known Bugs): Mention glibc bug 24269.
	Merge formatting/URL changes from Gnulib regex.texi.

	doc: fix --exclude description in man page
	Problem reported by Duncan Moore (Bug#37212).
	* src/grep.c (usage): Fix incorrect statement about --exclude
	and directories.  Standardize on “that match GLOB” instead
	of “matching GLOB”.

	doc: fix missing “more” in man page
	Problem reported by Philippe Schnoebelen (Bug#34078).
	* doc/grep.in.1: Add missing “more”.

2020-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	doc: add [:blank:] to man page
	* doc/grep.in.1: Mention [:blank:] (Bug#33291).

2020-01-01  Jim Meyering  <meyering@fb.com>

	maint: update all copyright year number ranges
	Run "make update-copyright" and then...
	* gnulib: Update to latest with copyright year adjusted.
	* tests/init.sh: Sync with gnulib to pick up copyright year.
	* bootstrap: Likewise.
	* doc/grep.in.1: Use "-" in copyright year ranges, not \en.

2019-12-31  Jim Meyering  <meyering@fb.com>

	tests: avoid unwarranted failure in a netbsd 8.1 VM
	* tests/mb-non-UTF8-perf-Fw: Run twice, to avoid first-read penalty.
	Reported by Nelson H.F. Beebe.

2019-12-30  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest (for localeinfo perf fix)

	maint: add syntax-check rule to prohibit "backreference" spelling
	* cfg.mk (sc_prohibit_backref): New rule.

2019-12-30  Paul Eggert  <eggert@cs.ucla.edu>

	maint: remove too-long line from AUTHORS
	* AUTHORS: Remove URL that’s too long.

	maint: update AUTHORS
	* AUTHORS: Update to better reflect current authorship.

2019-12-30  Jim Meyering  <meyering@fb.com>

	avoid new syntax-check failures
	* cfg.mk (old_NEWS_hash): Updating old news, we must also udpate this.

2019-12-30  Paul Eggert  <eggert@cs.ucla.edu>

	doc: don’t encourage back-references
	* doc/grep.texi (Usage): Remove palindrome question.  Bondioni’s
	RE makes grep issue a ‘grep: stack overflow’ diagnostic, and we
	shouldn’t be encouraging fancy back-references anyway, due to all
	the bugs in this area (Bug#26864).  Plus, the allusion to
	“GNU extensions” doesn't seem to be correct here.

	doc: robustify some examples
	Prompted by suggestions by Stephane Chazelas (Bug#38792#20).
	* doc/grep.texi (Usage): Make examples more robust.

	doc: fix bug# typo

	doc: spell "back-reference" more consistently

	doc: mention back-reference bugs
	Inspired by Bug#26864.
	* doc/grep.texi (Known Bugs): New section.
	Mention back-reference issues.

2019-12-29  Paul Eggert  <eggert@cs.ucla.edu>

	doc: Add -- to more-complex example
	Suggested by Stephane Chazelas (Bug#38792).
	* doc/grep.in.1, doc/grep.texi: Add ‘--’ to recently-added example.

	doc: improve subsection title (Bug#26132)
	* doc/grep.in.1: Rename "Matcher Selection" to "Pattern Syntax".

	doc: fix typo in previous patch

	doc: document quoting better
	Problem reported by Martin Simons (Bug#38792).
	* doc/grep.texi: Fix quoting used in examples.  Say that patterns
	should be quoted, use quoting more consistently in examples, and
	give an example illustrating the difference between patterns and
	globbing.  Don’t assume zgrep expertise in example.
	* doc/grep.in.1: Likewise.  Also, reorder sections
	to match GNU/Linux man-pages style.

2019-12-26  Jim Meyering  <meyering@fb.com>

	maint: tweak NEWS wording
	* NEWS: Minor wording change.

	build: update gnulib to latest; and sync tests/init.sh
	* gnulib: update
	* tests/init.sh: Sync from gnulib (this removes the LC_ALL=C setting).

	tests: avoid spurious failure due to 1-second timeout
	* tests/grep-dev-null-out: Use a 10-second timeout, rather than
	a 1-second one.  This avoids false failure on slow systems.
	Reported by Assaf Gordon in
	https://lists.gnu.org/r/grep-devel/2019-12/msg00018.html

2019-12-26  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	maint: adjust surrogate-pair for 16-bit wchar_t
	* tests/surrogate-pair: Adjust to match fixed behavior
	on AIX 7.2, where wchar_t is 16 bits and cannot represent
	the test case data.

2019-12-25  Jim Meyering  <meyering@fb.com>

	tests: fix typo in name of test file
	* tests/backslash-s-vs-invalid-multitype: Rename to...
	* tests/backslash-s-vs-invalid-multibyte: ...this.
	* tests/Makefile.am (TESTS): Reflect renaming.

	tests: ensure we use require_timeout_ when needed
	* cfg.mk (sc_timeout_prereq): New syntax-check rule.

	tests: require timeout
	* tests/mb-non-UTF8-perf-Fw: This test uses "timeout",
	so must first call require_timeout_.
	This avoids test spurious failure when running with
	no timeout program. Reported by Bruno Haible in
	https://lists.gnu.org/r/grep-devel/2019-12/msg00008.html

2019-12-25  Paul Eggert  <eggert@cs.ucla.edu>

	tests: work around AIX 7.2 sh printf bug
	AIX 7.2 /bin/sh’s printf command mishandles octal escapes
	in multibyte locales: it treats them as characters, not bytes.
	* tests/backslash-s-vs-invalid-multitype, tests/encoding-error:
	Use the C locale when employing the printf command with an octal
	escape that AIX 7.2 sh might mishandle.
	* tests/init.sh (setup_): Use the C locale for tests.
	This has the side benefit of making them more reproducible.

2019-12-22  Jim Meyering  <meyering@fb.com>

	maint: adjust new comments
	* src/dfasearch.c (possible_backrefs_in_pattern): Remove a
	duplicate "a", insert a "be" and a comma, and reformat.

	build: update gnulib to latest
	* gnulib: Update submodule to latest.
	* bootstrap: Copy from gnulib.
	* tests/init.sh: Likewise.

2019-12-22  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix some bugs in pattern-grouping speedup
	This fixes some bugs in the previous commit,
	and should finish the fix for Bug#33249.
	* NEWS: Mention fix for Bug#33249.
	* src/dfasearch.c (possible_backrefs_in_pattern, regex_compile)
	(GEAcompile): In new code, prefer ptrdiff_t to size_t when either
	will do, since ptrdiff_t has better error checking.  At some point
	we should adjust the old code too.
	(possible_backrefs_in_pattern): Rename from
	find_backref_in_pattern.  New arg BS_SAFE.  All uses changed.
	Fix false negative if a multibyte character ends in a single
	'\\' byte, followed by the two bytes '\\', '1'.
	(regex_compile): Simplify.
	(GEAcompile): Avoid quadratic behavior when reallocating growing
	buffers.  Fix a couple of bugs in copying pattern data involving
	backreferences.  Fix another bug in copying pattern metadata
	involving backreferences, by removing the need to copy it.

2019-12-22  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: grouping of a pattern with multiple lines
	When grep uses regex, it splits a pattern with multiple lines by
	newline character into fragments.  Compilation and execution run for
	each fragment.  That causes slowdown.  By this change, each fragment is
	divided into groups by whether the fragment includes back references.
	A fragment with back references constitutes group, and all fragments
	that lack back references also constitute a group.

	This change extremely speeds-up following case.

	  $ seq -f '%040g' 0 9999 | sed '1s/$/\\(0\\)\\1/' >pat
	  $ yes 00000000000000000000000000000000000000000x | head -10000 >in
	  $ time -p env LC_ALL=C src/grep -f pat in

	* src/dfasearch.c (find_backref_in_pattern, regex_compile):
	New functions.
	(GEAcompile): Use the new functions to group fragments
	as mentioned above.

2019-12-19  Paul Eggert  <eggert@cs.ucla.edu>

	maint: add NEWS for Bug#34951 fix
	* NEWS: Mention Bug#34951.

2019-12-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: separate parse and compile phase
	DFAMUST() must be called after parse and before tokens re-order which is
	introduced in commit 5c7a0371823876cca7a1347fa09ca26bbbff0c98, but both are
	executed in compilation phase.

	* lib/dfa.c (dfaparse): Change it to global function.
	(dfacomp): If first argument is NULL, skip parse.
	* lib/dfa.h: (dfaparse): Add a prototype.

2019-12-19  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2019-12-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: speed up multiple word matching
	grep uses its KWset matcher for multiple word matching, but that is
	very slow when most of the parts matched to a pattern are not words.
	So, if the first match to a pattern is not a word, use the grep matcher
	to match for its line.

	Note that when START_PTR is set, the grep matcher uses the regex matcher
	which is very slow to match words.  Therefore, we use the grep matcher
	when only START_PTR is NULL.

	* src/kwsearch.c (Fexecute): If an initial match is incomplete because
	not on a word boundary, use the grep matcher to find a matching line.

2019-12-18  Jim Meyering  <meyering@fb.com>

	maint: sort test names
	* tests/Makefile.am (TESTS): Alphabetize the new addition,
	mb-non-UTF8-perf-Fw to placate syntax-check's sc_sorted_tests.

2019-12-18  Paul Eggert  <eggert@cs.ucla.edu>

	maint: adjust to recent Gnulib change
	* po/POTFILES.in: Remove lib/xstrtol-error.c.

2019-12-17  Paul Eggert  <eggert@cs.ucla.edu>

	grep: do not match invalid UTF-8
	Update Gnulib to latest.  Also:
	* src/dfasearch.c (EGexecute): Use ptrdiff_t, not size_t,
	to match new Gnulib API.
	* tests/Makefile.am (TESTS): Add dfa-invalid-utf8.
	* tests/dfa-invalid-utf8: New file.

2019-11-30  Jim Meyering  <meyering@fb.com>

	tests: add test that would have detected -Fw perf regression
	* tests/mb-non-UTF8-perf-Fw: New file. Detect v3.3-22-g090a4db's
	performance regression.
	* tests/Makefile.am (TESTS): Add it.

2019-11-29  Jim Meyering  <meyering@fb.com>

	maint: fix test comment
	* tests/mb-non-UTF8-word-boundary: Also correct "introduced-in"
	version number in a comment here.

2019-11-25  Jim Meyering  <meyering@fb.com>

	maint: correct NEWS blurb
	* NEWS (Bug fixes): Correction: the -Fw bug was introduced
	in 2.28, not in 3.0. Reported by Paul Eggert.

2019-11-17  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: improve grep -Fw performance in non-UTF8 multibyte locales
	* src/searchutils.c (mb_goback): New parameter.  All callers changed.
	* src/search.h (mb_goback): Update prototype.
	* src/kwsearch.c (Fexecute): Use mb_goback's MBCLEN to detect a
	word-boundary even more efficiently.

	grep: fix performance regression with previous patch
	* src/kwsearch.c (Fexecute): Avoid unnecessary back-up in non-UTF8
	multibyte locales.

2019-11-16  Jim Meyering  <meyering@fb.com>

	maint: rename a variable: bol -> nl
	* src/kwsearch.c (Fexecute): Change misleading name: s/bol/nl/

	build: update gnulib to latest

	maint: correct and clarify a comment
	* src/kwsearch.c (Fexecute): Logic was reversed.

	grep: avoid false -Fw match in non-UTF8 multibyte locales
	For example, this command would erroneously print its input line:
	  echo ab | LC_CTYPE=ja_JP.eucjp grep -Fw b
	This arose when the "memrchr" search for a preceding newline failed:
	in that case, MB_START was not adjusted and was initially the same
	as BEG, so wordchar_prev mistakenly returned 0.
	* src/kwsearch.c (Fexecute): Set MB_START also when there is no
	preceding newline.
	* NEWS (Bug fixes): Mention it.
	* tests/mb-non-UTF8-word-boundary: New file. Test for the bug.
	* tests/Makefile.am (TESTS): Add it.
	Reported by NIDE, Naoyuki in https://bugs.gnu.org/38223.

2019-11-08  Jim Meyering  <meyering@fb.com>

	build: update gnulib to latest
	* po/POTFILES.in: Add lib/argmatch.h.

2019-11-05  Paul Eggert  <eggert@cs.ucla.edu>

	grep: new --no-ignore-case option
	Suggested by Karl Berry and mostly implemented by Arnold Robbins
	(Bug#37907).
	* NEWS:
	* doc/grep.in.1:
	* doc/grep.texi (Matching Control):
	* src/grep.c (usage):
	Document the new option.
	* src/grep.c (NO_IGNORE_CASE_OPTION): New constant.
	(long_options, main): Support new option.

	grep: simplify previous patch
	* src/grep.c (main): Use an int rather than an enum for a local
	var, which is overkill here.

	grep: further simplify out_file handling
	* src/grep.c (print_filenames): Make this a local variable instead
	of static.  Rename it to filename_option, to avoid confusion with
	the print_filename function, and rename the enum values for the
	same reason.  All uses changed.
	(out_file): Now -1, 0, 1 to represent unknown, false, true.
	All uses changed.
	(single_command_line_arg): Remove.  This static variable’s
	function is now accomplished by a local variable ‘num_operands’.
	(grepdesc): Simplify adjustment of out_file accordingly.
	(main): Initialize out_file to -1 if not known yet.

2019-11-05  Zev Weiss  <zev@bewilderbeest.net>

	grep: simplify out_file handling
	* src/grep.c (print_filenames): New tristate enum (-H, -h, or
	neither); supplants with_filenames and no_filenames.
	(single_command_line_arg): New variable indicating if grep was run
	with a single command-line argument.
	(no_filenames): Remove variable.
	(grepdirent): Don't twiddle out_file back and forth during recursion.
	(grepdesc): Turn off out_file on 'grep -r foo nondirectory'.
	(main): Replace with_filenames and no_filenames with print_filenames.
	Enable out_file when both -r/-R and multiple arguments are given.

2019-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix ‘grep -L ... >/dev/null’ bug
	Problem reported by Adam Sampson (Bug#37716).
	* NEWS: Mention this.
	* src/grep.c (grepdesc): Don’t assume that stdout being /dev/null
	means list_files == LISTFILES_NONE.
	(main): Do not change list_files merely because stdout is /dev/null.
	* tests/skip-read: Test for this bug.

2019-10-03  Paul Eggert  <eggert@cs.ucla.edu>

	grep: tighten -i doc
	* doc/grep.in.1:
	* doc/grep.texi (Matching Control):
	* src/grep.c (usage):
	Make it clearer that -i affects patterns and data, but not
	file names (Bug#37604).

2019-03-10  Paul Eggert  <eggert@cs.ucla.edu>

	maint: fix “/src/grep: No such file or directory”
	Problem reported by Jim Meyering in:
	https://lists.gnu.org/r/grep-devel/2019-02/msg00000.html
	* NEWS: Mention the change.
	* configure.ac (fn_grep): Remove.  This old attempt to fix
	<https://savannah.gnu.org/bugs/?31646> wasn’t working anyway,
	since subprograms didn’t grok fn_grep.  People building on Solaris
	will need a working grep, which is reasonably standard nowadays.
	(GREP, EGREP): Do not override.  This way, we test the
	newly-built grep only when running ‘make test’ and suchlike.
	Instead, output a hopefully-helpful diagnostic if the
	system 'grep' does not work.

2019-02-18  Jim Meyering  <meyering@fb.com>

	tests: avoid false positive upon stack overflow
	* tests/pcre-jitstack: Don't let a stack overflow evoke a false
	failure.  This test is to ensure there is no internal PCRE error.
	Reported by Andreas Schwab in http://bugs.gnu.org/34370

2019-02-16  Jim Meyering  <meyering@fb.com>

	build: avoid build failure with --enable-gcc-warnings
	* src/kwset.c (bmexec_trans): Define with _GL_ATTRIBUTE_PURE,
	per suggestion from recent gcc snapshot.

2019-02-03  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify --exclude globbing
	Problem reported by Paul Jackson.
	* doc/grep.in.1:
	* doc/grep.texi (File and Directory Selection):
	Clarify how --exclude globbing works.

	grep: parse --color arg independent of locale
	This is a better fix for Bug#34285.
	* bootstrap.conf (gnulib_modules): Add c-strcase.
	* src/grep.c: Include c-strcase.h, not strings.h.
	(main): Use c_strcasecmp, not strcasecmp.

2019-02-02  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix grep.c includes
	* src/grep.c: Include strings.h; problem reported by David
	Monniaux (Bug#34285).  Do not include fcntl.h, as system.h does
	that for us.h

	build: update gnulib submodule to latest

2019-01-20  Jim Meyering  <meyering@fb.com>

	build: ensure no VLA is used
	Cause developer builds to fail for any use of a VLA.
	VLAs (variable length arrays) limit portability.
	* configure.ac (nw): Remove -Wvla from the list of disabled warnings,
	thus enabling the warning when configured with --enable-gcc-warnings.
	(GNULIB_NO_VLA) Define, disabling use of VLAs in gnulib.  This commit
	is functionally equivalent to coreutils' v8.30-44-gd26dece5d.

	build: update gnulib to latest

2019-01-20  Paul Eggert  <eggert@cs.ucla.edu>

	doc: --binary-files update in man page
	* doc/grep.in.1: Adjust --binary-files description to match that
	in doc/grep.texi.  When I updated the documentation in
	2016-09-09T01:33:14!eggert@cs.ucla.edu I forgot to update the man
	page accordingly (Bug#33898).

	grep: simplify pcresearch.c ifdefs
	This fixes a warning if PCRE is not used (Bug#34054).
	* configure.ac (USE_PCRE): New conditional.
	* src/Makefile.am (grep_SOURCES) [!USE_PCRE]: Omit pcresearch.c.
	* src/grep.c (matchers) [!HAVE_LIBPCRE]: Omit perl matcher.
	(setmatcher) [!HAVE_LIBPCRE]: If helpful, mention
	--disable-perl-regexp in diagnostic.
	* src/pcresearch.c: Simplify by assuming HAVE_LIBPCRE.

2019-01-01  Jim Meyering  <meyering@fb.com>

	maint: update all copyright dates via "make update-copyright"
	* gnulib: Also update submodule for its copyright updates.

2018-12-20  Jim Meyering  <meyering@fb.com>

	doc: fix the bug-introduced version in 3.3's announcement
	* NEWS: Correct bug-introduced version (s/2.3/3.2/).
	* cfg.mk (old_NEWS_hash): Updating old news, we must also udpate this.

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.3
	* NEWS: Record release date.

	grep: fix \b DFA-bug in C locale
	Under some conditions, \b would mistakenly fail to match, e.g.
	  echo 123-x|LC_ALL=C grep '.\bx'
	* NEWS (Bug fixes): Mention it
	* gnulib: Update to latest, for DFA regression fix.
	* tests/word-delim-multibyte: Add a test for the dfa.c regression.

2018-12-20  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fit --version authorship into 80
	* src/grep.c (AUTHORS): Remove.
	(main): Output the authorship info ourselves instead of having
	version_etc do it.  This is better for i18n anyway.

	build: update gnulib submodule to latest

2018-12-20  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.2
	* NEWS: Record release date.

2018-12-18  Jim Meyering  <meyering@fb.com>

	build: update gnulib for c-stack fix

2018-12-17  Bruno Haible  <bruno@clisp.org>

	tests: stack-overflow: avoid unwarranted test failure on some hosts
	* tests/stack-overflow: Use ulimit to limit stack size. Otherwise,
	at least on gcc113, grep would fail to overflow its stack, so this
	test would fail to find the required diagnostic and would fail.

2018-12-16  Jim Meyering  <meyering@fb.com>

	tests: reenable the surrogate-pair test
	This reverts commit bdb98cec2e7bf255e1d00eaf8be16299f7bf571e,
	but adding the comment changes suggested by Bruno Haible in
	https://lists.gnu.org/r/grep-devel/2018-12/msg00037.html
	* tests/surrogate-pair: New file.
	* tests/Makefile.am (TESTS): List it.

2018-12-16  Bruno Haible  <bruno@clisp.org>

	tests: stackoverflow: fix test failure on HardenedBSD 11
	* tests/stack-overflow: Try up to 10 million opening parentheses.

2018-12-16  Jim Meyering  <meyering@fb.com>

	tests: remove stale surrogate-pair test
	The cygwin-specific code for surrogate pairs was first disconnected
	via v2.21-62-g936c904 and later removed as part of a then-unused
	function via v2.24-12-g704de87. So now I'm removing the test, too.
	If someone thinks it important and would like to revive it, please do.
	* tests/surrogate-pair: Remove file.
	* tests/Makefile.am (TESTS): Remove it.

2018-12-16  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2018-12-15  Jim Meyering  <meyering@fb.com>

	tests: stack-overflow: handle the case of success without the diagnostic
	* tests/stack-overflow: Do not always require a stack
	overflow diagnostic.

	build: update gnulib to latest
	* gnulib: Update to latest, to pull in code that now compensates for
	a bug in glibc-2.27 and prior.

	build: make the autoconf-2.63 requirement explicit
	* configure.ac: AC_PREREQ: Require 2.63, not 2.59. And quote properly.
	Autoconf-2.63 has been required for some time via gnulib.
	This merely makes it explicit.

2018-12-15  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix diagnostic typo
	Fix by Bruno Haible in:
	https://lists.gnu.org/r/grep-devel/2018-12/msg00003.html
	* tests/init.cfg (envvar_check_fail): Fix diagnostic.

2018-11-24  Jim Meyering  <meyering@fb.com>

	tests: stack-overflow: avoid false failure
	* tests/stack-overflow: This test would fail to elicit a stack overflow
	diagnostic on some OS X systems. Rewrite to iterate, gradually increasing
	the size of the input regex, stopping when grep emits the desired diagnostic
	or the size reaches a reasonable limit.

2018-10-16  Jim Meyering  <meyering@fb.com>

	tests: reduce the sole failing test
	* tests/backref-alt: Significantly reduce abort-inducing input.

	build: update gnulib to latest; also update bootstrap and init.sh

2018-10-13  Jim Meyering  <meyering@fb.com>

	doc: NEWS: mention performance improvements
	* NEWS (Improvements): Mention them.

2018-10-13  Jim Meyering  <meyering@fb.com>

	grep: triple initial buffer size: 32k->96k
	Changing 32k to 96k gives a 3-23% performance improvement.
	All timings ran with this diff on top of commit v3.1-39-g7179b21:

	for n in 32 64 96 128; do
	  echo n=$n
	  perl -pi -e 's/(INITIAL_BUFSIZE =) \d+/$1 '$n/ src/grep.c &&
	    make AM_CFLAGS=-O3 WERROR_CFLAGS= >& makerr-$n &&
	    for needle in 1f2 1f298lkjskjhahjklkj34; do
	      echo "  needle=$needle"
	      for i in $(seq 10); do
	         env MALLOC_PERTURB_= time -qf%e src/grep $needle w2000
	      done 2>&1 |sort -g | tee >(head -1|sed 's/^/    /') > .time-${n}KB-$needle
	    done
	done

	Tested searchs: search for a short literal pattern that is not
	present in 9.3GB file containing 2000 copies of /usr/dict/words
	created via this:
	  ln -s /usr/share/dict/words k && cat $(yes k|head -2000) > w2000
	I ran this command:
	  env MALLOC_PERTURB_= time src/grep 1f2 w2000
	old(32k) vs new elapsed time, best of 10 trials (gcc-9.0.0 20180831, -O3):
	 32k  64k  96k(%incr) 128k CPU
	1.25 1.18 1.16( 7.2) 1.20 i7-4770S@3.10GHz cache=8MB
	1.21 1.16 1.17( 3.3) 1.19 Xeon(R) E3-1505M v5 @ 2.80GHz cache=8MB
	2.36 2.29 2.29( 3.0) 2.36 Xeon(R) E5-2680 v4 @ 2.40GHz cache=32MB
	1.40 1.32 1.31( 6.4) 1.33 i5-6260U @ 1.80GHz cache=4MB
	1.31 1.26 1.24( 5.3) 1.23 AMD FX(tm)-4100 cache=2MB (with only 1000 copies)

	Searching for a longer string: 1f298lkjskjhahjklkj34
	2.03 1.76 1.61(20.7) 1.53 i7-4770S@3.10GHz cache=8MB
	1.95 1.70 1.56(20.0) 1.51 Xeon(R) E3-1505M v5 @ 2.80GHz
	3.27 2.98 2.84(13.1) 3.02 Xeon(R) E5-2680 v4 @ 2.40GHz
	2.48 2.12 1.91(23.0) 1.80 i5-6260U @ 1.80GHz cache=4MB
	1.72 1.54 1.46(15.1) 1.41 AMD FX(tm)-4100 cache=2MB

	* src/grep.c (INITIAL_BUFSIZE): Triple it: 32kB -> 96kB

2018-09-28  Barret Rhoden  <brho@cs.berkeley.edu>  (tiny change)

	maint: fix cross-compiling problem
	* cfg.mk (PATH): Omit if cross-compiling (Bug#32866).

2018-09-28  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	grep: fix usage 80-column glitch
	* src/grep.c (usage): Do not go over 80 columns in the source
	code, to pacify "make dist".

2018-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	maint: update bootstrap
	* bootstrap: Copy from Gnulib.

	maint: fix build failure
	Problem found by OpenCSW buildbot; the bug also occurs on GNU/Linux
	build platforms.  The symptom is “system.h:26:24: fatal error:
	configmake.h: No such file or directory”.  See:
	https://buildfarm.opencsw.org/buildbot/builders/ggrep-solaris10-sparc/builds/107
	* bootstrap.conf: Add configmake, a dependency that was formerly brought
	in only by accident.

2018-09-18  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2018-08-09  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix comment

	tests: backref-alt works with glibc 2.28
	Problem reported by Jaroslav Skarvada (Bug#32409).
	* tests/Makefile.am (XFAIL_TESTS) [!USE_INCLUDED_REGEX]:
	Don’t add backref-alt, since this bug is fixed in glibc 2.28.

2018-05-11  Paul Eggert  <eggert@cs.ucla.edu>

	doc: “pattern” vs “patterns”
	* doc/grep.in.1, doc/grep.texi, src/grep.c (usage): Be more
	careful about saying that an argument or option specifies one or
	more patterns, not just a single pattern.  Problem reported by Kaz
	Kylheku (Bug#31400).

	build: update gnulib submodule to latest

2018-04-21  Jim Meyering  <meyering@fb.com>

	maint: fix new syntax-check (sc_long_lines) failure
	* HACKING: Shorten line by one byte to fit in 80 columns.

	build: update gnulib to latest

2018-04-21  Paul Eggert  <eggert@cs.ucla.edu>

	doc: fix font typo

	maint: update URLs
	Mostly this is just changing http: to https:.
	In one or two places it removes no-longer-useful URLs.

	doc: man-page format fixes
	* doc/grep.in.1: Fix minor formatting glitches, e.g., extra
	space after [...] because groff thought it was a sentence end.
	Problem reported by Ingo Schwarze (Bug#31228#11).

2018-04-20  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention encoding errors
	This attempts to document the encoding-error problem more
	precisely (Bug#30326).
	* doc/grep.in.1, doc/grep.texi: Mention that the behavior of
	patterns like ‘.’ is not specified on encoding errors.

	doc: port better to mandoc
	* doc/grep.in.1: Check for groff and its macro packages
	independently, as groff can be used with non-groff macro packages.
	Use an-ext style macros rather than www.tmac style, as this should
	be more portable to mandoc.  Problem reported by Laura Morales and
	Ingo Schwarze (Bug#31228).

2018-02-16  Jim Meyering  <meyering@fb.com>

	maint: avoid new syntax-check failure
	* cfg.mk (old_NEWS_hash): Update, to accommodate v3.1-20-g63d4174's
	typo fix.

	doc: clarify that PCRE support is here to stay
	* doc/grep.texi (grep Programs): Clarify: it's not PCRE support
	that is experimental, but its combination with --null-data (-z).

2018-02-05  Paul Eggert  <eggert@cs.ucla.edu>

	maint: fix typo

2018-01-06  Jim Meyering  <meyering@fb.com>

	maint: update gnulib and copyright dates for 2018
	* gnulib: Update to latest.
	* all files: Run "make update-copyright".
	* bootstrap: Update from gnulib.

2017-12-17  Jim Meyering  <meyering@fb.com>

	build: link with -lsigsegv, when c-stack module requires it
	* src/Makefile.am (grep_LDADD): Add $(LIBCSTACK).
	Otherwise, on at least Debian and Arch-based systems, linking would
	fail with diagnostics like these:
	  c-stack.c:207: undefined reference to `stackoverflow_install_handler'
	  c-stack.c:216: undefined reference to `sigsegv_install_handler'
	Reported by Jeremy Feusi.

	build: suppress sig-handler.h's -Wcast-function-type warning
	* configure.ac (WERROR_CFLAGS): Add -Wno-cast-function-type
	to suppress warning about sig-handler.h's sa_handler_t cast:
	sig-handler.h: In function 'get_handler':
	sig-handler.h:47:12: error: cast between incompatible function\
	  types from 'void (* const)(int,  siginfo_t *, void *)'\
	  {aka 'void (* const)(int,  struct <anonymous> *, void *)'}\
	  to 'void (*)(int)' [-Werror=cast-function-type]
	     return (sa_handler_t) a->sa_sigaction;

2017-12-16  Jim Meyering  <meyering@fb.com>

	grep: diagnose stack overflow rather than segfaulting
	* bootstrap.conf (gnulib_modules): Add c-stack.
	* src/grep.c: Include "c-stack.h".
	(main): Call c_stack_action (NULL);
	* tests/stack-overflow: New file.
	* tests/Makefile.am (TESTS): Add name of new file.
	* NEWS (Improvements): Mention it.
	Interestingly, this bug does not afflict grep-2.5.4 or prior,
	so it appeared to have been introduced with grep-2.6.  However,
	the origin is in glibc's regexp compiler, and I tracked it to
	stack-aware parsing that was removed from glibc's regexp in 2002.
	However, grep-2.5.4 was released in 2009.  That version worked
	(and still works, now) because it included and (by default) used
	an old copy of glibc's regexp code.
	Jeremy Feusi reported the grep segfault in https://bugs.gnu.org/29666.
	I reported the glibc regexp bug in
	https://sourceware.org/bugzilla/show_bug.cgi?id=22620

2017-11-26  Stephan T. Lavavej  <stl@nuwen.net>

	grep: fix directory recursion on MS-Windows
	gnulib recently gained a module, windows-stat-inodes, that fixes
	directory recursion on MS-Windows. No changes to grep's C sources are
	required; grep simply needs to request the module during configuration.

	When grep requests this module, its configure script will gain the
	behavior that was implemented in windows-stat-inodes.m4. This detects
	mingw and sets WINDOWS_STAT_INODES=1. All other platforms are
	unaffected, setting WINDOWS_STAT_INODES=0 (which is what's happening
	in the absence of this patch).

	* bootstrap.conf (gnulib_modules): Add windows-stat-inodes.
	* NEWS (Bug fixes): Mention it.
	Thanks to Pär Björklund who diagnosed the problem as involving inodes,
	and thanks to Václav Haisman who provided the bootstrap.conf patch.

2017-11-25  Paul Eggert  <eggert@cs.ucla.edu>

	grep: port better to Adélie GNU/Linux 64-bit ppc
	Problem reported by A. Wilcox (Bug#29446).
	* src/pcresearch.c (PCRE_EXTRA_MATCH_LIMIT_RECURSION)
	(PCRE_STUDY_EXTRA_NEEDED): Default to 0.
	(jit_exec): If we run up against the recursion limit,
	double it (if possible) and try again.
	(Pcompile): Also specify PCRE_STUDY_EXTRA_NEEDED so that
	pc->extra is not null.

2017-11-03  Paul Eggert  <eggert@cs.ucla.edu>

	grep: omit a dup 'const'
	* src/grep.c (matchers): Omit duplicate 'const'.

2017-10-13  Bernhard Voelker  <mail@bernhard-voelker.de>

	doc: document the option delimiter '--'
	* doc/grep.texi (Other options): Do the above.
	Reported in https://lists.opensuse.org/opensuse/2017-03/msg00411.html
	This addresses http://bugs.gnu.org/26139

2017-08-21  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	Pacify GCC 5.4
	* src/grep.c (grepdesc): Rework to pacify GCC 5.4 warning
	about logical not.

2017-08-20  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2017-08-17  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -L exits with status 0 if a file is selected
	Problem reported by Anthony Sottile (Bug#28105).
	* NEWS, doc/grep.texi (Exit Status), src/grep.c (usage): Document this.
	* src/grep.c (grepdesc): Implement it.
	* tests/skip-read: Test it.

	build: update gnulib submodule to latest

2017-08-13  Jim Meyering  <meyering@fb.com>

	maint: avoid newly-introduced syntax-check failure
	* src/grep.c (usage): Shorten --help line to 80, so
	"make syntax-check" passes once again.

2017-08-03  Paul Eggert  <eggert@cs.ucla.edu>

	doc: improve -o help
	* src/grep.c (usage): Document that -o outputs only nonempty
	matches (Bug#27931).

2017-07-26  Paul Eggert  <eggert@cs.ucla.edu>

	tests: add Bug#27838 test case
	* tests/backref-alt: New test case from a fuzzer.

2017-07-25  Paul Eggert  <eggert@cs.ucla.edu>

	doc: distinguish -w from \<...\>
	* doc/grep.texi (Matching Control):
	Give example of why -w differs from \<...\> (Bug#27813).

2017-07-11  Paul Eggert  <eggert@cs.ucla.edu>

	doc: define Dt string in man page
	Problem reported by Bjarni I. Gislason via Santiago R.R. (Bug#27651).
	* doc/grep.in.1 (dT): New macro.
	(Dt): Define this string.

2017-07-02  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.1
	* NEWS: Record release date.

2017-07-01  Jim Meyering  <meyering@fb.com>

	tests: avoid false failures when run in qemu user mode
	* tests/filename-lineno.pl: Derive the program name that grep
	will use in diagnostics, based on a suggestion from Assaf Gordon.
	* tests/in-eq-out-infloop: Similar: accept an arbitrary "command_name: "
	prefix on checked diagnostics, rather than requiring "grep: ".
	* tests/reversed-range-endpoints: Likewise.
	* tests/write-error-msg: Likewise.
	Reported by Bruno Haible in http://bugs.gnu.org/27532

2017-06-25  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest
	* gnulib: Update to latest for these portability fixes:
	- stat: port to xlc 12.01
	- xalloc-oversized: port to icc

	doc: fix another typo
	* doc/grep.texi (File and Directory Selection): Fix typo: s/afer/after/

2017-06-24  Jim Meyering  <meyering@fb.com>

	doc: stop calling --perl-regexp (-P) "highly" experimental
	Use wording that is less likely to make readers think that
	support for -P may be removed.
	* doc/grep.in.1: s/highly experimental/experimental/
	* doc/grep.texi: Likewise.
	Suggested by Evan Sheahan.

2017-06-21  Jim Meyering  <meyering@fb.com>

	doc: correct typo
	* doc/grep.texi (Performance): s/suprisingly/surprisingly/

	gnulib: update to latest

2017-06-21  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -m no longer cuts off trailing context
	Problem reported by Markus Jochim (Bug#26254).
	* NEWS, doc/grep.texi (General Output Control): Document this.
	* src/grep.c (prpending): Selected lines no longer cut off context.
	(usage): Say "selected" instead of "matching", where appropriate.
	* tests/foad1, tests/max-count-vs-context, tests/yesno:
	Adjust to match new behavior.

2017-05-31  Paul Eggert  <eggert@cs.ucla.edu>

	Document grep performance
	* doc/grep.texi (Performance): New section.

	build: update gnulib submodule to latest

2017-05-21  Jim Meyering  <meyering@fb.com>

	maint: make the announcement template Cc the devel- list
	* cfg.mk (announcement_Cc_): Define.

	gnulib: update to latest; and update tests/init.sh

	maint: accommodate GCC7's -Werror=duplicated-branches
	* src/system.h (IGNORE_DUPLICATE_BRANCH_WARNING): Define.
	* src/grep.c (grepfile): Use it.
	* src/kwset.c (bmexec, acexec): Use it.

	maint: update to work with GCC7's -Werror=implicit-fallthrough=
	* src/system.h (FALLTHROUGH): Define.
	* src/grep.c (context_length_arg): Use new FALLTHROUGH macro in place
	of comments
	(fgrep_to_grep_pattern, try_fgrep_pattern, main): Likewise.

2017-05-13  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest and adapt src/kwset.c
	* gnulib: Update to latest.
	* src/kwset.c: Include "verify.h" for use of assume.

2017-03-22  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest for dfa [0-9] performance improvement
	This pulls in the following change that is very relevant to grep:

	    commit 6afba02d7869d39ed7f61981045ddbdcb2814101
	    Author: Paul Eggert <eggert@cs.ucla.edu>
	    dfa: make [0-9] faster in non-C locales

	* gnulib: Update to latest.
	* NEWS (Improvements): Describe the effect on grep.

2017-03-05  Jim Meyering  <meyering@fb.com>

	build: use $(builddir), not $(srcdir)
	* cfg.mk (PATH): Use $(builddir), so this also takes effect
	in a non-srcdir build.  Also, switch ${PATH} syntax to $(PATH).

2017-03-05  Juan Manuel Guerrero  <juan.guerrero@gmx.de>

	build: use $(PATH_SEPARATOR), not ":" to augment PATH
	* cfg.mk (PATH): Use $(PATH_SEPARATOR), for those systems that
	use something other than ":".
	* THANKS.in: Remove name, to avoid syntax-check failure due to
	the duplicate, now that there is this commit.

2017-02-17  Jim Meyering  <meyering@fb.com>

	maint: fix distcheck failure: remove stale dosbuf.c reference
	* src/Makefile.am (EXTRA_DIST): Do not attempt to distribute
	the recently deleted file, dosbuf.c.

	maint: fix new syntax-check errors
	* po/POTFILES.in: Add lib/xbinary-io.c.
	* cfg.mk (FILTER_LONG_LINES): Add TODO to the list of exempt files.

2017-02-16  Paul Eggert  <eggert@cs.ucla.edu>

	Fix up recent -U patches
	Inspired by a suggestion by Eric Blake (Bug#25707#17).
	* bootstrap.conf (gnulib_modules): Add xbinary-io,
	and remove binary-io and xfreopen.
	* doc/grep.texi (Other Options):
	Fix typo and reword to be a bit more general.
	* src/grep.c: Include xbinary-io.h instead of xfreopen.h.
	(grepfile): Open with O_BINARY if binary.
	(grepdesc): No need for set_binary_mode now.
	(grep_command_line_arg, main): Set stdin to binary mode if binary.
	(main): Avoid unnecessary test of stdin == NULL.
	Use xsetmode instead of xfreopen.
	* src/system.h: Do not include binary-io.h.

	build: update gnulib submodule to latest

	Simplify -U on MS-Windows by removing guesswork
	Suggested by Eric Blake (Bug#25707#11).
	* NEWS, doc/grep.texi: Document this.
	* src/dosbuf.c: Remove.
	* bootstrap.conf (gnulib_modules): Add xfreopen.
	* src/grep.c: Include xfreopen.h, not dosbuf.c.
	(fillbuf, print_line_head): Do not undossify input.
	(binary): New static var.
	(grepdesc): Apply BINARY to input file.
	(usage): Remove -u help.
	(main): Set BINARY if -U, and apply it to stdout.  Do nothing if -u.
	With -f, apply BINARY to input file.

2017-02-16  Eric Blake  <eblake@redhat.com>

	grep: don't forcefully strip carriage returns
	Commit 5c92a54 made the mistaken assumption that using fopen("rt")
	on platforms where O_TEXT is non-zero makes sense.  However, POSIX
	already requires fopen("r") to open a file in text mode, vs.
	fopen("rb") when binary mode is wanted, and at least on Cygwin,
	where it is possible to control whether a mount point is binary
	or text by default (using just "r"), the use of fopen("rt") actively
	breaks assumptions on a binary mount by silently corrupting any
	carriage returns that are supposed to be preserved.

	* src/grep.c (main): Never use fopen("rt") (Bug#25707).

2017-02-13  Paul Eggert  <eggert@cs.ucla.edu>

	Update TODO and doc
	* TODO: Bring up-to-date and fix formatting glitches.
	* doc/grep.in.1, doc/grep.texi: Fix minor glitches.
	The above patches should address the same problems that recent
	Debian doc patches address, albeit in a different way.

2017-02-12  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify default input (Bug#25651)
	* doc/grep.in.1:
	* src/grep.c (usage): Clarify default input when -r.
	* src/grep.c (usage): Do not bother documenting egrep and fgrep;
	the manual is enough.

2017-02-09  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.0
	* NEWS: Record release date.

2017-02-08  Paul Eggert  <eggert@cs.ucla.edu>

	grep: do not mishandle \. in multiple patterns
	Problem reported by Lars Wendler (Bug#25655).
	* NEWS: Document this.
	* src/grep.c (try_fgrep_pattern): Fix typo that prevented
	keys from being properly updated.
	* tests/foad1: Test for the bug.

2017-02-07  Paul Eggert  <eggert@cs.ucla.edu>

	Do not assume PCRE 8.20 or later
	Problem reported by Zube (Bug#25647)
	* NEWS: Document this.
	* src/pcresearch.c (struct pcre.com.jit_stack):
	Declare only if PCRE_STUDY_JIT_COMPILE.

2017-02-06  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.28
	* NEWS: Record release date.

2017-02-02  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

2017-02-01  Paul Eggert  <eggert@cs.ucla.edu>

	grep: tune to avoid memchr2 sometimes
	Problem noted by Norihiro Tanaka in:
	http://lists.gnu.org/archive/html/grep-devel/2017-01/msg00027.html
	Although not enough to restore all the previous performance in the
	case he noted, it helps significantly.
	* src/kwset.c (memchr_kwset): Bring back small_heuristic,
	in a somewhat different form.

2017-01-29  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

2017-01-23  Paul Eggert  <eggert@cs.ucla.edu>

	grep: simplify recent kwset change
	* src/kwset.c (acexec_trans): Simplify.

2017-01-23  Jim Meyering  <meyering@fb.com>

	tests: really add the new test name
	* tests/Makefile.am (TESTS): Add fgrep-longest.

2017-01-21  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep -Fo could report a match that is not the longest
	* src/kwset.c (acexec): Fix it.
	* tests/fgrep-longest: New test.
	* tests/Makefile.am: Add the test.
	* NEWS: Mention it.

2017-01-18  Paul Eggert  <eggert@cs.ucla.edu>

	grep: speed up Aho-Corasick when at most 2 bytes
	When using Aho-Corasick and all matched strings either begin with
	the same byte, or begin with one of at most two bytes, use memchr2
	to search for these matching bytes and apply the Aho-Corasick
	algorithm only when a memchr2 match is found.  On my platform,
	this speeds up 'grep -F -e aa -e ba in' by a factor of 7, where
	the file 'in' was created by 'seq -f %040.0f 10000000 >in'.
	* src/kwset.c (struct kwset.gc1): Now int, not char.
	If negative, there is no single terminal byte.  All uses changed.
	(struct kwset.gc1help): Now int, not char.
	If negative, memchr2 cannot be used.
	(kwsprep): Set up gc1 and gc1help from kwset->next, with
	the new (slightly changed) interpretation.
	(memchr_kwset): Use memchr2 if possible.
	Adjust to match new meaning of gc1, gc1help.
	(memoff2_kwset): Remove; no longer needed.
	(acexec_trans): Use memchr_kwset when possible, for speed.
	It now supersedes memoff2_kwset.

	grep: remove Commentz-Walter code
	This code was not being used, and complicated maintenance.
	We can bring it back from the repository if it turns out
	to be useful later.
	* src/kwset.c (struct kwset.reverse): Remove.  All uses of
	FOO->reverse replaced by (FOO->kwsexec == bmexec).
	(kwsalloc): Remove 'reverse' arg, as callers outside this
	module do not care about algorithm choice.  All callers changed.
	(kwsprep): When deciding whether to use Boyer-Moore, do not worry
	about being called twice on the same kwset, as that is not allowed.
	(cwexec): Remove; it was never called.  All uses removed.

2017-01-17  Jim Meyering  <meyering@fb.com>

	maint: avoid new syntax-check failures
	* src/kwset.c (struct kwset): Split a line longer than 80.
	* bootstrap: Update from gnulib. This fixes a new syntax-check
	failure due to its use of "time stamp".

2017-01-17  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Fix typo.

	* src/kwset.c: Fix comment typo.

	Improve -i performance in typical UTF-8 searches
	Currently ‘grep -i i’ is slow in a UTF-8 locale, because ‘i’ in
	the pattern matches the two-byte character 'ı' (U+0131, LATIN
	SMALL LETTER DOTLESS I) in data, and kwset handles only
	single-byte character translations, so grep falls back on a slower
	DFA-based search for all searches.  Improve -i performance in the
	typical case by using kwset when data are free of troublesome
	characters like 'ı', falling back on the DFA only when data
	contain troublesome characters.
	* src/dfasearch.c (GEAcompile):
	* src/grep.c (compile_fp_t):
	* src/kwsearch.c (Fcompile):
	* src/pcresearch.c (Pcompile):
	Pattern arg is now char *, not char const *, since Fcompile
	now reallocates it sometimes.
	* src/grep.c (all_single_byte_after_folding): Remove.
	All callers removed.
	(fgrep_icase_charlen): New function.
	(fgrep_icase_available, try_fgrep_pattern):
	Use it, for more-generous semantics.
	(fgrep_to_grep_pattern): Now extern.
	(main): Do not free keys, since Fexecute may use them.
	* src/kwsearch.c (struct kwsearch): New struct.
	(Fcompile): Return it.  If -i, be more generous about patterns.
	(Fexecute): Use it.  Fall back on DFA when the data contain
	troublesome characters; this should be rare in practice.
	* src/kwset.c, src/kwset.h (kwswords): New function.

	build: update gnulib submodule to latest

2017-01-15  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: prefer ptrdiff_t to size_t
	The code already cannot handle objects with size greater than
	SIZE_MAX / 2, so be more honest about it and use ptrdiff_t instead
	of size_t.  ptrdiff_t arithmetic is signed, which allows for more
	checking via -fsanitize=undefined.  It also makes the code a tad
	smaller on x86-64, since it can test for < 0 rather than for ==
	SIZE_MAX.
	* src/dfasearch.c (struct dfa_comp.kwset_exact_matches):
	(kwsmusts, EGexecute):
	* src/kwsearch.c (Fcompile, Fexecute):
	* src/kwset.c (struct kwset.kwsexec, kwsincr, memchr_kwset)
	(memoff2_kwset, bmexec_trans, bmexec, cwexec, acexec_trans)
	(acexec, kwsexec):
	* src/kwset.h (struct kwsmatch.index, .offset, .size):
	Prefer ptrdiff_t to size_t where either will do.

2017-01-11  Paul Eggert  <eggert@cs.ucla.edu>

	grep: improve comments, mostly in kwset
	Remove kwset.h comments that are obsolete and seemingly not
	maintained anyway; people can look in kwset.c instead.
	Update comments to reflect current behavior better.
	Cite Faro & Lecroq 2013.  Use GNU style for end-of-sentence.

2017-01-01  Jim Meyering  <meyering@fb.com>

	maint: update gnulib and copyright dates for 2017
	* gnulib: Update to latest.
	* all files: Run "make update-copyright".

2016-12-31  Paul Eggert  <eggert@cs.ucla.edu>

	grep: speed up -x with many patterns
	* src/kwsearch.c (Fcompile): Improve buffer allocation overhead
	with -x and multiple patterns.  In the common case where '\n' is
	the end-of-line byte, avoid copying other than the first and last
	patterns.

2016-12-31  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest, fixing a parallel getopt test failure

2016-12-29  Paul Eggert  <eggert@cs.ucla.edu>

	maint: space before paren

	grep: int cleanup in kwset.c
	This should affect only theoretical bugs with very large inputs.
	On my platform, this patch shrinks the grep text by 136 bytes.
	* src/kwset.c: Include intprops.h, for INT_MULTIPLY_WRAPV.
	(struct trie, struct kwset, kwsalloc, kwsincr, treedelta, kwsprep)
	(bm_delta2_search, bmexec_trans, cwexec): Prefer ptrdiff_t to int
	when counts can exceed INT_MAX in large inputs, at least in theory.
	(hasevery): Use bool for booleans.
	(bmexec_trans): Avoid undefined behavior on integer overflow.

2016-12-27  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: improve performance with multiple patterns
	* src/grep.c (main): Avoid fgrep-to-grep conversion for word matching
	with multiple patterns in single byte locales.

2016-12-27  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Fix typo.

	grep: fix bug with '... | grep pat >> /dev/null'
	Problem reported by Benno Fünfstück (Bug#25283).
	* NEWS: Document this.
	* src/grep.c (drain_input) [SPLICE_F_MOVE]:
	Don't assume /dev/null is always acceptable output to splice.
	* tests/grep-dev-null-out: Test for the bug.

2016-12-26  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor performance tweak for pure functions
	* src/search.h (wordchars_size, wordchar_next, wordchar_prev):
	Declare to be pure.

2016-12-25  Zev Weiss  <zev@bewilderbeest.net>

	grep: move localeinfo to grep.c
	It's not really dfasearch-specific, and grep.c initializes it, so it
	seems like the most appropriate "owner".

	* src/dfasearch.c (localeinfo): Remove.
	* src/grep.c (localeinfo): Add.
	* src/search.h (localeinfo): Move to new commented section.

2016-12-25  Zev Weiss  <zev@bewilderbeest.net>

	pcresearch: thread safety
	* src/pcresearch.c (pcre_comp): New struct to hold previously-global
	state.
	(jit_exec): Operate on a pcre_comp parameter instead of global state.
	(Pcompile): Allocate and return a pcre_comp instead of setting global
	variables.
	(Pexecute): Operate on a pcre_comp parameter instead of global state.

	kwsearch: thread safety
	* src/kwsearch.c (Fcompile): Return a kwset_t instead of setting a
	global variable.
	(Fexecute): Use a passed-in kwset_t instead of a global variable.
	(kwset): Remove global variable.

	dfasearch: thread safety
	* src/dfasearch.c (struct dfa_comp): New struct to hold
	previously-global variables.
	(dfawarn): Remove static variable.
	(kwsmusts): Operate on a dfa_comp parameter instead of global
	variables.
	(GEAcompile): Allocate and return a dfa_comp struct instead of setting
	global variables.
	(EGexecute): Operate on a dfa_comp parameter instead of global
	variables.
	* src/searchutils.c (kwsinit): Replace a static array with a
	dynamically-allocated one.

2016-12-25  Zev Weiss  <zev@bewilderbeest.net>

	grep: prepare search backends for thread-safety
	To facilitate removing mutable global state from search backends,
	compile() functions will return an opaque pointer to backend-specific
	data, which must then be passed back into the corresponding execute()
	function.  This is merely a preparatory step changing function
	signatures and call sites, so the pointers passed & returned are
	dummies for now and not (yet) actually used.

	* src/grep.c (compile_fp_t): Now returns an opaque pointer (the
	compiled pattern).
	(execute_fp_t): Now passed the pointer returned by a compile_fp_t.
	All call sites updated accordingly.
	(compiled_pattern): New static variable.
	* src/dfasearch.c (GEAcompile): Return a void pointer (dummy NULL).
	(EGexecute): Receive a void pointer argument (unused).
	* src/kwsearch.c (Fcompile): Return a void pointer (dummy NULL).
	(Fexecute): Receive a void pointer argument (unused).
	* src/pcresearch.c (Pcompile): Return a void pointer (dummy NULL).
	(Pexecute): Receive a void pointer argument (unused).
	* src/search.h: Update compile/execute function prototypes.

2016-12-24  Jim Meyering  <meyering@fb.com>

	maint: fix "syntax-check" failure
	* src/grep.c (SEP_STR_GROUP): Declare "static".

2016-12-23  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix comment in searchutils.c

	grep: improve word checking with UTF-8
	* src/searchutils.c: Do not include <verify.h>.
	(word_start): Remove, replacing with ...
	(sbwordchar): New static var.  All uses changed.
	(wordchar_prev): Return size_t, not bool, as this generates
	slightly better code.  Go back faster if UTF-8.

	grep: standardize on localeinfo.multibyte
	* src/dfasearch.c (EGexecute):
	* src/grep.c (main):
	* src/kwsearch.c (Fexecute):
	* src/pcresearch.c (Pcompile):
	Prefer localeinfo.multibyte to (MB_CUR_MAX > 1).

	grep: speed up -wf in C locale
	Problem reported by Norihiro Tanaka (Bug#22357#100).
	This patch improves the performance on that benchmark on my
	platform so that grep is now only about 2x slower than grep 2.26,
	which means it is considerably faster than grep 2.25 and earlier.
	* src/kwsearch.c (Fexecute):
	Use wordchars_size to boost performance for this case.
	* src/search.h, src/searchutils.c (wordchars_size): New function.

	grep: specialize word-finding functions
	This improves performance a bit.
	* src/dfasearch.c, src/kwsearch.c (wordchar):
	Remove; now in searchutils.c.
	* src/grep.c (main): Call wordinit if -w.
	* src/search.h: Adjust.
	* src/searchutils.c: Include verify.h.
	(word_start): New static var.
	(wordchar): Move here from dfasearch.c and kwsearch.c.
	(wordinit, wordchars_count, wordchar_next, wordchar_prev):
	New functions.
	(mb_prev_wc, mb_next_wc): Remove.
	All callers changed to use the new functions instead.

	grep: simplify Fexecute
	* src/kwsearch.c (Fexecute): Avoid the need for a 'try' local or
	for a 'goto success'.  Update mb_start to reflect newline found.

	grep: remove C label
	* src/kwsearch.c (Fexecute): Remove label.

	maint: rewrite to avoid some macros
	These days, the dangerous powers of C macros are not needed if
	constants or functions will do just as well.
	* src/grep.c (SEP_CHAR_SELECTED, SEP_CHAR_REJECTED, SEP_STR_GROUP)
	(INITIAL_BUFSIZE):
	* src/kwset.c (DEPTH_SIZE):
	Now constants, not macros.
	* src/kwset.c (link): Remove macro. Instead, rename local vars
	from 'link' to 'cur'.
	(malloc) [GREP]: Remove macro.  All uses of malloc changed to xmalloc.
	Omit double-inclusion of xalloc.h.  Do not depend on 'GREP'.
	(U): Now a function, not a macro.
	* src/kwset.c, src/searchutils.c (NCHAR): Move this macro to ...
	* src/system.h: ... here, and make it a constant.

2016-12-20  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix performance with multiple patterns
	Problem reported by Jaroslav Skarvada (Bug#22357).
	* NEWS: Document this and other recent performance fixes.
	* src/grep.c (E_MATCHER_INDEX): New constant.
	(all_single_byte_after_folding):
	New function, split out from fgrep_icase_available.
	(fgrep_icase_available): Use it.
	(try_fgrep_pattern): New function, which also uses it.
	(main): With two or more patterns, use try_fgrep_pattern to fix
	performance regression.  The number "two" here is just a heuristic.

	grep: simplify matcher configuration
	* src/grep.c (matcher, compile): Remove static vars.
	(compile_fp_t): Now takes a 3rd syntax argument.
	(Gcomppile, Ecompile, Acompile, GAcompile, PAcompile): Remove.
	(struct matcher): Now nameless, since it is used only once.
	Make 'name' a bit shorter.  New member 'syntax'.
	(matchers): Initialize it, and change removed functions to GEAcompile.
	(F_MATCHER_INDEX, G_MATCHER_INDEX): New constants.
	(setmatcher): New arg MATCHER, and return new matcher index.
	Avoid unnecessary call to strcmp.
	(main): Keep matcher as a local int, not a global pointer.
	* src/kwsearch.c (Fcompile):
	* src/pcresearch.c (Pcompile): Ignore the 3rd syntax argument.

	grep: simplify line counting in patterns
	* src/grep.c (n_patterns): Rename from patfile_lineno,
	as it is now origin-zero.  Now size_t, not uintmax_t.
	(count_nl_bytes, fl_add): Simplify to just buffer and size.
	All callers changed.

2016-12-19  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2016-12-18  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	build: update gnulib submodule to latest

2016-12-13  Jim Meyering  <meyering@fb.com>

	tests: use just-built grep in more places
	* cfg.mk (PATH): Prepend $(srcdir)/src, so that we use the just-
	built grep also when running commands like those of "make distcheck".
	This would have avoided the recently-luckily-noticed infloop bug.
	Tested by running this in a just-built directory:
	f=src/grep; printf '%s\n' '#!/bin/sh' 'sleep 9h' > $f; chmod a+x $f
	and then verifying that nearly every "make syntax-check" rule hangs.

	maint: tell "syntax-check" not to worry about the NEWS update
	Whenever we change "old" NEWS, we have to update this checksum.
	Otherwise, a "make syntax-check" test that guards against a class
	of logical merge conflicts will fail.
	* cfg.mk (old_NEWS_hash): Update this hash to accommodate the
	recent clarification of a 2.27 NEWS entry.

2016-12-13  Arnold D. Robbins  <arnold@skeeve.com>

	build: update gnulib submodule to latest
	* src/dfasearch.c (GEAcompile): Remove use of flag, RE_ICASE covers it.

2016-12-12  Paul Eggert  <eggert@cs.ucla.edu>

	grep: work around proc lseek glitch
	Problem reported by Andreas Schwab (Bug#25180).
	* NEWS: Document this.
	* src/grep.c (finalize_input): Ignore EINVAL lseek failures.
	* tests/Makefile.am (TESTS): Add proc.
	* tests/proc: New file.

2016-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	grep: simplify finalize_input
	* src/grep.c (finalize_input): Simplify without changing behavior.
	It's still a bit of a rat's-nest, but it's a cozier rat's-nest.

	maint: clarify early-exit news for 2.27
	* NEWS: Mention early-exit options to avoid confusion.  See:
	http://lists.gnu.org/archive/html/grep-devel/2016-12/msg00007.html

2016-12-06  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.27
	* NEWS: Record release date.

2016-11-29  Jim Meyering  <meyering@fb.com>

	grep: fix DFA-induced infloop
	* gnulib: Update to latest, for the DFA infloop fix.
	* tests/dfa-infloop: New test, to trigger an infinite loop
	in the DFA matcher.
	* tests/Makefile.am (TESTS): Add it.

2016-11-28  Jim Meyering  <meyering@fb.com>

	tests: use "returns_ N env VAR=val ..."
	rather than "VAR=val returns_ N ..."
	Some shells do not propagate envvar settings through our use
	of the "returns_" function, so set any envvar via use of "env".
	This was an issue at least on Ubuntu and Debian-based systems,
	presumably due to their common use of "dash" as /bin/sh.
	Reported by Assaf Gordon.
	* tests/char-class-multibyte: As above.
	* tests/euc-mb: Likewise.
	* tests/false-match-mb-non-utf8: Likewise.
	* tests/pcre-infloop: Likewise.
	* tests/pcre-jitstack: Likewise.
	* tests/sjis-mb: Likewise.
	* tests/warn-char-classes: Likewise.

2016-11-28  Paul Eggert  <eggert@cs.ucla.edu>

	tests: revert check for unibyte French range bug
	The test wasn't portable, as it assumed that rational ranges
	were not in effect.  Problem reported by Eric Blake (Bug#25048#8).
	There doesn't seem to be a portable way to do the test, so omit it.
	* tests/init.cfg, tests/unibyte-bracket-expr:
	Revert previous change.

	build: update gnulib submodule to latest

2016-11-27  Jim Meyering  <meyering@fb.com>

	grep: avoid false matches in non-UTF8 multibyte locales
	* gnulib: Update to latest, for the dfa.c fix.
	* NEWS (Bug fixes): Mention it.
	* tests/false-match-mb-non-utf8: New file, with tests for this.
	Based on tests from Stephane Chazelas.
	* tests/Makefile.am (TESTS): Add it.
	Introduced by commit v2.18-54-g3ef4c8e, a change that made grep use
	its DFA matcher more aggressively.  The malfunction arises only with
	the DFA matcher, not with regex.
	Reported by Stephane Chazelas in https://bugs.gnu.org/24975

2016-11-20  Paul Eggert  <eggert@cs.ucla.edu>

	tests: check for unibyte French range bug
	Problem reported by Stephane Chazelas (Bug#24973).
	This bug was fixed in Gnulib.
	* NEWS: Document the fix.
	* tests/init.cfg (require_ru_RU_koi8_r): Remove.
	* tests/unibyte-bracket-expr: Add a test for the bug.
	Call get-mb-cur-max directly instead of bothering with
	require_ru_RU_koi8_r.

	build: update gnulib submodule to latest

2016-11-19  Paul Eggert  <eggert@cs.ucla.edu>

	grep: further -P performance fix
	Problem reported by Stephane Chazelas in:
	http://bugs.gnu.org/22655#103
	* src/pcresearch.c (Pexecute): Set the subject to the start of
	each line as it is found.

	grep: -P no longer uses PCRE_MULTILINE
	This reverts commit f6603c4e1e04dbb87a7232c4b44acc6afdf65fef,
	as the extra performance is not worth the trouble for PCRE users.
	Problem reported by Stephane Chazelas in:
	http://bugs.gnu.org/22655#103
	* NEWS: Document this and the next patch.
	* src/dfasearch.c (EGexecute):
	* src/grep.c (execute_fp_t):
	* src/kwsearch.c (Fexecute):
	* src/pcresearch.c (Pexecute):
	First arg is now a const pointer again.
	* src/grep.c (buf_has_encoding_errors): Now static.
	* src/grep.h (buf_has_encoding_errors): Remove decl.
	* src/search.h: Adjust decls.
	* src/pcresearch.c (reflags): Remove.  All uses removed.
	(Pcompile, Pexecute): Do not use PCRE_MULTILINE.

2016-11-19  Jim Meyering  <meyering@fb.com>

	doc: fix a doubled "the"
	* doc/grep.texi (--perl-regexp): s/the\nthe/the/

2016-11-19  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix -zxP bug
	* NEWS: Document this.
	* src/pcresearch.c (Pcompile): Search a line at a time if -x is
	used, since -x uses ^ and $.
	* tests/pcre: Test this.

	grep: simplify by using PRIuMAX
	* configure.ac (HAVE_PRINTF_C99_SIZES): Remove; no longer needed.
	* src/grep.c (print_offset): Simplify (Bug#24451).

	grep: -T now adjusts number widths for worst case
	* NEWS, doc/grep.texi (Output Line Prefix Control):
	Document this (Bug#24451).
	* src/grep.c (offset_width): New static var.
	(print_offset): Use it instead of arg.  All callers changed.
	(grep): Set it.
	* tests/initial-tab: Test this.

	grep: -T no longer outputs BS
	* NEWS: Document this (Bug#24451).
	* src/grep.c (print_line_head): Do not attempt to backspace output.
	* tests/initial-tab: New test.
	* tests/Makefile.am (TESTS): Add it.

	grep: document -oz better
	* doc/grep.texi (General Output Control, Usage): Tweak (Bug#24961).

	grep: fix performance typo with -P
	Reported by Zev Weiss in: http://bugs.gnu.org/22655#88
	* src/pcresearch.c (Pcompile): Initialize reflags.

	tests: use "returns_" rather than "$?"
	* tests/grep-dev-null-out: Use "returns_ 124" rather than testing
	$? = 124.

	grep -f /dev/null -L PAT FILE outputs FILE
	* NEWS: Document this.
	* src/grep.c (main): Do not exit right away with -L.
	* tests/skip-read: Test for the fix.

	grep: tune -f /dev/null
	* src/grep.c (main): Do the -f /dev/null early-exit checks before
	more-expensive tests that involve syscalls.

	grep: treat -f /dev/null like -m0
	* NEWS: Document this.
	* src/grep.c (main): With -f /dev/null, don't bother to read the
	input.  This is what FreeBSD grep does.
	* tests/Makefile.am (TESTS): Add skip-read.
	* tests/skip-read: New file.

	grep: avoid O(N**2) buffer reallocation
	* src/grep.c (main): Use x2realloc to avoid O(N**2) performance as
	pattern buffers grow.

	grep: avoid unnecessary gettext call
	Translate "(standard input)" lazily.
	* src/grep.c (input_filename): New function.
	(suppressible_error): Remove 1st arg, since it is always
	input_filename ().  All callers changed.
	(suppressible_error, print_filename, grep, grepdesc): Use it.
	(grep_command_line_arg): Set filename to NULL if standard
	input has no label.  Often, this avoids all calls to gettext,
	which can be a win as the first call can be expensive.

	grep: drain the input pipe faster
	* src/grep.c (dev_null_output): Now static.
	(drain_input): New function, using 'splice' if that makes sense.
	(finalize_input): Use it.
	(main): Omit now-unnecessary initialization.

	grep: scale back /dev/null speedup
	The performance improvement when output is /dev/null (commit
	af6af288eac28951b5eee1eaaf373e22b2193b7b dated 2016-05-01)
	breaks scripts that run "PROGRAM | grep PATTERN >/dev/null"
	where PROGRAM dies when writing into a broken pipe.
	Suppress the improvement if standard input is not seekable.
	Problem reported by Gary Johnson (Bug#24941).
	* NEWS: Document this.
	* src/grep.c (seek_failed): New static var.
	(seek_data_failed): Move decl earlier, to be next to seek_failed.
	(file_must_have_nulls): Skip useless syscalls if seek_failed.
	Lessen source-code nesting.
	(reset): Set seek_failed and seek_data_failed.
	Try lseek even on non-regular files.
	(grep): New arg INEOF.  All callers changed.
	Do not clear seek_data_failed here, since 'reset' now does this.
	(finalize_input): New static function.
	(grepdesc): Use it.
	(main): Do not exit on first match merely because output is
	/dev/null.
	* tests/grep-dev-null-out: Adjust to new behavior.

	grep: improve diagnostic on lseek failure
	* src/grep.c (reset): Mention the file name in the (unlikely)
	chance of an lseek failure.

	grep: avoid unnecessary isatty calls
	This fixes an inefficiency that was mistakenly introduced a while
	back, when the macro SET_BINARY became defined on all platforms.
	* src/grep.c (grepdesc, main): Do not unecessarily call isatty on
	POSIXish platforms.

	grep: -Pz no longer rejects ^, $
	Problem reported by Stephane Chazelas (Bug#22655).
	* NEWS: Document this.
	* doc/grep.texi (grep Programs): Warn about -Pz.
	* src/pcresearch.c (reflags): New static var.
	(multibyte_locale): Remove static var; now local to Pcompile.
	(Pcompile): Check for (? and (* too.  Set reflags instead of
	dying when problematic operators are found.
	(Pexecute): Use reflags to decide whether searches should
	be multiline.
	* tests/pcre: Test new behavior.

2016-11-14  Jim Meyering  <meyering@fb.com>

	tests: use "returns_" rather than explicit comparison with "$?"
	* tests/sjis-mb (encode): Rearrange to emit desired input into
	a file, rather than piping directly into grep.  That permits
	the use of returns_ 1 to verify timeout's exit status.
	* tests/euc-mb: Use "returns_ 1" rather than testing $? = 1
	* tests/char-class-multibyte: Likewise.
	* tests/dfa-heap-overrun: Likewise.
	* tests/encoding-error: Likewise.
	* tests/fedora: Likewise.
	* tests/grep-dev-null: Likewise.
	* tests/init.cfg (envvar_check_fail): Likewise.
	* tests/kwset-abuse: Likewise.
	* tests/mb-non-UTF8-overrun: Likewise.
	* tests/multibyte-white-space: Likewise.
	* tests/pcre-infloop: Likewise.
	* tests/surrogate-pair: Likewise.
	* tests/warn-char-classes: Likewise.
	Do the same for other values:
	* tests/backref-multibyte-slow: Likewise.
	* tests/euc-mb: Likewise.
	* tests/pcre-abort: Likewise.
	* tests/pcre-jitstack: Likewise.
	* tests/repetition-overflow: Likewise.
	* tests/reversed-range-endpoints: Likewise.
	* tests/warn-char-classes: Likewise.

2016-10-26  Jim Meyering  <meyering@fb.com>

	doc: grep builds on HP-UX once again
	* NEWS (Bug fixes): Mention the HP-UX fix.

	gnulib: update to latest, for getprogname HPUX port

2016-10-22  Mark Veltzer  <mark.veltzer@gmail.com>

	ignore coverage generated files

	ignore ar-lib in build-aux

2016-10-20  Zev Weiss  <zev@bewilderbeest.net>

	grep: use 'j' intmax_t printf length modifier if supported
	* configure.ac: Use gl_PRINTF_SIZES_C99 to test printf and
	(conditionally) define HAVE_PRINTF_C99_SIZES.
	* src/grep.c (print_offset): Use printf("%j...") for printing
	[u]intmax_t if HAVE_PRINTF_C99_SIZES is defined; otherwise continue
	using the existing hand-rolled loop.

2016-10-15  Jim Meyering  <meyering@fb.com>

	build: distribute new file, die.h, so "make distcheck" passes
	* src/Makefile.am (grep_SOURCES): Add die.h.
	Also, sort these file names.

2016-10-10  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2016-10-09  Jim Meyering  <meyering@fb.com>

	maint: die.h: add the "#define ..." part of double inclusion guard
	* src/die.h (DIE_H): Define to 1.

2016-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	grep: don't assume stdbool.h before die call
	* src/die.h: Include stdbool.h, since 'die' uses 'false'

	grep: die more systematically
	* src/die.h: New file.
	* src/dfasearch.c, src/grep.c, src/pcresearch.c: Include die.h.
	* src/dfasearch.c (dfaerror):
	* src/grep.c (context_length_arg, add_count, prline, setmatcher, main):
	* src/pcresearch.c (jit_exec, Pcompile, Pexecute):
	Use 'die' instead of 'error' when exiting.
	* src/pcresearch.c: Do not include verify.h.
	(die): Remove; now in die.h.
	* src/search.h: Do not include error.h here, since this file does
	not use anything defined in error.h.  Instead, dfasearch.c, which
	uses error.h's symbols, now includes error.h directly.

2016-10-02  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.26
	* NEWS: Record release date.

2016-10-01  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest; for getprogname fix

2016-10-01  Paul Eggert  <eggert@cs.ucla.edu>

	tests/grep-dir: port to Solaris 10
	* tests/grep-dir: Port to Solaris 10 'cat', which
	exits with status 0 even after 'read' fails from a directory.

2016-09-28  Jim Meyering  <meyering@fb.com>

	build: placate GCC 7's -Wimplicit-fallthrough
	* src/pcresearch.c (die): New macro.
	(Pexecute): Use it in place of offending uses of error,
	to placate GCC 7's -Wimplicit-fallthrough.
	Include verify.h.  Since this is grep's first explicit use of this
	gnulib module, ...
	* bootstrap.conf (gnulib_modules): Add verify.

	gnulib: update to latest; for ...
	This includes the following:
	 - a getprogname-vs-openbsd-5.1 portability fix
	 - "fallthru" comment-adding changes for dfa and unistr/u8-uctomb-aux.c
	 - another getprograme fix to avoid breaking newer glibc

2016-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	build: reword .git old-GCC warning
	* configure.ac (gl_gcc_warnings): Reword diagnostic.
	Suggested by Assaf Gordon in:
	http://lists.gnu.org/archive/html/grep-devel/2016-09/msg00024.html

	build: port .git builds to newer GCC
	* configure.ac (gl_gcc_warnings): Omit duplicate copy of 'main'.
	Problem reported by Assaf Gordon in:
	http://lists.gnu.org/archive/html/grep-devel/2016-09/msg00024.html

	build: port .git builds to older GCC
	Problem reported by Dagobert Michelsen in:
	http://lists.gnu.org/archive/html/grep-devel/2016-09/msg00018.html
	* configure.ac (gl_gcc_warnings): Default to false if .git
	exists but GCC is too old.

2016-09-27  Jim Meyering  <meyering@fb.com>

	tests/long-pattern-perf: avoid false-failure due to cache speed
	* tests/long-pattern-perf: This test would fail semi-consistently
	on some systems, probably because the smaller regexp fit well
	within cache, yet the larger one did not.  In that case, there
	was a relative speed difference greater than 20x and the test
	would fail.  Quadruple the sizes, to make that less likely.
	Also, construct the 10x larger regexp directly from the smaller,
	rather than relying on seq with endpoints to induce that
	approximate size ratio.  Reported by Bruce Dubbs in
	https://lists.gnu.org/archive/html/grep-devel/2016-09/msg00013.html

2016-09-24  Jim Meyering  <meyering@fb.com>

	build: avoid "./configure && make dist" missing-dep. failure
	* Makefile.am (run-syntax-check): Depend on "all", to avoid a
	parallel build failure due to a missing dependency. Reported by
	Paul Eggert in https://bugs.gnu.org/24256#50

2016-09-24  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2016-09-24  Jim Meyering  <meyering@fb.com>

	tests/fmbtest: avoid false-failure due to reliance on MB-correct sed
	* tests/fmbtest: Several of these tests would mistakenly fail due to
	postprocessing with a combination of sed and locale support that failed
	to handle some multibyte characters in the cs_CZ.UTF-8 locale.  Instead
	of relying on sed's multibyte support or anything locale-related to
	perform this simple filtering, just use this: tr -cs '0-9' '[ *]'
	Also, rather than exporting LC_ALL, just set it for each command.
	Reported by Nelson H. F. Beebe.
	https://bugs.gnu.org/24534

	tests: revamp multibyte-white-space test to be more permissive
	This test elicits too many failures.  Whether a system has accurate
	unicode "whitespace" attributes should not influence whether grep's
	test suite passes.  In many cases, now you will see a warning that
	some multibyte characters do not pass whitespace-related tests, but
	this test no longer fails.  However, if you run this test on a modern
	enough system, it does require that \s and \S do work properly with
	most of the listed characters.
	* tests/multibyte-white-space: Confirm that Fedora 24's locale
	tables still declare those four Unicode code points *not* whitespace.
	Honor a new column telling how to handle failure.  Provide more
	information in each diagnostic.
	Reported by Nelson H. F. Beebe.
	https://bugs.gnu.org/24530

	tests: avoid erroneous failure of pcre-jitstack test
	On some systems (*BSD), 'ulimit -s unlimited' would fail, yet the
	test for that mistakenly masked the failure, so the following grep
	command ended up failing with a segfault.
	* tests/pcre-jitstack: Don't mask the ulimit failure.
	Reported privately by Nelson H. F. Beebe.
	https://bugs.gnu.org/24524

2016-09-23  Jim Meyering  <meyering@fb.com>

	grep: avoid unwarranted "input file 'F' is also the output" on *BSD
	On *BSD systems, any command like "echo y | grep x", where grep reads
	from a pipe and writes to standard output, would mistakenly emit this:
	  grep: input file '(standard input)' is also the output
	* src/grep.c (grepdesc): Ensure that the file descriptor we're
	reading is a regular one before using SAME_INODE to test whether
	it is the same as the descriptor open on standard output.
	Nelson Beebe reported privately that the foad1 tests failed on many
	BSD systems.  Exposed by commit v2.25-2-gaf6af28.
	https://bugs.gnu.org/24522

	tests: avoid backref-multibyte-slow false failure
	* tests/backref-multibyte-slow (max_seconds): If we calculate
	a max duration of 1 second, use 5.  Otherwise, on high-latency
	systems, it would be way too easy for the duration of the final
	test run to exceed that limit.  Reported by Nelson H. F. Beebe.
	http://bugs.gnu.org/24516

2016-09-22  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest; for getprogname-vs-AIX fix

2016-09-18  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: add news entry for fix to bug#24233
	* NEWS (Bug fixes): Add an entry describing bug#24233.
	The bug was fixed by commit v2.25-77-gad468bb, by chance.

2016-09-15  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

2016-09-10  Jim Meyering  <meyering@fb.com>

	dfa: reflect move of grep's DFA code to gnulib
	Now that the core DFA code and tests reside in gnulib,
	remove the copies here and use what gnulib provides.
	* bootstrap.conf: Use the dfa module.
	* cfg.mk: Remove settings involving files that have moved.
	(_gl_TS_unmarked_extern_functions): Add dfaerror and dfawarn.
	It is wrong/ugly to have to define these global symbols to use
	the dfa module, but we'll adjust that separately.
	* po/POTFILES.in: Apply s/src/lib/ to src/dfa.c.
	* src/Makefile.am: Remove mention of dfa.[ch] and localeinfo.[ch].
	* tests/Makefile.am: Remove mention of the tests that we have
	moved to the gnulib module.
	* src/dfa.c: Remove file.
	* src/dfa.h: Likewise.
	* src/localeinfo.c: Likewise.
	* src/localeinfo.h: Likewise.
	* tests/dfa-match: Likewise.
	* tests/dfa-match-aux.c: Likewise.
	* tests/invalid-char-class: Likewise.

	gnulib: update to latest, for new dfa module

2016-09-08  Paul Eggert  <eggert@cs.ucla.edu>

	grep: encoding errors suppress just their line
	From a suggestion by Marcello Perathoner (Bug#22838).
	* NEWS, doc/grep.texi (File and Directory Selection): Document this.
	* src/grep.c (print_line_head): Do not suppress later output lines
	merely because an earlier output line would have had an encoding error.
	* tests/encoding-error: Test for the new behavior.

2016-09-08  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest, for getprogname fixes

2016-09-08  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: additional change new option for anchored searches
	* src/dfa.c (dfaexec_main): Do it.

2016-09-07  Paul Eggert  <eggert@cs.ucla.edu>

	doc: define "context lines"
	Reported by Igor Bogomazov via Santiago Ruano Rincón (Bug#24024).
	* doc/grep.texi (Context Line Control): Define "context lines".

	build: update gnulib submodule to latest

2016-09-05  Jim Meyering  <meyering@fb.com>

	maint: switch from gnulib's progname to getprogname module
	* gnulib: Update to latest, for its new getprogname module.
	* bootstrap.conf (avoided_gnulib_modules): Include the getprogname
	module rather than the now-obsolescent progname.
	* src/grep.c: Include "getprogname.h" rather than "progname.h"
	and remove any use of set_program_name.
	* tests/dfa-match-aux.c (main): Likewise.
	* tests/get-mb-cur-max.c (main): Likewise.
	* src/grep.c (usage, main): Use getprogname() in place of program_name.

2016-09-02  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: minor cleanup of previous change
	* src/dfa.c (dfaexec_main): Omit redundant code and reindent.

2016-09-02  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: additional change new option for anchored searches
	* src/dfa.c (dfaexec_main): Do it.

	dfa: use single-byte algorithm even in non-UTF-8
	* src/dfa.c (dfaexec_main): Do it.  (This was inadvertently
	omitted in a recent patch.)

2016-09-02  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: merge xalloc.h changes from Gawk
	* src/dfa.h (_GL_ATTRIBUTE_MALLOC): Define here, as other
	Gnulib .h files do.  This is more consistent with Gawk.
	* src/dfa.c: Include xalloc.h, since dfa.h no longer does so.
	Include localeinfo.h later; we don't care about order, but Gawk does.

2016-09-02  Arnold Robbins  <arnold@skeeve.com>

	dfa: port to C90
	* src/dfa.c (dfamust): Avoid declarations after statement (Bug#21486).

2016-09-02  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: new option for anchored searches
	This follows up on a suggestion by Norihiro Tanaka (Bug#24262).
	* src/dfa.c (struct regex_syntax): New member 'anchor'.
	(char_context): Use it.
	(dfasyntax): Change signature to specify it, along with the old
	FOLD and EOL args, as a single DFAOPTS arg.  All uses changed.
	* src/dfa.h (DFA_ANCHOR, DFA_CASE_FOLD, DFA_EOL_NUL): New constants
	for dfasyntax new last arg.

2016-09-02  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: simplify and optimize at initial state in execution
	* src/dfa.c (skip_remains_mb): Remove argument *pwc.  Update calller.
	(dfaexec_main): Simplify and optimize at initial state (Bug#24261).

	dfa: simplify to find state index for state 0
	* src/dfa.c (dfastate): Simplify to find state index for state 0.

2016-09-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	tests: add a new test for SJIS locale
	* tests/sjis-mb: Add a new test.  It fails in grep-2.25 or prior.

2016-09-01  Paul Eggert  <eggert@cs.ucla.edu>

	grep: update NEWS
	* NEWS: Describe previous change.

	grep: use regex fastmap unless -i
	This builds on a suggestion by Norihiro Tanaka (Bug#24009).
	* src/dfasearch.c (GEAcompile): Use a fastmap unless -i.
	This improves performance 20x for me using the first benchmark
	given in Bug#24009.

	grep: improve dfasearch storage management
	This patch is mostly refactoring, with a bit of performance tweaking.
	It is done in preparation for a fix for Bug#24009.
	* src/dfasearch.c (patterns): Now of type struct re_pattern_buffer *
	instead of an anonymous struct pointer, since there is no longer
	any need to keep regs here.  All uses changed.
	(GEAcompile): Use patlim instead of a hard-to-follow "total".
	Use x2nrealloc to avoid potential O(N**2) reallocation algorithm.
	Initialize just the pattern members that need clearing.
	(EGexecute): Put regs into a static variable, as this code did
	before 2001-02-18, as there is no need to have a separate set of
	regs for each pattern.  Explain the "Q@#%!#" comment better.

2016-09-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: remove separation by context in transition in non-UTF8 multibyte locales
	* src/dfa.c (struct dfa): Remove member curr_dependent.  All uses
	removed.

2016-09-01  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: document previous change
	* NEWS: Adjust to match previous change.

2016-09-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: avoid invalid character matching period
	* dfa.c (transit_state): Avoid invalid character matching period.

	dfa: use single-byte algorithm even in non-UTF-8
	Even in non-UTF8 locales, if the current input character
	is single byte, we can use CSET to match ANYCHAR.
	* src/dfa.c (struct dfa): New member canychar.
	Cache index of CSET for ANYCHAR.
	(lex): Make CSET for ANYCHAR.
	(state_index): Simplify.
	(dfastate): Consider CSET for ANYCHAR.
	(transit_state_singlebyte, transit_state): Remove handling for eolbyte,
	as we assume that eolbyte does not appear at current position.
	(dfaexec_main): Use algorithm for single byte character to any single
	byte character in input text always.
	(dfasyntax): Initialize canychar.

2016-09-01  Paul Eggert  <eggert@cs.ucla.edu>

	grep: avoid code duplication with -iF
	This follows up on the -iF performance improvement (Bug#23752).
	* NEWS: Simplify description of -iF improvement.
	* src/dfa.c: Do not include wctype.h.
	(lonesome_lower, case_folded_counterparts): Move to localeinfo.c.
	(CASE_FOLDED_BUFSIZE): Move to localeinfo.h.
	* src/grep.c: Do not include wctype.h.
	(lonesome_lower): Remove.
	(fgrep_icase_available): Use case_folded_counterparts instead.
	Do not call it for the same character twice.
	Return false on wcrtomb failures (which should never happen).
	(fgrep_to_grep_pattern, main): Simplify.  Let fgrep_to_grep’s
	caller fiddle with the global variables.
	* src/localeinfo.c: Include <wctype.h>
	(lonesome_lower, case_folded_counterparts):
	Move here from src/dfa.c.  Return int, not unsigned int.
	Verify that CASE_FOLDED_BUFSIZE is big enough.
	* src/localeinfo.h (CASE_FOLDED_BUFSIZE): Now 32, so that
	we don’t expose lonesome_lower’s size.
	* src/searchutils.c (kwsinit): Return new kwset instead of
	storing it via a pointer.  All callers changed.  Simplify a bit.

2016-09-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: speed up -iF in multibyte locales
	In a multibyte locale, if a pattern is composed of only single byte
	characters and their all counterparts are also single byte characters
	and the pattern does not have invalid sequences, grep -iF uses the
	fgrep matcher, the same as in a single byte locale (Bug#23752).
	* NEWS: Mention it.
	* src/grep.c (lonesome_lower): New constant.
	(fgrep_icase_available): New function.
	(fgrep_to_grep_pattern): Simplify it.
	(main): Use them.
	* src/searchutils.c (kwsinit): New arg MB_TRANS; all uses changed.
	Try fgrep matcher for case insensitive matching by grep -F in multibyte
	locale.

2016-08-31  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2016-08-31  Jim Meyering  <meyering@fb.com>

	maint: avoid new 'make syntax-check' failure
	* src/dfa.c (using_simple_locale): Prefer STREQ(a,b) over
	strcmp(a,b) == 0.

	gnulib: update to latest

2016-08-31  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: make dfa.c fully thread-safe
	This follows up on Zev Weiss’s recent patches to make the DFA code
	thread-safe (Bug#24249).  It removes the remaining static
	variables used by dfa.c.  These variables are locale-dependent, so
	they would cause problems in multithreaded code where different
	threads are in different locales (e.g., via uselocale).  I
	abstracted most of the variables into a new localeinfo module.
	* src/Makefile.am (grep_SOURCES): Add localeinfo.c.
	(noinst_HEADERS): Add localeinfo.h.
	* src/dfa.c: Include localeinfo.h.
	(struct dfa): Remove multibyte member, as it is now part of
	localeinfo.  New members simple_locale and localeinfo.
	Put locale-related members at the end.
	(mbrtowc_cache): Remove; now part of dfa->localeinfo.
	(charclass_index): Rename back from dfa_charclass_index,
	since it's private.
	(unibyte_word_constituent): New arg DFA; use its sbctowc member.
	(using_utf8, dfa_using_utf8, init_mbrtowc_cache, check_utf8):
	Remove; now done by localeinfo members.  All uses changed.
	(dfasyntax): New localeinfo arg.  Move to end to avoid forward decls.
	Initialize the entire DFA.
	(unibyte_c, check_unibyte_c): Remove; now in simple_locale member.
	(using_simple_locale): Now takes bool instead of DFA.
	Do the locale check here, rather than in the caller,
	as the result is now cached in dfa->simple_locale.
	(dfaalloc): Just allocate the DFA.  dfasyntax now initializes it.
	* src/dfa.h: Add forward decl of struct localeinfo.
	Adjust to new dfa.c API.
	* src/dfasearch.c (localeinfo): New var, replacing former static
	vars like mbrtowc_cache.
	* src/localeinfo.c, src/localeinfo.h: New files.
	* src/search.h: Include localeinfo.h.
	(localeinfo): New decl.
	* src/searchutils.c (mbclen_cache, build_mbclen_cache):
	Remove.  All uses changed to localeinfo.
	* tests/Makefile.am (dfa_match_aux_LDADD): Add localeinfo.o.
	* tests/dfa-match-aux.c: Include localeinfo.h.
	(main): Adjust to changes in DFA API.

2016-08-28  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest
	This should fix Bug#24323 reported by Dennis Clarke, where grep
	does not build on Solaris 10 when compiled with Solaris Studio 12.4.

2016-08-23  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: minor thread-safety cleanups
	* src/dfa.c (struct lexer_state): Rename lexptr to ptr and lexleft
	to left, for brevity.  All uses changed.
	(struct dfa): Rename lexstate to lex and parsestate to parse,
	for brevity.  All uses changed.
	(using_simple_locale): Simplify boolean expression.
	(FETCH_WC): Parenthesize uses of dfa macro arg.
	(FETCH_WC, parse_bracket_exp, addtok_mb): Prefer suffix operators
	on structure members when possible, for clarity.
	(parse_bracket_exp): Check for buffer exhaustion before
	dereferencing buffer pointer.
	(struct lexptr): New type.
	(push_lex_state, pop_lex_state): Use it.  Change from macros
	PUSH_LEX_STATE and POP_LEX_STATE to static functions, and add
	parameters to make them proper C functions.  All uses changed.
	(lex): Simplify tests for \) and \|.  Avoid some string
	duplication by using &"^..."[boolean].
	(dfaalloc): Use xzalloc, not xcalloc with 1.

2016-08-21  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor tweaks of initial buffer alloc
	* src/grep.c (main): Allocate input buffer only when about
	to do I/O.  Avoid int overflow on systems with 2 GiB pages.
	Fix size_t overflow check.

2016-08-20  Zev Weiss  <zev@bewilderbeest.net>

	dfa: constify some function parameters
	* src/dfa.c (char_context): Mark dfa parameter const.
	(charclass_context): Likewise.

	dfa: thread-safety: initialize mbrtowc_cache in dfa_init
	* src/dfa.c (dfasyntax): Remove initialization of mbrtowc_cache.
	(init_mbrtowc_cache): New function.
	(dfa_init): Call it.
	http://bugs.gnu.org/24259

	dfa: thread-safety: eliminate static local variables
	* src/dfa.c: Replace utf8 and unibyte_c static local variables with
	static globals initialized by a new function dfa_init() which must be
	called before any other dfa*() functions.
	(dfa_using_utf8): Rename using_utf8() to dfa_using_utf8() for
	consistency with other exported functions.
	* src/dfa.h (dfa_using_utf8): Rename using_utf8() to dfa_using_utf8();
	also add _GL_ATTRIBUTE_PURE.
	(dfa_init): New function.
	* src/grep.c (main), tests/dfa-match-aux.c (main): Call dfa_init().
	* src/dfasearch.c (EGexecute): Replace using_utf8 with dfa_using_utf8.
	* src/kwsearch.c (Fexecute): Likewise.
	* src/pcresearch.c (Pcompile): Likewise.
	http://bugs.gnu.org/24259

	dfa: thread-safety: move regex syntax configuration into struct dfa
	* src/dfa.c: move global variables holding regex syntax configuration
	into a new struct (`struct regex_syntax') and add an instance of it to
	struct dfa.  All references to the globals are replaced with
	references to the dfa struct's new member.  As a side effect, a
	`struct dfa' must be allocated with dfaalloc() and passed to
	dfasyntax().
	* src/dfa.h (dfasyntax): Add new struct dfa* parameter.
	* src/dfasearch.c (GEAcompile): Allocate `dfa' earlier and pass it to
	dfasyntax().
	* tests/dfa-match-aux.c (main): Pass `dfa' to dfasyntax().
	http://bugs.gnu.org/24259

	dfa: thread-safety: move parser state into struct dfa
	* src/dfa.c: move global variables holding parser state (`tok' and
	`depth') into a new struct (`struct parser_state') and add an instance
	of it to struct dfa.  All references to the globals are replaced by
	references to the dfa struct's new member.
	http://bugs.gnu.org/24259

	dfa: thread-safety: move lexer state into struct dfa
	* src/dfa.c: move global variables holding lexer state into a new
	struct (`struct lexer_state') and add an instance of this struct to
	struct dfa.  All references to the globals are replaced with
	references to the dfa struct's new member.
	http://bugs.gnu.org/24259

2016-08-19  Zev Weiss  <zev@bewilderbeest.net>

	dfa: thread-safety: remove dfa.c's "dfa" global
	Remove the global dfa struct.  Instead, add a struct dfa pointer
	parameter to each function that had been using the global.
	* src/dfa.c (dfa): Remove file-scoped global.
	(charclass_index): Remove now-unnecessary function.
	(using_simple_locale): Add a dfa parameter and update all callers.
	(FETCH_WC, parse_bracket_exp, lex, addtok_mb, addtok): Likewise.
	(addtok_wc, add_utf8_anychar, atom, nsubtoks, copytoks): Likewise.
	(closure, branch, regexp): Likewise.
	(dfaparse): No longer set the global.
	http://bugs.gnu.org/24260

2016-08-18  Paul Eggert  <eggert@cs.ucla.edu>

	grep: tune list_files conversion to enum
	* src/grep.c (grepdesc): Use a slightly more-efficient way to test
	list_files.

	grep: prefer bitwise to short-circuit when shorter
	* src/grep.c (skip_devices, initialize_unibyte_mask, fillbuf, main)
	* src/kwsearch.c (Fexecute): Prefer bitwise to short-circuit ops
	when they are logically equivalent and the bitwise ops generate
	shorter code on GCC 6.1 x86-64.
	* src/grep.c (get_nondigit_option, parse_grep_colors):
	Use c_isdigit instead of spelling it out with a short-circuit op.

2016-08-17  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: use 64-bit when ulong is at least that wide
	* src/dfa.c (charclass_word): Now unsigned long instead of unsigned.
	(CHARCLASS_WORD_BITS): Now 64 on 64-bit platforms.
	(CHARCLASS_PAIR, CHARCLASS_INIT): New macros.
	(CHARCLASS_WORD_MASK): Now a static const, since it no longer
	needs to be a macro.
	(equal): Open-code rather than calling memcmp.
	(add_utf8_anychar): Use CHARCLASS_INIT.

	dfa: avoid uninitialized constants
	Some compilers warn about 'static int const x;' on the grounds
	that X should have an initializer.  Instead of worrying about
	this, rewrite to avoid this sort of thing.
	* src/dfa.c (emptyset): New function.
	(parse_bracket_exp): Use it instead of 'equal' and a zero constant.
	* src/dfasearch.c (struct patterns): Remove tag 'patterns'.
	(patterns0): Remove zero constant.
	(GEAcompile): Use memset instead of the zero constant.

2016-08-17  Jim Meyering  <meyering@fb.com>

	maint: avoid new "make syntax-check" failure
	* src/dfa.c: Adjust comment not to go past column 80.

	tests: pcre-jitstack: avoid false failure without base64 -d support
	* tests/pcre-jitstack: Try harder to find a base64 decoder:
	try 'base64 -d', 'base64 -D', 'openssl base64 -d' and perl's
	MIME::Base64 decode_base64.  The old code would fail at least on
	OS X, for which base64 expects -D or --decode.
	Reported by Jack Howarth in http://bugs.gnu.org/24243.

2016-08-16  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: minor refactoring and doc fixes
	* NEWS: Improve description of recent change.
	* src/dfa.c: Improve commentary.  Indent new code (and some
	long-existing howlers) more in GNU style.
	(dfa_state): Reorder members to make struct smaller on x86.
	mb_trindex member is now state_num, not size_t, so that -1 is more
	natural; all uses changed.
	(struct dfa): Similarly for mb_trcount member.
	(state_index): Compute values for new state components before
	allocating the state, to make the code easier to understand.
	(state_index, dfastate): Prefer A & ~B to other forms like (A & B)
	!= A.
	(dfastate, build_state, transit_state): In new code, prefer i++ to
	++i in for-loop control.
	(build_state, transit_state): In new code, prefer < to >.
	(transit_state): Add to *PP in one assignment, rather than in a
	loop.  Prefer !x to x == NULL.  Use xmalloc instead of xnmalloc,
	since the size is a constant.  Do the size calculation as a signed
	integer constant expression, so that the compiler diagnoses any
	overflow.
	(transit_state, free_mbdata): Tune by looping from -1 to N - 1,
	rather than from 0 to N - 1 with a separate instance for -1.
	(dfaexec_main): Rewrite to avoid side effects in if-part.
	(free_mbdata): Simplify.

	dfa: port to C90
	* src/dfa.c (transit_state, dfa_supported, dfamust):
	Don't use declarations after statements.
	If I recall correctly, gawk still wants to port to C90.

	dfa: fix context newline confusion
	* src/dfa.c (transit_state): Fix "... & ~0" that was evidently
	intended to be "... & ~1".  Do index calculation in a simpler way,
	that uses just addition (Bug#21486).

2016-08-16  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: improve leading "." with non-UTF8 multibyte
	In non-UTF8 multibyte locales, matching the dot expression is very
	slow, as the next state is calculated on demand.  This change caches
	the result for the typical case (Bug#21486).

	Compare the run times of this command before and after this change,
	on a i5-4570 CPU @ 3.20GHz using rawhide (~fedora 22) and compiled
	with gcc 5.1.1 20150618:
	yes "$(printf 'a%38db\n' 0)" | head -1000000 >in
	env LC_ALL=ja_JP.eucJP time -p \
	src/grep .......................................... in
	  Before: 19.10
	  After :  0.55

	* NEWS: Document this.
	* src/dfa.c: (struct dfa_state): New members curr_dependent, mb_trindex.
	(MAX_TRCOUNT): New constant.
	(struct dfa): New members mb_trans, mb_trcount.
	(state_index): Initialize new members of struct dfa_state and calculate
	dependency on context of next character for positions for dot.
	(dfastate): Calculate follows positions for dot if enabled.
	(realloc_trans_if_necessary): Allocate transition tables.
	(build_state): Use new constant and reset transition tables.
	(transit_state): Use cache for transition from a state with the dot
	expression.
	(free_mbdata): Deallocate transition tables.

2016-08-06  Jim Meyering  <meyering@fb.com>

	tests: standardize on 10-second timeouts to avoid rare false failure
	In a parallel test run, it is not unusual to exceed a timeout of
	1-3 seconds.  Increase several from 3 or fewer to 10 seconds.
	* tests/skip-device: Increase timeout from 2 to 10 seconds.
	* tests/grep-dev-null-out: Likewise, but s/1/10/.
	* tests/pcre-invalid-utf8-input: Likewise, but s/3/10/.
	* tests/dfa-match: Likewise.
	* tests/pcre-invalid-utf8-infloop: Likewise.
	* tests/pcre-infloop: Likewise.
	* tests/max-count-overread: Likewise.
	* tests/invalid-multibyte-infloop: Likewise.
	Prompted by http://bugs.gnu.org/24159.

	tests/backref-multibyte-slow:: avoid false positive
	* tests/backref-multibyte-slow: When redirecting the "fast" LC_ALL=C
	run's output to /dev/null, we got an artificially low timing (of 0),
	due to grep's own stdout-vs-/dev/null optimization.  With an initial
	timing of 0 on that first run, the derived timeout for the UTF-8 run
	(which redirects to a file) would be a mere 1 second.  The fix: also
	redirect that first run's output to a file, not to /dev/null.

2016-08-05  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: minor fix for whether dfa is "fast"
	* src/dfa.c (dfaoptimize): When a UTF-8 optimization succeeds for
	a DFA (it can use single-byte code paths), record that by setting
	its ->fast flag.

2016-07-25  Jim Meyering  <meyering@fb.com>

	grep: print "filename:lineno:" in invalid-regex diagnostic
	Determining the file name and line number is a little tricky because
	of the way the regular expressions are all concatenated onto a newline-
	separated list.  By the time grep would compile regular expressions,
	the <filename,lineno> origin of each regexp was no longer available.
	This patch adds a list of filename,first_lineno pairs, one per input
	source, by which we can then map the ordinal regexp number to a
	filename,lineno pair for the diagnostic.

	* src/dfasearch.c (GEAcompile): When diagnosing an invalid regexp
	specified via -f FILE, include the "FILENAME:LINENO: " prefix.
	Also, when there are two or more lines with compilation failures,
	diagnose all of them, rather than stopping after the first.
	* src/grep.h (pattern_file_name): Declare it.
	* src/grep.c: (struct FL_pair): Define type.
	(fl_pair, n_fl_pair_slots, n_pattern_files, patfile_lineno):
	Define globals.
	(fl_add, pattern_file_name): Define functions.
	(main): Call fl_add for each type of the following: -e argument,
	-f argument, command-line-specified (without -e) regexp.
	* tests/filename-lineno.pl: New file.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Improvements): Mention this.
	Initially reported by Gunnar Wolf in https://bugs.debian.org/525214
	Forwarded to grep's bug list by Santiago Ruano Rincón as
	http://debbugs.gnu.org/23965

2016-07-24  Jim Meyering  <meyering@fb.com>

	tests: add coreutils' perl-driven test framework
	* configure.ac: Set the AM_CONDITIONAL variable, HAVE_PERL.
	* tests/Coreutils.pm: New file.
	* tests/CuSkip.pm: New file.
	* tests/CuTmpdir.pm: New file.
	* tests/no-perl: New file.
	* tests/Makefile.am: Set up to use .pl tests:
	(TEST_EXTENSIONS, TESTSUITE_PERL, TESTSUITE_PERL_OPTIONS): Define.
	(SH_LOG_COMPILER, PL_LOG_COMPILER): Define.
	(EXTRA_DIST): Add the four new file names.

	doc: omit an excess word in HACKING

2016-07-21  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: always match single line only with DFA superset
	\n cannot occur inside a multibyte character.  So an input always
	matches single line only with DFA superset.

	* src/dfasearch.c (EGexecute): Simplify it with above.

2016-07-15  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: fix whitespace problems
	* src/dfa.c: Use GNU style for pointer decls.

2016-07-15  Paul Eggert  <eggert@cs.ucla.edu>

	maint: modernize HACKING a bit
	* HACKING: Remove some ancient history to simplify maintenance.

2016-07-14  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor style changes for -F crash fix
	* src/kwset.c (memoff2_kwset): Use ?: instead of if-else.

2016-07-14  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: fix -F crash when alternating duplicates
	grep -F crashes with a pattern like 0\n0.
	This bug was introduced in 966f6586fbce3081ce6e5e2f9b55301b0ec3d2b4.

	* src/kwset.c (memoff2_kwset): If two characters are the same,
	use memchr instead of memchr2.
	* tests/two-chars: New test.
	* tests/Makefile.am (TESTS): Add it.

2016-07-07  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: fix comments to match code better
	* src/dfa.c: Fix comments.

2016-07-06  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: don't treat null bytes specially
	* src/dfa.c (transit_state): Do not treat null byte specially
	when eolbyte == '\n'.

2016-07-06  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: don't distingish letter in non-POSIX locales
	For non-POSIX locales, dfa does not support word delimiter
	support, so remove distinction between letters and non-letters.
	* src/dfa.c (struct dfa): Remove members initstate_letter,
	initstate_others.  All uses removed.  New member initstate_notbol.
	(dfaanalyze, dfaexec_main): Replace old members with new member.
	(wchar_context): Remove.  Update callers.

2016-07-06  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: minor cleanups for non-POSIX simplification
	* src/dfa.c (transit_state_singlebyte): Remove unnecessary 'const'
	from arg; we usually don't bother with 'const' on locals.
	(transit_state_singlebyte): Omit '!= NULL' in boolean context.
	Use assert rather than abort.

2016-07-06  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: simplify for non-POSIX locales
	Simplify the dfa code, since it no longer supports ranges,
	collating elements, and equivalent classes in non-POSIX locales.
	* src/dfa.c (struct dfa): Remove mb_match_lens.
	(enum status_transit_state, match_anychar)
	(check_matching_with_multibyte_ops, transit_state_consume_1char):
	(State_transition): Remove.
	(transit_state_singlebyte): Accepts pointer-to-pointer position,
	instead of pointer, and no longer accept pointer to next state.
	Return next state instead of status_transit_state.  All callers
	changed.
	(transit_state_singlebyte, transit_state): Simplify.
	(dfaexec_main): Now transit_state is called only when next character
	matches with ANYCHAR.

2016-06-14  Paul Eggert  <eggert@cs.ucla.edu>

	doc: propagate more changes from grep.texi
	Problem reported by Björn Voigt in: http://bugs.gnu.org/23763#27
	* doc/grep.in.1: Fix more inconsistencies with grep.texi.

2016-06-13  Paul Eggert  <eggert@cs.ucla.edu>

	doc: remove obsolete MS-DOS mention
	* doc/grep.in.1: Remove obsolete discussion of MS-DOS heuristics.
	Problem reported by Björn Voigt in: http://bugs.gnu.org/23763

2016-06-09  Zev Weiss  <zev@bewilderbeest.net>

	grep: do pagesize initialization and buffer allocation earlier
	* src/grep.c (reset, main): We're going to need pagesize and buffer
	initialized anyway, so we might as well do so unconditionally early on
	rather than checking on every call to reset().
	http://bugs.gnu.org/23717

	grep: remove unnecessary dirdesc variable.
	* src/grep.c (grepdirent): Remove dirdesc variable and just use
	fts_cwd_fd directly, since the fts_options test was guaranteed to
	succeed (and fts_cwd_fd was already being used directly in fstatat()
	anyway).  http://bugs.gnu.org/23716

	grep: convert list_files to an enum
	* src/grep.c: Make list_files a tristate enum instead of an int.
	http://bugs.gnu.org/23715

	grep: correct a stale comment and remove dead code
	* src/grep.c (grepdesc): The `grep()' function no longer has
	special-case negative return values, since it no longer handles
	directories, so don't bother checking for them.
	http://bugs.gnu.org/23714

	maint: replace bitwise with logical OR
	* src/grep.c (main): replace bitwise ORs with logical ORs where it
	makes sense (when dealing with boolean conditions as opposed to
	bitmasks).  http://bugs.gnu.org/23713

	maint: mark a couple of static variables const
	* src/dfa.c (parse_bracket_exp): mark zeroclass const.
	* src/dfasearch.c: mark patterns0 const.
	http://bugs.gnu.org/23712

2016-06-03  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix similar bug in exit status test
	* tests/grep-dir (status_range): New shell function.
	Use it to fix bug where $? was not saved properly.

2016-06-03  Zev Weiss  <zev@bewilderbeest.net>

	tests: fix bug in exit status test
	When checking $? against multiple values, save its value in another
	variable and check that so as to avoid tests beyond the first seeing a
	$? clobbered by earlier ones.

	* tests/status: save $? in a temporary variable before testing it.

2016-06-02  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: more simplification of dfaexec_main
	* src/dfa.c (dfaexec_main): Failure at an acceptable position and demand
	to build state is unlikely.  So go next loop without checking them after
	a newline.  This commit induces no semantic change.

2016-06-02  Paul Eggert  <eggert@cs.ucla.edu>

	maint: correct attribution
	* build-aux/git-log-fix: Fix attribution of primary Aho-Corasick patch

2016-06-02  Paul Eggert  <eggert@cs.ucla.edu>

	grep: simplify -F Aho-Corasick a bit
	This removes some tuning that complicates the code without providing
	performance benefits that I could measure (GCC 6.1, x86-64).
	(acexec_trans): Do not hand-unroll.  Unduplicate the code for a
	transition step.

	* src/kwset.c (struct kwset.kwsexec, bmexec, acexec_trans, acexec)

2016-06-02  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor cleanups for -F Aho-Corasick
	* NEWS: Don't claim 7x, as the value seems to be system-dependent.
	* src/kwset.c (struct kwset.kwsexec, bmexec, acexec_trans, acexec):
	* src/kwset.c, src/kwset.h (kwsalloc, kwsexec):
	Don't put 'const' into the declaration when that is irrelevant to
	the API.  More generally, don't bother with 'const' when it's only
	a local so it is reasonably obvious to a reader that it is 'const'
	anyway.  It would be overkill to add 'const' to all locals that
	never change.
	* src/kwset.c (U): Avoid unnecessary parens.
	(treefails, memoff2_kwset, bmexec_trans, bmexec, cwexec, acexec_trans):
	Prefer SIZE_MAX to (size_t) -1.
	(bmexec_trans, cwexec, acexec_trans):
	Remove attributes for static functions that no longer seem needed.
	(memoff2_kwset): Rename from memchr2_kwset, since it returns
	an offset, not a pointer.  All uses changed.
	(cwexec, acexec_trans) [lint]: Remove initialization that is no
	longer needed; at least, GCC 6.1 x86-64 does not need it.
	(acexec_trans): Clarify code by using nesting rather than 'continue'.

2016-06-02  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: use memchr2 for two patterns of a character
	* src/kwset.c (memchr2_kwset): Add a new function.  grep uses memchr2 to
	search just two letters.
	(cwexec, acexec_trans): Use it.

	grep: -F multiword longest match not always needed
	Searching multiple fixed words, grep immediately returns without longest
	match if not needed.  Without this change, grep tries longest match for
	multiple words even if not needed.
	* src/kwset.c (kwsexec, acexec, cwexec, bmexec): Add a bool argument
	for whether longest match is needed.  All callers changed.
	* src/kwset.h (kwsexec): Update prototype.

2016-06-02  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: use Aho-Corasick algorithm to search multiple fixed words
	Searching multiple fixed words, grep used the Commentz-Walter
	algorithm, but this was O(m*n) and was very slow in the worst case.
	For example:

	  - input: yes `printf %040d` | head -10000000
	  - word1: x0000000000000000000
	  - word2: x

	This change instead uses the Aho-Corasick algorithm to search multiple
	fixed words.  It uses a high-quality trie-building function that is
	already defined for Commentz-Walter in kwset.c.

	I see 7x speed-up even for a typical case on Fedora 21 with a 3.2GHz i5
	by this change.  Using best-of-5 trials for the benchmark:

	    find /usr/share/doc/ -type f |
	    LC_ALL=C time -p xargs.sh src/grep -Ff /usr/share/dict/linux.words >/dev/null

	The results were:

	    real 11.37  user 11.03  sys 0.24  [without the change]
	    real 1.49   user 1.31   sys 0.15  [with the change]

	* src/kwset.c (struct kwset): Add a new member 'mode'.
	(kwsalloc): Use it.
	All callers are changed.
	(kwsincr): Using Aho-Corasick algorithm, build tries in normal order.
	(acexec_trans, acexec): Add a new function.
	(kwsexec): Use it.
	* src/kwset.h (kwsalloc): Update a prototype.
	* NEWS (Improvements): Mention it.

2016-05-13  Jim Meyering  <meyering@fb.com>

	maint: do not let a LANGUAGE envvar setting perturb tests
	E.g., running "LANGUAGE=eo make check" would provoke a failure
	of the encoding-error test, on systems that mistakenly let that
	envvar trump the setting of LC_ALL.
	* tests/envvar-check: New file, copied from coreutils.
	* tests/Makefile.am (EXTRA_DIST): Add it.
	(TESTS_ENVIRONMENT): Source it.
	Also select TMPDIR as we do for coreutils tests.
	Reported by Benno Schulenberg in http://bugs.gnu.org/23527.

2016-05-02  Jim Meyering  <meyering@fb.com>

	maint: avoid NEWS syntax-check failure
	* NEWS: Move the mention of the /dev/null speed-up from the
	block for 2.25 into the current, in-preparation block.

2016-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: prefer bool for boolean
	* src/dfa.c (syntax_bits_set, dfasyntax, using_utf8, FETCH_WC)
	(POP_LEX_STATE, State_transition):
	* src/dfa.h (using_utf_8):
	Use bool for boolean.

2016-05-01  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: stop exporting internal functions
	* src/dfa.c, src/dfa.h (dfaparse, dfaanalyze, dfastate, dfainit):
	Now static.

	dfa: prefer bool at DFA interfaces
	* src/dfa.c (struct dfa, dfasyntax, dfaanalyze, dfaexec_main)
	(dfaexec_mb, dfaexec_sb, dfaexec_noop, dfaexec, dfacomp):
	* src/dfa.h (dfasyntax, dfacomp, dfaexec, dfaanalyze):
	* src/dfasearch.c (EGexecute):
	Use bool for boolean.

2016-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: speed up checking for character boundary
	This should help performance with gawk; not so much with grep.
	Suggested by Norihiro Tanaka in: http://bugs.gnu.org/18777
	* src/dfa.c (never_trail): New static var.
	(dfasyntax): Initialize it.
	(skip_remains_mb): Use it to speed up a common case in Gawk.

	grep: /dev/null output speedup
	This sped up 'seq 10000000000 | grep . >/dev/null' by a factor of
	380,000 on my platform (Fedora 23, x86-64, AMD Phenom II X4 910e,
	en_US.UTF-8 locale).
	* NEWS: Document this.
	* src/grep.c (grepbuf): exit_on_match no longer implies that -q
	was specified, so when a match is found, exit with exit_failure if
	an error was also found.
	(grepdesc): Omit unnecessary S_ISREG and st_ino checks.
	out_stat.st_ino is zero if stdout is not a regular file,
	and this cannot possibly equal st->st_ino.
	(main): Omit duplicate initialization of exit_failure.  Do not
	bother with isatty unless -q is not used and stdout is a character
	special file and --color=auto and TERM says colorization is
	possible.  Most importantly, set exit_on_match if the output is
	/dev/null.
	* tests/grep-dev-null-out: New test.
	* tests/Makefile.am (TESTS): Add it.
	* tests/status: Do not require grep to actually read all the input
	files when the output is /dev/null and a matching line has been
	found.

2016-04-21  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.25
	* NEWS: Record release date.

2016-04-19  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: remove dependency on btowc
	MirOS BSD btowc is a macro that (when GCC is being used) hardcodes
	btowc (0x80) == WEOF regardless of locale, which contradicts
	future POSIX in the C locale.  Instead of bothering to develop a
	Gnulib workaround for the btowc incompatibility, use mbrtowc,
	which we are using elsewhere and fixing anyway, and are caching so
	it is fast here.  Problem reported by Nelson H. F. Beebe via Jim
	Meyering in: http://bugs.gnu.org/23269#14
	* bootstrap.conf (gnulib_modules): Remove btowc.
	* src/dfa.c (struct dfa): Remove mbrtowc_cache member, replacing with ...
	(mbrtowc_cache): ... this new static var.  All uses changed.
	(dfambcache): Remove; now done by setsyntax.  Call removed.
	(is_valid_unibyte_character): Remove.
	(IS_WORD_CONSTITUENT): Remove this macro, replacing it with ...
	(unibyte_word_constituent): ... this new function.  It uses
	mbrtowc_cache rather than btowc.
	(dfasyntax): Initialize mbrtowc_cache before using it.

2016-04-10  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor doc tweaks inspired by Debian
	Problem reported by Santiago Ruano Rincón in: http://bugs.gnu.org/22911
	* doc/grep.in.1:
	* doc/grep.texi (Matching Control, grep Programs)
	(Regular Expressions):
	Document -e, -f, and PCRE more carefully.

2016-04-10  Jim Meyering  <meyering@fb.com>

	maint: remove unused mbtoupper function
	* src/searchutils.c (mbtoupper): Remove now-unused function.
	Also remove inclusion of <assert.h>, since this change removed
	the final use of assert.
	* src/search.h (mbtoupper): Remove declaration.

2016-04-10  Paul Eggert  <eggert@cs.ucla.edu>

	grep: in C locale, all bytes are valid characters
	This works around glibc bug 19932:
	https://sourceware.org/bugzilla/show_bug.cgi?id=19932
	The actual bug fix was the update to the current version of Gnulib.
	grep problem reported by Björn Jacke in: http://bugs.gnu.org/23234
	* NEWS: Mention this.
	* doc/grep.texi (File and Directory Selection): Crossref to LC_*
	section.  Suggest why -a or LC_ALL=C might be useful.
	(Environment Variables): Mention 'locale -a'.
	Say that LC_CTYPE also specifies encoding, and that every
	byte is a valid character in the C or POSIX locale.
	* tests/c-locale: New test.
	* tests/Makefile.am (TESTS): Add it.

	build: update gnulib submodule to latest

2016-04-05  Paul Eggert  <eggert@cs.ucla.edu>

	Give another example of binary file processing
	Problem reported by Shlomi Fish
	* doc/grep.texi (File and Directory Selection):
	Document that 'q$' might match 'q' followed by a NUL
	if --binary-files=binary is in effect.

2016-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	tests: test egrep/fgrep help only if our grep
	Problem reported by Christian Weisgerber in: http://bugs.gnu.org/23146
	* tests/Makefile.am (TESTS_ENVIRONMENT):
	Test egrep and fgrep only if they use our grep.

2016-03-29  Jim Meyering  <meyering@fb.com>

	tests: remove spurious test of egrep
	* tests/reversed-range-endpoints: Do not test egrep here.
	There is already a test of grep -E.
	Prompted by http://bugs.gnu.org/23146

2016-03-23  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -Pz no longer misdiagnoses [^a]
	Problem reported by Michael Jess.
	* NEWS: Document this.
	* src/pcresearch.c (Pcompile): Do not diagnose [^ when [ is unescaped.
	* tests/pcre: Test for the bug.

2016-03-22  Jim Meyering  <meyering@fb.com>

	maint: move new 'Improvements' blurb into proper section
	* NEWS (Improvements): Move this new section from within the block
	for the already-released 2.24 into the proper "next-release" block.
	Also, retain the 2-blank-line separator between blocks.

2016-03-18  Jim Meyering  <meyering@fb.com>

	maint: avoid spurious "binary file ... matches" in generated THANKS
	* Makefile.am (THANKS): Don't apply grep to a stream containing
	NUL bytes.  Sync this rule from the one in coreutils: it was missing
	some improvements.
	Reported by Bailes Magio in http://bugs.gnu.org/22899

2016-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -oz now outputs null bytes, not newlines
	* NEWS: Document this.
	* doc/grep.texi (Other Options): Clarify that -z affects output
	as well as input data.
	* src/grep.c (print_line_middle): Output eolbyte, not newline, if -o.
	* tests/null-byte: Test -o too.
	* tests/pcre-context: Adjust test to match new behavior.

2016-03-17  Paul Eggert  <eggert@cs.ucla.edu>

	grep: use errno consistently in write diagnostics
	Feature request and initial version reported by Assaf Gordon in:
	http://bugs.gnu.org/23031
	* NEWS: Document this.
	* src/grep.c: Include <stdarg.h>.
	(stdout_errno): New static var.
	(write_error_seen): Remove; superseded by stdout_errno.
	All uses changed.
	(putchar_errno, fputs_errno, printf_errno, fwrite_errno)
	(fflush_errno): New static functions.
	(print_filename, print_sep, print_offset, print_line_head)
	(print_line_middle, print_line_tail, prline, prtext, grep)
	(grepdesc): Use them.
	* tests/write-error-msg: New file.
	* tests/Makefile.am (TESTS): Add it.

2016-03-10  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.24
	* NEWS: Record release date.

2016-02-28  Jim Meyering  <meyering@fb.com>

	maint: add dist-check.mk
	This file augments "make distcheck" rules.
	* dist-check.mk: New file, from coreutils via gzip.
	* Makefile.am (EXTRA_DIST): Add it.
	* cfg.mk: Include it.

2016-02-21  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -Pz is incompatible with ^ and $
	Problem reported by Sergei Trofimovich in: http://bugs.gnu.org/22655
	* NEWS: Document this.
	* src/pcresearch.c (Pcompile): Warn with -Pz and anchors.
	* tests/pcre: Test new behavior.

2016-02-21  Jim Meyering  <meyering@fb.com>

	tests: test cleanup
	* tests/z-anchor-newline: Remove test artifact that would write
	to /t/x.

2016-02-20  Jim Meyering  <meyering@fb.com>

	grep -z: avoid erroneous match with regexp anchor and \n in text
	* src/dfasearch.c (EGexecute): Clear the newline_anchor bit when
	eolbyte is not '\n'.
	* tests/z-anchor-newline: New file.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Describe it.
	Originally reported by Ulrich Mueller in
	https://bugs.gentoo.org/show_bug.cgi?id=574662
	Reported to us by Sergei Trofimovich as http://debbugs.gnu.org/22655

	tests: convert "cmd && fail=1" to "returns_ 1 cmd || fail=1"
	The latter is robust, while the former can silently ignore
	failure due to signals.
	* cfg.mk (sc_prohibit_and_fail_1): New rule, copied from coreutils.
	* tests/long-pattern-perf: Perform the above substitution.
	* tests/mb-non-UTF8-performance: Likewise.
	* tests/help-version: Merge from coreutils.

2016-02-09  Jim Meyering  <meyering@fb.com>

	maint: add a check-very-expensive target
	* Makefile.am (check-very-expensive): New convenience rule,
	currently merely equivalent to check-expensive.

2016-02-04  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.23
	* NEWS: Record release date.

2016-02-02  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest
	Update for this "make distcheck"-fixing change:
	> verify-tests: also remove stray test-verify.Tpo

2016-02-01  Jim Meyering  <meyering@fb.com>

	tests/null-byte: test another code path
	* tests/null-byte: Also exercise the case in which there is
	a match in the block along with the NUL byte.

2016-01-31  Paul Eggert  <eggert@cs.ucla.edu>

	Omit excess "Binary file ... matches"
	Problem reported in: http://bugs.gnu.org/22461
	* src/grep.c (grep): Don't report "Binary file ... matches"
	merely because the file contained both matches and binary data.
	Insist that the binary data contained a match.
	* tests/null-byte: Add a test for this.

2016-01-28  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

2016-01-23  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

	maint: fix typo in NEWS: s/a/an/

2016-01-15  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -x now supersedes -w more consistently
	* NEWS, doc/grep.texi (Matching Control): Mention this.
	* src/dfasearch.c (EGexecute):
	* src/pcresearch.c (Pcompile):
	Don't get confused by -w if -x is also present.
	* src/pcresearch.c (Pcompile): Remove misleading comment about
	non-UTF-8 multibyte locales, as PCRE doesn't support them.
	Calculate buffer sizes more carefully; the old method
	allocated a buffer slightly too big, seemingly due to luck.
	* tests/backref-word, tests/pcre: Add tests for this bug.

	tests: omit update-copyright-tests
	This test does not check how 'grep' itself operates, so it is
	out of place for grep's 'make check'.  Problem reported by Sam Razavi in:
	http://bugs.gnu.org/22376
	* bootstrap.conf (avoided_gnulib_modules): Add update-copyright-tests.

2016-01-11  Jim Meyering  <meyering@fb.com>

	tests: do use "yes" but via an AWK replacement
	Also, use sed Nq in place of head -N
	* tests/init.cfg (yes): Define.
	Thanks to Paul Eggert for this definition.
	* tests/max-count-overread: Revert to using "yes".
	* tests/mb-non-UTF8-performance: Likewise, and use
	"sed Nq" in place of head -N.

2016-01-11  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/pcre-count: Don't assume the page size is 32kB.

2016-01-08  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port to other POSIXish platforms
	I tested this on Solaris 10 and AIX 7.1.
	* tests/max-count-overread:
	* tests/mb-non-UTF8-performance:
	Don't assume 'yes' exists, as 'yes' is not in POSIX.
	* tests/mb-non-UTF8-performance:
	Don't rely on 'head -1000', as that option syntax is not POSIX.
	* tests/pcre-count: Don't rely on "printf '\x0'".
	* tests/unibyte-binary: Don't assume \200 is an encoding error
	in every unibyte locale.

2016-01-08  Jim Meyering  <meyering@fb.com>

	tests: fix encoding-error test failure to use of printf '\xHH'
	* tests/encoding-error: Don't rely on printf having support for \xHH
	hexadecimal.  That is not portable.  Use \OOO octal, instead.

	maint: fix typo in NEWS: s/a/an/

2016-01-07  Jim Meyering  <meyering@fb.com>

	mb-non-UTF8-performance: avoid FP test failure on fast hardware
	* tests/mb-non-UTF8-performance: Don't use a fixed size.
	Otherwise, on a fast system, the fixed-size unibyte test
	would complete in a nominal 0 ms, which might well be
	smaller than 1/30 of the multibyte duration, provoking
	a false positive test failure.  Instead, increase the
	size of the input until we obtain a unibyte duration of
	at least 10ms.

2016-01-07  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention unibyte encoding fix
	* NEWS: Document recent fix for encoding errors in unibyte locales.

	grep: improve unibyte -P performance
	This is a followon to the recent changes prompted by Bug#20526.
	In <http://bugs.gnu.org/bug=20526#86> Norihiro Tanaka pointed out
	that grep mistakenly assumed that unibyte locales cannot have
	encoding errors.  Here, the mistake hurt performance significantly.
	On Fedora 23 x86-64 in the C locale, this patch improved grep's
	performance by a factor of 7 when run as "grep -P 'z.*a'" on the
	output of "yes $(printf '\200\n') | head -n 1000000000".
	* src/pcresearch.c (multibyte_locale) [HAVE_LIBPCRE]: New static var.
	(Pcompile): Set it.
	(Pexecute): Use it to avoid the need to call
	buf_has_encoding_errors in unibyte locales.

2016-01-06  Paul Eggert  <eggert@cs.ucla.edu>

	Improve on fix for Bug#22181
	* src/pcresearch.c (Pexecute): Update subject when skipping past
	easily-determined encoding errors, as this is faster than letting
	pcre_exec skip them.  On my platform this improves performance
	4.7x on a benchmark created via "yes $(printf '\200\200\200\200
	\200\200\200\200\200\200\200\200\200\200\200\200\200\200\200\200x\n')
	| head -n 1000000 >j; grep -oP y j" in a UTF-8 locale.  Rework
	code that deals with PCRE_ERROR_BADUTF8 return, to avoid an
	incorrect (albeit currently harmless) 'bol = false' assignment.

	grep: restore -P optimization (followup fix)
	* src/search.h (EGexecute, Fexecute, Pexecute):
	Change decls to match new implementations.
	I forgot to add this file to the previous commit.

	grep: restore -P PCRE_NO_UTF8_CHECK optimization
	On my platform in the en_US.utf8 locale, this makes 'grep -P "z.*a" k'
	220x faster, where k is created by the shell command:
	yes 'abcdefg hijklmn opqrstu vwxyz' | head -n 10000000 >k
	* src/dfasearch.c (EGexecute):
	* src/grep.c (execute_fp_t):
	* src/kwsearch.c (Fexecute):
	* src/pcresearch.c (Pexecute):
	First arg is now char *, not char const *, since Pexecute now
	temporarily modifies this argument.
	* src/grep.c, src/grep.h (buf_has_encoding_errors): Now extern.
	* src/pcresearch.c (Pexecute): Use it.  If the input is free of
	encoding errors, use a multiline search and the PCRE_NO_UTF8_CHECK
	option, as this is typically way faster.  This restores an
	optimization that was removed with the recent changes for binary
	file detection.

2016-01-05  Paul Eggert  <eggert@cs.ucla.edu>

	Fix calculation of unibyte_mask
	* src/grep.c (initialize_unibyte_mask): The old method worked for
	UTF-8 and other typical encodings, but did not work for weird
	encodings, e.g., one where all bytes other than 0x7f and 0x80 are
	unibyte characters.

2016-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix bug with with invalid unibyte sequence
	This was introduced by the recent binary-data-detection changes.
	Problem reported by Norihiro Tanaka in: http://bugs.gnu.org/20526#86
	* src/grep.c (HIBYTE, easy_encoding, init_easy_encoding): Remove,
	replacing with ...
	(uword_max, unibyte_mask, initialize_unibyte_mask): ... this new
	constant, static var, and function.  All uses changed.  The
	unibyte_mask var generalizes the old local var hibyte_mask, which
	worked only for encodings where every byte with 0x80 turned off is
	a single-byte character.
	(buf_has_encoding_errors): Return false immediately if
	unibyte_mask is zero, not whether the current encoding is unibyte.
	The old test was incorrect in unibyte locales in which some bytes
	were encoding errors.
	* tests/pcre-z: Require UTF-8 locale, since the grep -z . test now
	needs this.  Use printf \0 rather than tr.  Port the 'grep -z .'
	test to platforms where the C locale says '\200' is an encoding
	error.  Use cmp rather than compare, as the file is binary and
	so non-GNU diff might not work.
	* tests/unibyte-binary: New file.
	* tests/Makefile.am (TESTS): Add it.

2016-01-01  Jim Meyering  <meyering@fb.com>

	maint: update copyright year, bootstrap, init.sh
	Run "make update-copyright" and then...

	* gnulib: Update to latest.
	* tests/init.sh: Update from gnulib.
	* bootstrap: Likewise.

2015-12-31  Paul Eggert  <eggert@cs.ucla.edu>

	doc: clarify text vs binary match output
	* NEWS:
	* doc/grep.texi (File and Directory Selection):
	Make it clearer that grep can now output matching text before
	reporting a binary match.  Problem reported by Norihiro Tanaka in:
	http://bugs.gnu.org/20526#83

	doc: minor clarifications
	* doc/grep.in.1, doc/grep.texi: Minor clarifications suggested by
	Debian documentation patches.  Problem reported by Santiago Ruano
	Rincón in: http://bugs.gnu.org/18651

	grep: fix -l --line-buffer bug
	Problem reported by Louis Sautier in: http://bugs.gnu.org/18750
	* NEWS: Document this.
	* src/grep.c (grep, grepdesc): If --line-buffered, flush
	stdout after outputting newline (or null byte, if applicable).

2015-12-30  Paul Eggert  <eggert@cs.ucla.edu>

	grep: remove duplicate init
	* src/grep.c (print_line_middle): Remove duplicate initialization.

	grep: report line-buffered write error right away
	* src/grep.c (prline): When line buffered, if there is a write
	error, report it immediately rather than waiting until the next
	line of output.

	grep: -c should keep counting after binary data
	Problem and fix reported by Jaroslav Škarvada, and test case
	reported by Norihiro Tanaka, in: http://bugs.gnu.org/22028
	* NEWS: Document this.
	* src/grep.c (grep): Don't stop counting merely because nulls seen.
	* tests/pcre-count: New file.
	* tests/Makefile.am (TESTS): Add it.

	dfa: port to tinycc
	* src/dfa.c (add_utf8_anychar): Put 'const' after type.
	Problem reported by Aharon Robbins in:
	http://bugs.gnu.org/22260

	grep: be less picky about encoding errors
	This fixes a longstanding problem introduced in grep 2.21,
	which is overly picky about binary files.
	* NEWS:
	* doc/grep.texi (File and Directory Selection): Document this.
	* src/grep.c (input_textbin, textbin_is_binary, buffer_textbin)
	(file_textbin):
	Remove.  All uses removed.
	(encoding_error_output): New static var.
	(buf_has_encoding_errors, buf_has_nulls, file_must_have_nulls):
	New functions, which reuse bits
	and pieces of the removed functions.
	(lastout, print_line_head, print_line_middle, print_line_tail, prline)
	(prpending, prtext, grepbuf):
	Avoid use of const, now that we have
	functions that require modifying a sentinel.
	(print_line_head): New arg LEN.  All uses changed.
	(print_line_head, print_line_tail):
	Return indicator whether the output line was printed.
	All uses changed.
	(print_line_middle): Exit early on encoding error.
	(grep): Use new method for determining whether file is binary.
	* src/grep.h (enum textbin, TEXTBIN_BINARY, TEXTBIN_UNKNOWN)
	(TEXTBIN_TEXT, input_textbin): Remove decls.  All uses removed.
	* src/pcresearch.c (Pexecute): Remove multiline optimization,
	since the main program no longer checks for encoding errors on input.
	* tests/encoding-error: New file.
	* tests/Makefile.am (TESTS): Add it.

2015-12-29  Jim Meyering  <meyering@fb.com>

	maint: correct (make sorted) order of test file names
	* tests/Makefile.am (TESTS): Insert new test name in sorted order.

2015-12-28  Paul Eggert  <eggert@cs.ucla.edu>

	grep: --exclude matches trailing parts of args
	Problem reported by Vincent Lefevre in:
	http://bugs.gnu.org/22144
	* NEWS:
	* doc/grep.texi (File and Directory Selection): Document this.
	* src/grep.c (excluded_patterns, excluded_directory_patterns):
	Now 2-element arrays, with one element for subfiles and another
	for command-line args.  All uses changed.  This implements the change.
	(exclude_options): New function.
	* tests/include-exclude: Test the change.

2015-12-18  Jim Meyering  <meyering@fb.com>

	grep -oP: don't infloop when processing invalid UTF8 preceding a match
	* src/pcresearch.c (Pexecute): When advancing SUBJECT past an
	encoding error, don't blindly set P to that new value, since we
	will soon compute SEARCH_OFFSET = P - SUBJECT, and mistakenly
	making that difference too small would allow us to match some
	previously-processed text, resulting in an infinite loop.
	* NEWS (Bug fixes): Mention it.
	* THANKS.in: Add Christian's name and email address.
	* tests/pcre-invalid-utf8-infloop: New file.
	* tests/Makefile.am (TESTS): Add it.
	Reported by Christian Boltz in http://debbugs.gnu.org/22181
	Introduced by commit, v2.21-37-g14f8e48.

2015-11-04  Jim Meyering  <meyering@fb.com>

	tests: mark performance-related tests as expensive
	These performance-related tests are slightly failure prone due to
	varying system load during the two runs.
	Marking these tests as "expensive" makes it so they are no longer run
	via "make check". You can still run them via make "check-expensive".
	This makes them less likely to be run by regular users.
	* tests/long-pattern-perf: Use expensive_.
	* tests/mb-non-UTF8-performance: Likewise.
	Reported by Jaroslav Skarvada in http://debbugs.gnu.org/21826
	and by Andreas Schwab in http://debbugs.gnu.org/21812.

2015-11-01  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.22
	* NEWS: Record release date.

	tests: pcre-jitstack: upon failure, retry with no stack size limit
	* tests/pcre-jitstack: Don't let an example that provokes inordinate
	stack space use cause a test failure.  Thanks to reports from and
	analysis by Bruce Dubbs; see http://debbugs.gnu.org/21755

2015-10-27  Jim Meyering  <meyering@fb.com>

	maint: update THANKS.in
	* THANKS.in: Add name+email of those who found and reported
	the bug that made grep -E '^x|x$' match any "x".

2015-10-25  Zev Weiss  <zev@bewilderbeest.net>

	dfa: plug a memory leak in dfamust
	* src/dfa.c (dfamust): Ensure MP is freed, by refraining
	from returning early when, at "done:" *RESULT is NULL.

2015-10-25  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest
	* gnulib: Pull in one more portability fix:
	  stdalign: port to Sun C 5.9

2015-10-24  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest, for portability fixes
	* gnulib: Pull in changes like these:
	  fts: port to C11 alignof
	  stdalign: work around pre-4.9 GCC x86 bug

	maint: NEWS: correct/amend
	* NEWS: Move the long-regexp-performance-improvement from
	"Bug fixes" to "Improvements."  Say more and include an example.
	The -Fw degradation was introduced in commit v2.18-125-g94555dd

	tests: avoid spurious failure on OpenBSD 5.8
	* tests/fedora: Don't rely on "diff - FILE" reading from stdin.
	Reported privately by Nelson Beebe.

2015-10-17  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest; also bootstrap and tests/init.sh
	* bootstrap: Update from gnulib.
	* tests/init.sh: Likewise.
	* gnulib: Update submodule to latest.

	build: avoid spurious bootstrap failure involving pkg.m4
	Running ./bootstrap could fail mistakenly at the very end in
	its attempt to obtain a copy of pkg.m4.  It would search only
	$(aclocal --print-ac-dir) and some other directories, but not
	those listed in $(aclocal --print-ac-dir)/dirlist.
	* bootstrap.conf (bootstrap_post_import_hook): Also search the
	directories named in $(aclocal --print-ac-dir)/dirlist when that
	file exists with nonzero size.

2015-10-16  Paul Eggert  <eggert@cs.ucla.edu>

	maint: add news item
	* NEWS: Document grep -Fw speedup.

	grep: simplify previous change
	* src/grep.c (main): Simplify recently-changed grep -Fw test.

2015-10-16  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: use grep matcher for grep -Fw when unibyte
	In single byte locales with grep -Fw, prefer the grep matcher to the
	kwset matcher, as the former uses KWset and a DFA, whereas the latter
	calls kwsexec many times until it matches a word.
	* src/grep.c (main): Change pattern for fgrep into grep for grep -Fw in
	single byte locales.

2015-10-16  Paul Eggert  <eggert@cs.ucla.edu>

	grep: use memchr/memrchar
	* src/kwsearch.c (Fexecute): Prefer memchr and memrchr to doing it
	by hand.

2015-10-16  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: improve performance of grep -Fw
	* src/kwsearch.c (Fexecute): grep -Fw examined whether the previous
	character is a word character after matching from the head of the
	buffer.  It is extremely slow.  Now, if grep found a potential match,
	it looks for the previous newline, and examines from there.

2015-10-13  Jim Meyering  <meyering@fb.com>

	maint: use single quote rather than UTF-8 multi-byte version
	* tests/backref-alt: Translate unnecessary non-ASCII in comment.

2015-10-13  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: make the executable a bit smaller
	* src/dfa.c (dfamust): Hoist MB_CUR_MAX calculation out of loops.

2015-10-13  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: fix bug in alternate of sub-patterns that differ only in constraints
	Fix a bug where a line incorrectly matches alternates of sub-patterns
	that differ only in the constraints, e.g., the ERE '^a|a$'.
	Reported by Greg Boyd in: http://debbugs.gnu.org/21670
	* src/dfa.c (dfamust): For a pattern with constraints, check that it is
	matched including the constraints, to judge whether it is exact.

	dfa: fix off-by-one error
	* src/dfa.c (dfamust): Fix off-by-one error in computing 'must' length,
	which caused the 'must' to be too short.  See:
	http://bugs.gnu.org/21670#28

2015-10-12  Jim Meyering  <meyering@fb.com>

	doc: NEWS: mention a bug fix
	* NEWS (Bug fixes): Describe it.
	This bug was introduced by commit v2.18-85-g2c94326
	and fixed by commit v2.21-51-g256a4b4.

2015-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	tests: add test case for Bug#21670
	* tests/options: Add test #4 to catch Bug#21670.
	Also, do not overescape # in shell strings.

2015-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	Add test for pop_fail_stack bug
	Problem reported by Hanno Böck in: http://bugs.gnu.org/21513
	If you use --with-included-regex the bug fix is in gnulib, here:
	http://git.savannah.gnu.org/cgit/gnulib.git/commit/?id=5513b40999149090987a0341c018d05d3eea1272
	If you use glibc, the bug fix has not been installed yet.
	* tests/Makefile.am (XFAIL_TESTS): Add backref-alt if system matcher.
	(TESTS): Add backref-alt.
	* tests/backref-alt: New file.
	* tests/triple-backref: Remove unused var.
	Don't skip if tested with glibc, as Makefile.am now handles this.

	build: update gnulib submodule to latest

2015-08-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: avoid use of uninitialized variable
	EGexecute would use "backref" uninitialized.
	While that could have no bearing on correctness, it could
	impact performance, via an unnecessary use of regexp.
	* src/dfasearch.c (EGexecute): Initialize backref.
	Reported as http://debbugs.gnu.org/21273
	Introduced by commit v2.21-55-gea0ebaa.

2015-08-12  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: remove fgrep code for case insensitive match
	The fgrep matcher is no longer called in case insensitive matching,
	so remove the code to support it.
	* src/kwsearch.c (mb_case_map_apply): Remove function.
	(Fexecute): Remove now-unused code.

2015-08-12  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: optimize [x-x]
	* src/dfa.c (parse_bracket_exp): Treat [x-x] as if it were [x].
	This also pacifies GCC, which otherwise complains about wc2
	being set but not used.

2015-08-12  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: remove unused multibyte support
	Now regex should be used for range, collating element, equivalent class
	in non POSIX locales.  So remove code to support these features.
	* dfa.c (struct mb_char_classes): Remove members ch_classes,
	nch_classes, ranges, nranges, equivs, nequivs, coll_elems, ncoll_elems.
	All uses removed.
	(match_mb_charset): Remove function.

2015-08-01  Jim Meyering  <meyering@fb.com>

	tests: mb-non-UTF8-performance: use new function
	* tests/mb-non-UTF8-performance: Rewrite to use
	the user-time measuring function in init.cfg.

	tests: long-pattern-perf: measure user time, not elapsed
	Measuring user time makes this test less prone to false
	positive failure, and also lets us use a tighter bound.
	* tests/long-pattern-perf: Measure elapsed user time rather than
	wall-clock time, to permit a tighter bound on the ratio of
	N-to-10N timings.  Suggested by Giuseppe Ottaviano.
	Also, use regexps built from mostly 5-digit numbers, so that the 10:1
	ratio applies to lines of "seq" output as well as to total bytes.

	tests: new function to measure elapsed user time
	* tests/init.cfg (user_time_): New function.

2015-07-25  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: remove word delimiter support for multibyte locales
	DFA supports word delimiter expressions, but it does not behave
	correctly for multibyte locales.  Even if it were to be fixed,
	the DFA matcher's performance would be no better than that of regex.
	Thus, this change removes DFA support for word delimiter expressions
	in multibyte locales.

	* src/dfa.c (dfa_supported): Return false also when a pattern uses any
	word delimiter expression in a multibyte locale.

2015-07-25  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: avoid execution for a pattern including an unsupported expression
	If a pattern includes a construct unsupported by the DFA matcher,
	the DFA search would fail in most cases.  Make dfaexec immediately
	return for any such pattern.

	* src/dfa.c (struct dfa_state) [has_backref, has_mbcset]: Remove members
	and all uses.
	(dfaexec_main): Remove 'backref' parameter.  Update callers.
	(dfaexec_noop): New function.
	(dfa_supported): New function.
	(dfassbuild): Remove now-unused code.
	(dfacomp): When a pattern uses a DFA-unsupported construct, do not
	waste time performing any further analysis.

2015-07-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: DEBUG: print detail of DFA states
	When compiled with -DDEBUG, grep outputs tokens etc.
	With this change, also print DFA states and transitions.
	This change is very useful when debugging those.

	* src/dfa.c (prtok) [DEBUG]: Change `%c' to `%02x' in printf format.
	(state_index) [DEBUG]: Print detail of new state.
	(dfastate) [DEBUG]: Print detail of DFA states.
	Reported as http://debbugs.gnu.org/18707

2015-07-18  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	tests: sjis-mb: accept two more locales
	* tests/sjis-mb: Accept the ja_JP.SJIS and ja_JP.PCK locales
	as well as ja_JP.SHIFT_JIS, so this test is less likely to
	be skipped unnecessarily.  Reported as http://bugs.gnu.org/18983

2015-07-18  Jim Meyering  <meyering@fb.com>

	tests: add a test for the performance fix
	* tests/long-pattern-perf: New file.
	* tests/Makefile.am (TESTS): Add it.

2015-07-18  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: speed up handling of long pattern
	DFA tries to find a long sequence of characters that must appear
	in any matching line.  However, when a pattern is long (length N),
	it is very slow, because it makes O(N^2) strstr calls.
	This change reduces that to O(N) by processing each sequence of
	adjacent "regular" characters as a group.

	Compare the run times of this command before and after this change:
	(on a i7-4770S CPU @ 3.10GHz using rawhide (~fedora 22) and compiled
	with gcc 6.0.0 20150627)
	  : | env time -f %e grep -f <(seq -s '' 9999)
	  Before: 0.85
	   After: 0.02

	* src/dfa.c (dfamust): Process each string of concatenated normal
	characters as a unit.
	* NEWS (Improvement): Mention it.
	Prompted by a bug report and patch by Ivan Yanikov
	in http://bugs.gnu.org/15191#5

2015-07-17  Jim Meyering  <meyering@fb.com>

	tests: fix mis-applied patch.
	* tests/include-exclude: I applied "|sort" to the wrong creation
	of "out", and didn't push the same patch that I'd tested.

	tests: avoid FS-dependent false-positive failure
	* tests/include-exclude: Sort file name list, so that this test
	is not sensitive to the order in which those names are returned
	via readdir. I noticed the failure on a Fedora 21 system using ext4.
	Also fix a typo: s/framework_failure+/framework_failure_/

2015-07-13  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix bug with --exclude-dir and command line
	Reported by Aron Griffis in: http://bugs.gnu.org/21027
	* NEWS: Document this.
	* src/grep.c (grepdirent): Don't check whether the file is skipped
	when on the command line, as that's the caller's responsibility.
	(main): Anchor the exclude patterns.
	* tests/include-exclude: Adjust test case to match fixed behavior.
	Add some more test cases.

	tests: fix $? typo in null-byte
	* tests/null-byte: Don't assume $? survives an invocation of 'test'.

2015-07-05  Jim Meyering  <meyering@fb.com>

	maint: dfa: used unsigned types where appropriate
	* src/dfa.c (case_folded_counterparts): Return unsigned int, not int.
	Change type of two locals to unsigned int, to reflect that their
	values are never negative.
	(parse_bracket_exp): Adjust type of result at each use, as well
	as that of related index variables.

2015-07-04  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: build struct dfamust on demand
	If we won't use KWset, do not build a "struct dfamust".
	Now it is built only when needed.
	* src/dfa.c (struct dfa) [musts]: Remove member.
	(dfacomp): Don't build dfamust here.
	(dfamustfree): New function to free a struct dfamust.
	(dfamust): Make it a global function, and make it return a pointer
	to a malloc'd struct dfamust.
	(dfamusts): Remove it.
	* src/dfa.h (struct dfamust) [next]: Remove member.
	In the implementation preceding this patch, there was
	never more than one of these in a given "struct dfa".
	(dfamustfree, dfamust): Add prototypes.
	(dfamusts): Remove prototype.
	(dfaalloc): Declare with _GL_ATTRIBUTE_MALLOC.
	To make that symbol usable there, move the inclusion
	of "xalloc.h" from dfa.c to this file, dfa.h.
	* src/dfasearch.c (kwsmusts): Adapt to use the new interface.
	Update the comments to reflect reality.
	This addresses http://bugs.gnu.org/17715

2015-07-04  Paul Eggert  <eggert@cs.ucla.edu>

	grep: use recent gnulib syntax bits
	* src/grep.c (Gcompile, Ecompile): Use plain RE_SYNTAX_GREP
	and RE_SYNTAX_EGREP, now that we assume a recent-enough gnulib.

	maint: ignore gendocs_template_min
	* doc/.gitignore: Add '/gendocs_template_min'.

	build: update gnulib submodule to latest

	dfa: '.' and '[^x]' now consistently match newline
	* src/dfa.c (parse_bracket_exp, lex, add_utf8_anychar)
	(match_anychar): RE_DOT_NEWLINE and RE_HAT_LISTS_NOT_NEWLINE
	are about LF, not about eolbyte.  This patch does not affect
	'grep', but may affect other users of dfa.c.

	grep: -z '[^x]' now consistently matches newline
	Problem reported by Norihiro Tanaka in: http://bugs.gnu.org/20974#19
	* NEWS: Document this.
	* src/grep.c (Gcompile, Ecompile): Clear RE_HAT_LISTS_NOT_NEWLINE.
	* tests/utf8-bracket: Test this.

2015-07-03  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -z '.' now consistently matches newline
	Problem reported by Balazs Kezes in: http://bugs.gnu.org/20974
	* NEWS: Document this.
	* tests/utf8-bracket: New file, to test for this bug.
	* src/grep.c (Gcompile, Ecompile): Also specify RE_DOT_NEWLINE.
	* tests/Makefile.am (TESTS): Add it.

	grep: simplify print_line_middle slightly
	* src/grep.c (print_line_middle): Simplify.

	grep: don't mishandle left context in -P
	http://bugs.gnu.org/20957
	* src/pcresearch.c (jit_exec): New arg SEARCH_OFFSET.
	Caller changed.
	(Pexecute): Pass the left context to pcre_exec, so that PCRE
	regular-expression matching can see it.
	* tests/pcre-context: New file, to test for this bug.
	* tests/Makefile.am (TESTS): Add it.

2015-06-28  Jim Meyering  <meyering@fb.com>

	tests/case-fold-backref: factor test

2015-06-26  Paul Eggert  <eggert@cs.ucla.edu>

	grep: don't hang on command-line fifo if -D skip
	* NEWS: Document this.
	* src/grep.c (skip_devices):
	New function, with code taken from grepdirent.
	(grepdirent): Use it.  Avoid an unnecessary initialization.
	(grepfile): If skipping devices, open files with O_NONBLOCK.
	Throw in O_NOCTTY while we're at it.
	(grepdesc): Skip devices here, too.  Not only does this fix the
	bug, it fixes an unlikely race condition if some other process
	renames a device between fstatat and openat.
	* tests/skip-device: Add a test for this bug.

	grep: minor tweaks
	* src/grep.c (main): Change recently-added static vars to be
	constants, which makes them sharable.  Prefer 'return' to 'exit'
	when returning/exiting from 'main'.  Move decl closer to first use
	and rename local from 'ok' (which was confusing) to 'status'.
	Prefer named constant STDOUT_FILENO to unnamed constant 1.

2015-06-26  Jim Meyering  <meyering@fb.com>

	maint: unify three argv-processing calls
	* src/grep.c (main): Unify three calls to grep_commandline_arg.

	maint: alphabetize anonymous enum member names

2015-05-30  Paul Eggert  <eggert@cs.ucla.edu>

	test: tighten tests for bracket exprs
	* tests/posix-bracket: Test '[a-a[.-.]--]'.
	Also, test that failures are with status 1
	(nonmatching data), not status 2 (invalid expressions).

2015-04-26  Jim Meyering  <meyering@fb.com>

	maint: update bootstrap from gnulib
	* bootstrap: Update from gnulib.

	maint: reword a diagnostic not to trigger leading capital check
	* src/pcresearch.c: Reword diagnostic to avoid "make syntax-check"
	failure.

	maint: sort test names in tests/Makefile.am and add syntax-check rule
	* cfg.mk (sc_sorted_tests): New rule.
	* tests/Makefile.am (TESTS): Alphabetize.

2015-04-25  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: make find_pred return NULL for an invalid predicate
	This could never happen when invoked via grep, but could have triggered
	a bug if dfa.c's find_pred function were invoked by some other program.
	* src/dfa.c (find_pred): Return NULL for an invalid predicate.
	* tests/invalid-char-class: New file to test for this.
	* tests/Makefile.am (TESTS): Add that new file name to the list.
	This addresses http://debbugs.gnu.org/18631

2015-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	build: improve pkg-config doc and error handling
	Error-handling improvement suggested by Mike Frysinger in:
	http://bugs.gnu.org/16757#29
	* NEWS: Document pkg-config changes.
	* README-prereq: pkg-config is now a prereq when building from
	repository.
	* m4/pcre.m4 (gl_FUNC_PCRE): Report an error if pcre is explicitly
	requested but not available.  Defer to user-supplied PCRE_CFLAGS
	and PCRE_LIBS.

	build: remove typo and don't bother with /usr/include/pcre
	Problem reported by Holger Bruenjes.
	* m4/pcre.m4: Remove test for /usr/include/libpng (a typo).
	Come to think of it, don't bother worrying about
	/usr/include/pcre, as hosts with that problem can use pkg-config
	or configure with CFLAGS by hand.

	build: use pkg-config (if available) to configure libpcre
	Problem reported by Mike Frysinger in: http://bugs.gnu.org/16757
	* bootstrap.conf (bootstrap_post_import_hook):
	Copy pkg-config's pkg.m4.
	* configure.ac: Invoke PKG_PROG_PKG_CONFIG.
	* m4/pcre.m4 (gl_FUNC_PCRE): Rewrite to use pkg-config if
	available, and to test that pcre_compile can be linked to.
	* src/Makefile.am (AM_CFLAGS): Add PCRE_CFLAGS.
	(grep_LDADD): Add PCRE_LIBS.
	* src/pcresearch.c: Simply include <pcre.h> if HAVE_LIBPCRE,
	since 'configure' arranges for the appropriate -I option now.

2015-03-11  Paul Eggert  <eggert@cs.ucla.edu>

	grep: output "." file name in diagnostic
	This is bug C as reported by David Grayson in:
	http://bugs.gnu.org/16444#18
	This bug occurs only in obscure circumstances, and I didn't see
	how to write a reasonable test case for it.
	* src/grep.c (filename_prefix_len): Remove, replacing with ...
	(omit_dot_slash): New static var.  All uses of the former replaced
	with uses of the latter.
	(grepdirent): Don't add 2 if the filename is just ".".

	egrep, fgrep: just use what's in PATH
	* src/egrep.sh: Don't monkey with PATH; just use whatever 'grep'
	is in the path.  This is simpler, and lets the user specify
	default options with a script for only grep, with no need for
	egrep and fgrep scripts.
	Fixes: bug#19998

	doc: give a script wrapper example
	* doc/grep.texi (Environment Variables): Give an example of a
	wrapper script, as an alternative to using GREP_OPTIONS.
	Fixes: bug#19998

	doc: clarify how -a matches
	* doc/grep.in.1, doc/grep.texi (File and Directory Selection):
	Give an example of how non-text bytes affect pattern matching in
	binary files.
	Fixes: bug#20080

2015-02-23  Paul Eggert  <eggert@cs.ucla.edu>

	Cover the non-INSTALL case
	* README: Mention what to do if there is no INSTALL file.
	Fixes: bug#19928

2015-02-11  Jim Meyering  <meyering@fb.com>

	maint: use ASAN-poisoning more carefully
	The ASAN-poisoning instituted by commit v2.21-14-g1555185 was
	incomplete, since the poisoned tail of the read buffer could well
	be the target of a legitimate follow-on read.  To accommodate that,
	we must unpoison each such region just before beginning fillbuf's
	read loop.
	* src/grep.c [HAVE_ASAN] (asan_poison): Define.
	(clear_asan_poison): Define.
	(fillbuf): Clear before reading, since we are likely to read
	into memory that was poisoned on the preceding iteration.
	* tests/two-files: New file, to test for this.
	* tests/Makefile.am (TESTS): Add it.

2015-02-10  Paul Eggert  <eggert@cs.ucla.edu>

	Grow the JIT stack if it becomes exhausted
	Problem reported by Oliver Freyermuth in: http://bugs.gnu.org/19833
	* NEWS: Document the fix.
	* tests/Makefile.am (TESTS): Add pcre-jitstack.
	* tests/pcre-jitstack: New file.
	* src/pcresearch.c (NSUB): Move decl earlier, since it's needed
	earlier now.
	(jit_stack_size) [PCRE_STUDY_JIT_COMPILE]: New static var.
	(jit_exec): New function.
	(Pcompile): Initialize jit_stack_size.
	(Pexecute): Use new jit_exec function.  Report a useful diagnostic
	if the error is PCRE_ERROR_JIT_STACKLIMIT.

2015-02-01  Jim Meyering  <meyering@fb.com>

	maint: reference CVE-2015-1345 from NEWS
	* NEWS: Mention the CVE that was addressed by v2.21-13-g83a95bd,
	"grep -F: fix a heap buffer (read) overrun".

2015-01-18  Jim Meyering  <meyering@fb.com>

	maint: convert "goto" to "continue" and remove now-spurious label
	* src/kwset.c (bmexec_trans): Using "goto big_advance" here is
	equivalent to using "continue".  Make that change and remove
	the now-unused label.

2015-01-10  Jim Meyering  <meyering@fb.com>

	tests: add support for ASAN memory poisoning
	This lets us reliably detect with ASAN some UMR bugs
	that would otherwise be detectable only some of the time
	with MSAN.  Use __asan_poison_memory_region to mark the unused
	portion of a read buffer as inaccessible.  Then, with ASAN,
	any attempt to access those bytes results in an ASAN abort.
	* src/system.h: Include "ignore-value.h".
	(__has_feature): Define.
	(HAVE_ASAN): Define when address sanitizer is enabled.
	[HAVE_ASAN]: Declare these two __asan_* symbols.
	[!HAVE_ASAN] (__asan_poison_memory_region): Define stub.
	[!HAVE_ASAN] (__asan_unpoison_memory_region): Likewise.
	* src/grep.c: Use __asan_poison_memory_region.

2015-01-09  Yuliy Pisetsky  <ypisetsky@fb.com>

	grep -F: fix a heap buffer (read) overrun
	grep's read buffer is often filled to its full size, except when
	reading the final buffer of a file.  In that case, the number of
	bytes read may be far less than the size of the buffer.  However, for
	certain unusual pattern/text combinations, grep -F would mistakenly
	examine bytes in that uninitialized region of memory when searching
	for a match.  With carefully chosen inputs, one can cause grep -F to
	read beyond the end of that buffer altogether.  This problem arose via
	commit v2.18-90-g73893ff with the introduction of a more efficient
	heuristic using what is now the memchr_kwset function. The use of
	that function in bmexec_trans could leave TP much larger than EP,
	and the subsequent call to bm_delta2_search would mistakenly access
	beyond end of the main input read buffer.

	* src/kwset.c (bmexec_trans): When TP reaches or exceeds EP,
	do not call bm_delta2_search.
	* tests/kwset-abuse: New file.
	* tests/Makefile.am (TESTS): Add it.
	* THANKS.in: Update.
	* NEWS (Bug fixes): Mention it.

	Prior to this patch, this command would trigger a UMR:

	  printf %0360db 0 | valgrind src/grep -F $(printf %019dXb 0)

	  Use of uninitialised value of size 8
	     at 0x4142BE: bmexec_trans (kwset.c:657)
	     by 0x4143CA: bmexec (kwset.c:678)
	     by 0x414973: kwsexec (kwset.c:848)
	     by 0x414DC4: Fexecute (kwsearch.c:128)
	     by 0x404E2E: grepbuf (grep.c:1238)
	     by 0x4054BF: grep (grep.c:1417)
	     by 0x405CEB: grepdesc (grep.c:1645)
	     by 0x405EC1: grep_command_line_arg (grep.c:1692)
	     by 0x4077D4: main (grep.c:2570)

	See the accompanying test for how to trigger the heap buffer overrun.

	Thanks to Nima Aghdaii for testing and finding numerous
	ways to break early iterations of this patch.

2015-01-08  Jim Meyering  <meyering@fb.com>

	grep: avoid false-positive UMR
	For some inputs, valgrind would report an uninitialized
	memory read error, but it was harmless.
	* src/grep.c (fillbuf): Initialize those trailing bytes.

2015-01-01  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

	maint: update copyright year ranges to include 2015
	Run "make update-copyright".  Also, ...
	* grep.texi: Update manually, converting each "--" to "-".

2014-12-15  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document binary-data heuristic better
	Problem reported by Martin Hoch in: http://bugs.gnu.org/19388
	* doc/grep.texi (File and Directory Selection):
	Document what non-text bytes are.
	(Usage): Fix cross reference.

2014-12-12  Jim Meyering  <meyering@fb.com>

	maint: fix a new "make syntax-check" failure
	* tests/dfa-match-aux.c: s/can not/cannot/

2014-12-12  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	build: avoid build failure with --enable-gcc-warnings and no PCRE
	* src/pcresearch.c [HAVE_LIBPCRE] (empty_match): Guard the declaration
	of this PCRE-only variable.

2014-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port fmbtest to CentOS 6 and earlier
	* tests/fmbtest: Port to platforms where the 'sed' pattern
	'[^0-9]' does not match every non-digit character.  Problem
	reported by Norihiro Tanaka in: http://bugs.gnu.org/19293

2014-12-06  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: simplify dfaexec
	* src/dfa.c (dfaexec): Simplify by rearrangement of IF conditions.
	This commit induces no semantic change, and reverts part of commit
	v2.5.4-144-gbafa134.

2014-12-06  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: avoid invalid match or infinite loop in unused matching mode
	Neither grep nor gawk uses this DFA code in its matching mode,
	since each always calls dfacomp with a nonzero final argument.
	However, when used in that mode, it had bug:
	After failing to match in matching mode, it should return NULL,
	but instead would either report a false match or enter an
	infinite loop.

	* src/dfa.c (dfaexec_main): After failing to match in matching mode
	return NULL, rather than transitioning to the next state.
	* tests/dfa-match: Add a new test.
	* tests/dfa-match-aux.c: Add a new program to exercise this
	otherwise-unused part of dfa.c.
	* tests/Makefile.am: Add a rule to build new test.
	(check_PROGRAMS): Add dfa-match-aux.
	(AM_CPPFLAGS): Add -I$(top_srcdir)/src.
	(TESTS): Add dfa-match.
	* cfg.mk (exclude_file_name_regexp--sc_bindtextdomain):
	(exclude_file_name_regexp--sc_prohibit_atoi_atof):
	Exempt the new test file from some syntax-check rules.

2014-12-04  Santiago Ruano Rincón  <santiago@debian.org>

	doc: document grep-2.11 change in behavior of -r, --recursive
	* doc/grep.texi (--recursive, -r): Mention the new behavior
	of recursively searching "." when there is no FILE argument.
	* doc/grep.in.1: Likewise.
	That change first appeared in grep-2.11, released on 2012-03-02.

2014-11-24  Jim Meyering  <meyering@fb.com>

	maint: correct for four Author: name misspellings
	* .mailmap: Correct for misspelling in Norihiro Tanaka's last name
	as listed in four commit Author: fields: s/Norihirio/Norihiro/

2014-11-23  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.21
	* NEWS: Record release date.

2014-11-21  Jim Meyering  <meyering@fb.com>

	tests: sjis-mb: remove now-obsolete and failing sub-tests
	* tests/sjis-mb: Commit v2.18-123-geb3292b changed how grep
	handles patterns with encoding errors.  These SJIS tests are
	skipped so often that we didn't notice until now that there were
	two tests of that changed behavior, and that on any system with
	the ja_JP.SHIFT_JIS locale, they would always fail.  Remove those
	two tests, since this functionality is well tested separately,
	via tests/prefix-of-multibyte.

2014-11-20  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep -F could erroneously fail to match in non-UTF8 multibyte locales
	This fixes a bug that can strike only when using a non-UTF8 multibyte
	locale like ja_JP.SHIFT_JIS.

	Consider this example: it would mistakenly fail to match before
	this patch:

	  printf '\203AA\n'|LC_ALL=ja_JP.SHIFT_JIS src/grep -F A

	When searching for a single byte that happens to be the latter
	byte of a multibyte character, and the target byte also follows
	that multibyte character, grep -F would advance an internal pointer
	by one byte too many, thus missing the target byte.  A test case
	for this bug is already included in tests/sjis-mb.

	* src/kwsearch.c (Fexecute): Skip one byte less, after matched middle of a
	multi-byte character.  Introduced by commit v2.18-119-gfb7d538.

2014-11-17  Jim Meyering  <meyering@fb.com>

	tests: big-match: disable OOM-provoking subtest
	* tests/big-match: Our application of this regexp '^.*x\(\)\1'
	to a file containing a single matching line of length 2GiB+2
	would cause inordinate memory consumption (over 100GB) via
	regexec.c, but no leak.  That would cause disruption on most
	systems, so remove this subtest.  Reported by Assaf Gordon.

2014-11-16  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: avoid undefined behavior
	* src/dfa.c (dfassbuild): Don't call memcpy with a second
	argument of NULL, even when the size (3rd argument) is 0.

2014-11-14  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest

2014-11-14  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep -F -x -o PAT would print an extra newline for each match
	* src/kwsearch.c (Fexecute): Correctly compute the length of a match
	by subtracting 2 (not 1) when match_lines is set.  With -x, we augment
	the "line" by both prepending and appending an EOLBYTE to the search
	pattern.  Here, we must correct for that.  However, to compensate,
	when we are using -x (--line-regexp) and start_ptr is NULL, we have
	to add 1 to the length so that we still print the trailing EOLBYTE.
	Introduced by commit v2.18-85-g2c94326.
	* tests/match-lines: Add a new test.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Mention it.

2014-11-11  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port to Darwin
	The 'sed' command 's/.//' does not delete all bytes in the C locale.
	Problem reported by Nelson H. F. Beebe.
	* tests/fmbtest: Don't assume that sed treats bytes with the
	top bit set as valid characters in the C locale, as this is not
	true for Darwin.  Use the cs_CZ.UTF-8 locale instead, and
	simplify the sed script.

	tests: fix recently-introduced stray output
	* tests/init.cfg (require_pcre_): Remove stray debugging output.

	build: port to GCC 4.6.4 + glibc 2.5
	On platforms this old, building with _FORTIFY_SOURCE equal to 2
	results in duplicate definitions of standard library functions.
	Problem reported by Nelson H. F. Beebe.
	* configure.ac (_FORTIFY_SOURCE): Sort after GNULIB_PORTCHECK.
	By default, do not enable this unless GNULIB_PORTCHECK is defined.
	This better matches the original intent, which as I recall was to
	enable these extra checks only with --enable-gcc-warnings.

	tests: port to libpcre sans UTF-8 support
	Problem reported by Nelson H. F. Beebe.
	* tests/pcre-infloop, tests/pcre-invalid-utf8-input, tests/pcre-utf8:
	Skip the test unless PCRE works in an en_US.UTF-8 locale.

2014-11-09  Jim Meyering  <meyering@fb.com>

	tests: do not fail when the zh_CN.UTF-8 locale is not installed
	* tests/word-multibyte: This test would fail on a system with
	no zh_CN.UTF-8 locale. Use it only if it is installed.

	tests: avoid hex_printf_ portability problems
	* tests/init.cfg (hex_printf_): Spell out a-f and A-F, for
	non-C locales, ensure that the input to sed is newline-terminated,
	and quote the final octal format string.
	Suggestions from Paul Eggert.

2014-11-08  Jim Meyering  <meyering@fb.com>

	tests: avoid a multibyte tr portability problem
	* tests/init.cfg (tr): New wrapper function.
	See comments for details.  Reported by Norihiro Tanaka
	in http://debbugs.gnu.org/18991

	maint: remove spurious LC_ALL setting from one test
	* tests/word-multibyte: Remove unnecessary setting of LC_ALL.

	tests: fix typo in previous change
	* tests/init.cfg (hex_printf_): Fix typo s/A-f/A-F/.
	For the record, I introduced that error, not Norihiro.

2014-11-08  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	tests: avoid awk+printf+\xHH portability trap
	* tests/init.cfg (hex_printf_): Rewrite in terms of printf and sed.
	Using awk's printf with \xHH in the format string was not portable
	to the awk of Solaris 10, AIX 7 or HP-UX 11.23, as reported in
	http://debbugs.gnu.org/18987.
	* tests/word-multibyte: Use printf rather than hex_printf_,
	and give the character we're printing a name: e_acute (rather
	than A-grave), since that is used in other tests.
	a trailing \n in the format string, adjust by removing it, and
	instead invoking echo.
	* tests/multibyte-white-space: Simply remove each trailing \n.
	They were not needed.

2014-11-07  Jim Meyering  <meyering@fb.com>

	tests: avoid printf+\xHH portability trap
	* tests/word-multibyte: Using the bourne shell's printf function
	with strings like "\xHH\xHH" happens to work for most interactive
	shells, but not for dash.  That is not portable.  Use our hex_printf_
	awk wrapper instead. Without this change, this test would fail on
	a Debian system for which /bin/sh is configured to be "dash".

	maint: move helper function, hex_printf to init.cfg
	* tests/init.cfg (hex_printf_): New function, from ...
	* tests/multibyte-white-space: ... here.  Reflect the
	s/hex_print/hex_printf_/ renaming.

2014-11-02  Paul Eggert  <eggert@cs.ucla.edu>

	grep: port O_NOFOLLOW errno checking to NetBSD
	Problem reported by Assaf Gordon in: http://bugs.gnu.org/18892
	* NEWS: Document it.
	* src/grep.c (open_symlink_nofollow_error):
	New function, which does the right thing on NetBSD.
	(grepfile): Use it.

2014-10-31  Jim Meyering  <meyering@fb.com>

	build: generate man pages even when existing targets are read-only
	* doc/Makefile.am (grep.1): Use mv -f to move temporary to target,
	in case the target is read-only.  Also, always make the generated
	files read-only.
	(egrep.1 fgrep.1): Likewise.
	This avoids a build failure reported by Eric Blake in
	http://lists.gnu.org/archive/html/bug-grep/2014-10/msg00112.html

2014-10-30  Jim Meyering  <meyering@fb.com>

	tests: avoid false-positive failure due to some zh_CN.* locales
	On some systems, and for some zh_CN.* locales (e.g., OpenBSD5.5) the
	E-acute pair of bytes do not qualify as a word-constituent character.
	* tests/word-multibyte: Use zh_CN.UTF-8, rather than "zh_CN".
	Reported by Assaf Gordon and Bruce Dubbs in
	http://debbugs.gnu.org/18892

2014-10-29  Jim Meyering  <meyering@fb.com>

	gnulib: update to latest; bootstrap, too
	* gnulib: Update to latest.
	* bootstrap: Copy latest from gnulib.

2014-10-28  Jim Meyering  <meyering@fb.com>

	tests: make new test script executable
	* tests/word-multibyte: Make this file executable.

2014-10-28  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: make \w and \W work in multibyte locales
	Reported by Jaroslav Skarvada in: http://bugs.gnu.org/18817
	Now, \w and \W are supported in not only single byte locale but multibyte
	locale.

	* src/dfa.c (PUSH_LEX_STATE, POP_LEX_STATE): Move definitions "up",
	so they are not within the function.
	(lex): Make \w and \W work in a multibyte locale, the same way
	we made \s and \S work.
	* tests/word-multibyte: New test for this change.
	* tests/Makefile.am: Add a rule to build new test.
	* NEWS (Bug fixes): Mention it.

2014-10-26  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: avoid false match in a non-UTF8 multibyte locale
	This command should print nothing:

	  printf '\263\244\263\244\n' \
	    | LC_ALL=ja_JP.eucJP grep -E "$(printf '^x|\244\263')"

	Before this patch, it would print its sole input line.
	* src/dfa.c (struct dfa): Add new members: min_trcount,
	initstate_letter, initstate_others.
	(dfaanalyze): Build states with not only a newline context but others.
	(build_state): Don't release initial states.
	(skip_remains_mb): Add a parameter.
	Add a comment describing all parameters.
	(dfaexec_main): When there are multiple start states, we are about
	to transition from one state to another and the current byte is not
	the first byte of a multibyte character, first advance past the
	current multibyte character.
	* tests/euc-mb: Add a new test.
	* NEWS (Bug fixes): Mention it.
	This addresses http://debbugs.gnu.org/18685

2014-10-25  Paul Eggert  <eggert@cs.ucla.edu>

	tests: work around older libpcre bugs when testing -P and UTF-8
	* tests/pcre-invalid-utf8-input: Add require_timeout_ and
	require_compiled_in_MB_support.  Put a timeout of 3 seconds on
	grep, to avoid having this test case loop forever with older
	versions of libpcre, such as those found on RHEL 6.5.
	Reported by Jim Meyering in: http://bugs.gnu.org/18806#34

2014-10-24  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	tests: add test for grep -P fix
	* tests/pcre-o: New test for this change.
	* tests/Makefile.am (TESTS): Add it.

2014-10-24  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix grep -P crash
	Reported by Shlomi Fish in: http://bugs.gnu.org/18806
	Commit 9fa500407137f49f6edc3c6b4ee6c7096f0190c5 (2014-09-16) is a
	hack that I put in to speed up 'grep -P'.  Unfortunately, not only
	is it violation of modularity, it's also a bug magnet, as we have
	found out with Bug#18738 and Bug#18806.  Remove the optimization
	instead of applying more bandaids.  Perhaps we can think of a
	better way of doing the optimization, or perhaps we can just live
	with a slower grep -P (as -P is inherently slower anyway...).
	* src/grep.c, src/grep.h (validated_boundary):
	Remove.  All uses removed.
	* src/pcresearch.c (Pexecute): Do not worry about validated_boundary.

2014-10-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: remove two erroneous clauses from a now-unused function
	RE_DOT_NEWLINE and RE_DOT_NOT_NULL apply only to a dot that
	matches any character.  Do not consider them when matching
	with a bracket expression.

	* src/dfa.c (match_mb_charset): Remove tests for RE_DOT_NEWLINE
	and RE_DOT_NOT_NULL.

2014-10-19  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: process all MBCSET constructs via glibc's matcher
	The DFA matcher does not support collating symbols or equivalence
	classes, so ensure that any MBCSET reference is handled by the glibc
	matcher.  dfa.c already handled this in one case, but not the other,
	so that a command like "printf '\0' |src/grep -aE '^\s?$'" would
	mistakenly end up using dfa.c's match_mb_charset function rather
	than glibc's matcher.

	* src/dfa.c (dfaexec_main): Move that code into the
	State_transition macro.  This renders the match_mb_charset
	unused by grep.
	* tests/multibyte-white-space: Add a test to exercise the
	just-rendered-inaccessible code path.

2014-10-15  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: initialize validation_boundary properly before use
	* src/grep.c (main): Initialize validation_boundary before pre-searching
	for an empty line.

2014-10-15  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix off-by-one bug in -P optimization
	Reported by Norihiro Tanaka in: http://bugs.gnu.org/18738
	* src/pcresearch.c (Pexecute): Fix off-by-one bug with
	validation_boundary.
	* tests/init.cfg (envvar_check_fail): Catch off-by-one bug.

2014-10-08  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: fix a theoretical bug
	* src/dfa.c (dfaexec_main): After searching for a match from
	the initial state, set the previous state, S1, to 0.
	So far, we have found no case in which this fix makes a difference.
	See http://debbugs.gnu.org/18645

2014-10-07  Paul Eggert  <eggert@cs.ucla.edu>

	doc: modernize and simplify man page
	* doc/grep.in.1 (Tx, Id): Remove.  All uses removed.
	(MTO, URL): New macros, used for email and URL.
	Use them when appropriate.
	In main text, omit chatty discussions of other implementations;
	the full manual suffices for this sort of thing.

	doc: clarify exit status
	Reported by Santiago Ruano Rincón in: http://bugs.gnu.org/18651
	* doc/grep.in.1 (EXIT STATUS):
	* doc/grep.texi (Exit Status): Clarify.

2014-10-07  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: test for just-fixed bug
	* tests/mb-dot-newline: New file.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Mention it.
	Bisection suggests that the bug was introduced by
	commit v2.18-123-geb3292b.  Also see
	http://debbugs.gnu.org/cgi/bugreport.cgi?msg=17;bug=18580

2014-10-05  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: factor out a new nontrivial block of duplicated code
	* src/dfa.c (State_transition): New macro.
	(dfaexec_main): Use it twice.

	dfa: check end of input buffer after transition in non-UTF8 multibyte locale
	* src/dfa.c (dfaexec_main): Check for end of input buffer after each
	transition in a non-UTF8 multibyte locale.
	* tests/mb-non-UTF8-overrun: New test.
	* tests/Makefile.am (TESTS): Add it.
	* src/grep.c (main): With this fix, we no longer need the fourth
	byte of "eolbytes".

2014-10-04  Jim Meyering  <meyering@fb.com>

	grep: avoid stack buffer read-underrun and overrun
	Testing binaries built with -fsanitize=address caused aborts due
	to stack underrun and overrun.
	* src/grep.c (main): Allocate a larger buffer for eolbytes:
	one byte before the beginning and one more after the end.
	For details, see http://debbugs.gnu.org/18580#44.

2014-10-04  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: fix subscript error when testing whether empty lines match
	src/grep.c (grep): When testing whether an empty line matches,
	make the input buffer one byte longer, as dfaexec uses that
	for a sentinel.

2014-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: minor tweaks, mostly to remove __attribute__ ((noinline))
	That attribute isn't portable, and I found a way to get similar
	performance with standard C features.
	* NEWS: Document the recently-installed performance improvement.
	* src/dfa.c (struct dfa): New member dfaexec.
	(dfaexec_main): Remove unnecessary 'const'.
	(dfaexec_mb, dfaexec_sb): Remove __attribute__ ((noinline));
	no longer needed.
	(dfaexec): Use new dfaexec member.
	(dfainit, dfaoptimize, dfassbuild): Initialize it.

2014-09-27  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: separate dfaexec function to help optimization by compiler
	* src/dfa.c (dfaexec_main): Rename from dfaexec, add inline attribute.
	(dfaexec_mb): New function.  Run it when d->multibyte is true.   For this
	function inlination must be avoided.
	(dfaexec_sb): New function.  Run it when d->multibyte is false.  For this
	function inlination must be avoided.
	(dfaexec): Call dfaexec_mb or dfaexec_sb accoding to d->multibyte.

2014-09-27  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: speed-up at initial state
	DFA state is always 0 until have found potential match.  So we improve
	matching there by continuing to use the transition table.

	* src/dfa.c (skip_remains_mb): New function.
	(dfaexec): Speed-up at initial state.

2014-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	maint: generalize the -Wcast-align fix
	* src/grep.c (CAST_ALIGNED): New macro.
	(skip_easy_bytes): Use it.

2014-09-27  Jim Meyering  <meyering@fb.com>

	maint: suppress a false-positive -Wcast-align warning
	Building with --enable-gcc-warnings and gcc-4.9.1 would provoke this:
	  grep.c:499:12: error: cast from 'const char *' to 'const uword *'\
	      (aka 'const unsigned long *') increases required alignment from\
	      1 to 8 [-Werror,-Wcast-align]
	    for (s = (uword const *) p; ! (*s & hibyte_mask); s++)
		     ^~~~~~~~~~~~~~~~~
	* src/grep.c (skip_easy_bytes): Use a pragma to suppress
	gcc's false-positive cast-alignment warning.

2014-09-26  Paul Eggert  <eggert@cs.ucla.edu>

	grep: don't check extensively for invalid prefix bytes unless -P
	Problem reported by Jim Meyering in: http://bugs.gnu.org/18454#56
	* src/grep.c (grep): After the first buffer is checked, leave the
	file-type checker in TEXTBIN_UNKNOWN state only when -P is used.
	Only the -P matcher has performance problems with checking binary
	data that make it worthwhile to check every prefix input byte so
	the -P matcher's TEXTBIN_UNKNOWN optimizations can come into play.
	Other matchers can simply check the data directly, and using
	TEXTBIN_UNKNOWN with them slows 'grep' down for no benefit.

	grep: scan for valid multibyte strings more quickly
	Scan valid multibyte strings more quickly in the common case of
	encodings that are upward compatible with ASCII, such as UTF-8.
	You'd think there'd be a fast standard way to do this nowadays,
	but nooooo....
	Problem reported by Jim Meyering in: http://bugs.gnu.org/18454#56
	* src/grep.c (HIBYTE): New constant.
	(easy_encoding): New static var.
	(init_easy_encoding, skip_easy_bytes): New functions.
	(uword): New type.
	(buffer_textbin): Skip easy bytes quickly.
	Don't bother with mb_clen here, since skip_easy_bytes typically
	captures the easy cases; just use mbrlen directly.
	(buffer_textbin, file_textbin): First arg is no longer a const
	pointer, since the byte past the end is now an overwritten sentinel.
	(fillbuf): Make room for a uword after the buffer, for skip_easy_bytes.
	(main): Call init_easy_encoding.

2014-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	grep: speed up processing of holes before EOF on Solaris
	* src/grep.c (fillbuf): If SEEK_DATA fails with errno == ENXIO,
	skip over the hole at EOF.

	grep: port to platforms lacking SEEK_DATA
	Reported by Norihiro Tanaka in: http://bugs.gnu.org/18454#38
	* src/grep.c (SEEK_DATA): Default to SEEK_SET if not defined.
	(SEEK_HOLE): Move to top level, and default it to SEEK_SET.
	(file_textbin): Adjust to new default.
	(fillbuf): Don't bother with SEEK_DATA if it defaults to SEEK_SET.

	grep: skip past holes efficiently
	Take advantage of the relaxed rules for treating non-text bytes in
	binary data, by efficiently skipping past holes on platforms
	supporting lseek's SEEK_DATA flag.
	On one test on a circa-2008 Sun Fire V40z running Solaris 11.2,
	'grep x' took 0.009 real-time seconds to scan a holey file of size
	9,223,372,036,854,775,802 bytes, for a nominal scan rate of 1 ZB/s.
	grep 2.20's scan rate on this platform was 843 MB/s, so this is a
	speedup by a factor of 1.2 trillion.  The speedup factor is not
	as great on GNU/Linux hosts, due to what appear to be SEEK_DATA
	inefficiencies, but presumably this will be cleared up in time.
	* NEWS: Document this.
	* src/grep.c, src/grep.h (eolbyte): Now char, not unsigned char.
	This is for compatibility with the rest of the code.
	The old (performance?) reasons for 'unsigned char' are now moot.
	* src/grep.c (skip_nuls, skip_empty_lines, seek_data_failed):
	New static vars.
	(totalnl): Move up, since it's about input, not output, and
	fillbuf now uses it.
	(add_count): Move up, since fillbuf now uses it.
	(all_zeros): New function.
	(fillbuf): Use SEEK_DATA to skip past holes efficiently,
	on systems that support this.
	(grep, main): Set the new static vars.

	grep: improve -P performance in typical cases
	* src/grep.c, src/grep.h (enum textbin): Move to grep.h.
	(input_textbin, validated_boundary): New vars.
	* src/grep.c (grepbuf, grep): Initialize them.
	* src/pcresearch.c (Pexecute): Do a multiline search
	when the input is known to be free of encoding errors.
	Quickly discard bytes that are obviously encoding errors.
	Quickly match empty strings.

	grep: minor -P speedup with jit_stack
	* src/pcresearch.c (jit_stack): No longer static.

	grep: non-text bytes in binary data may be treated as line ends
	* NEWS, doc/grep.texi (File and Directory Selection):
	Document this change.
	* src/grep.c (zap_nuls): New function.
	(grep): Use it.
	* tests/null-byte: Relax to allow new behavior.

	grep: -z no longer considers '\200' to be binary data
	This avoids a problem when using grep -z in a Windows-1252 locale.
	Plus, it lets 'grep -z' run a bit faster.
	* NEWS: Document this.
	* src/grep.c (buffer_textbin): Don't look for '\200' if -z.
	* tests/pcre-z: Test for new behavior.

	grep: refactor binary-vs-unknown-vs-text flags for clarity
	* src/grep.c (enum textbin): New enum.
	(textbin_is_binary): New function.
	(buffer_textbin, file_textbin, grep): Use them, for clarity.

2014-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix -P speedup bug with empty match
	* src/pcresearch.c (NSUB): New top-level constant, replacing
	'nsub' within Pexecute.
	(Pcompile, Pexecute): Use it.
	(Pexecute): Don't assume sub[1] is zero after a PCRE_ERROR_BADUTF8
	match failure.
	* tests/pcre-invalid-utf8-input: Test for this bug.

	grep: port -P speedup to hosts lacking PCRE_STUDY_JIT_COMPILE
	* src/pcresearch.c (Pcompile): Do not assume that
	PCRE_STUDY_JIT_COMPILE is defined.
	(empty_match): Define on all platforms.

	grep: use mbclen cache in one more place
	* src/grep.c (fgrep_to_grep_pattern): Use mb_clen here, too.

	grep: avoid false alarms for mb_clen and to_uchar
	* cfg.mk (_gl_TS_unmarked_extern_functions): New var,
	to bypass the tight_scope false alarms on mb_clen and to_uchar.

	grep: use mbclen cache more effectively
	* src/grep.c (buffer_textbin, contains_encoding_error):
	Use mb_clen for speed.
	(buffer_textbin): Bypass mb_clen in unibyte locales.
	(main): Always initialize the cache, since it's sometimes used in
	unibyte locales now.  Initialize it before contains_encoding_error
	might be called.
	* src/search.h (SEARCH_INLINE): New macro.
	(mbclen_cache): Now extern decl.
	(mb_clen): New inline function.
	* src/searchutils.c (SEARCH_INLINE, SYSTEM_INLINE): Define.
	(mbclen_cache): Now extern.
	(build_mbclen_cache): Put 1 into the cache when mbrlen returns 0.
	(mb_goback): Use mb_len for speed, and rely on it returning nonzero.
	* src/system.h (SYSTEM_INLINE): New macro.
	(to_uchar): Use it.

	grep: improve performance for older glibc
	glibc has a bug where mbrlen and mbrtowc mishandle length-0 inputs.
	Working around it in gnulib slows grep down, so disable the tests for it
	and make sure grep works even if the bug is present.
	* bootstrap.conf (avoided_gnulib_modules): Add mbrtowc-tests.
	* configure.ac (gl_cv_func_mbrtowc_empty_input): Assume yes.
	* src/searchutils.c (mb_next_wc): Don't invoke mbrtowc on empty input.

	grep: treat a file as binary if its prefix contains encoding errors
	* NEWS:
	* doc/grep.texi (File and Directory Selection):
	Document this.
	* src/grep.c (buffer_encoding, buffer_textbin): New functions.
	(file_textbin): Rename from file_is_binary.  Now returns 3-way value.
	All callers changed.
	(file_textbin, grep): Check the input more carefully for text vs
	binary data.
	(contains_encoding_error): Remove; use replaced by buffer_encoding.
	* tests/backref-multibyte-slow:
	* tests/high-bit-range:
	* tests/invalid-multibyte-infloop:
	Use -a, since the input is now considered to be binary.
	* tests/invalid-multibyte-infloop: Add a check for new behavior.

	grep: use bool for boolean in grep.c
	* src/grep.c (show_version, suppress_errors, only_matching)
	(align_tabs, match_icase, match_words, match_lines, errseen)
	(write_error_seen, is_device_mode, usable_st_size)
	(file_is_binary, skipped_file, reset, fillbuf, out_quiet)
	(out_line, out_byte, count_matches, no_filenames, line_buffered)
	(done_on_match, exit_on_match, print_line_head, prline, grep)
	(grepdirent, grepfile, grepdesc, grep_command_line_arg)
	(get_nondigit_option, main): Use bool for boolean.
	(print_line_head, prline): Use char for byte.
	* src/grep.h: Include <stdbool.h>, and adjust decls to match
	changes in grep.c.

	grep: speed up -P on files containing many multibyte errors
	* src/pcresearch.c (empty_match): New var.
	(Pcompile): Set it.
	(Pexecute): Use it.

	grep: remove/refactor unnecessary code about line splitting
	* src/grep.c (do_execute): Remove.  Caller now uses 'execute'.
	* src/pcresearch.c (Pexecute): Improve comment about this.

2014-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	grep: diagnose -P in non-UTF-8 multibyte locale
	* src/pcresearch.c (Pcompile):
	libpcre supports only unibyte and UTF-8 locales,
	so report an error and exit if used in other locales.
	* NEWS: Mention this.
	* tests/euc-mb: Test this.

2014-09-12  Jim Meyering  <meyering@fb.com>

	doc: move NEWS note about GREP_OPTIONS into proper section
	* NEWS (Changes in behavior): Move the note about GREP_OPTIONS
	from the 2.20 section into the section for the upcoming release.

2014-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	grep: make GREP_OPTIONS obsolescent
	* NEWS:
	* doc/grep.in.1 (ENVIRONMENT_VARIABLES):
	* doc/grep.texi (Environment Variables):
	Document that GREP_OPTIONS is obsolescent now.
	* src/grep.c (main): Warn if GREP_OPTIONS is used.
	* tests/r-dot, tests/skip-device: Don't use GREP_OPTIONS.

2014-09-11  Paul Eggert  <eggert@cs.ucla.edu>

	doc: bug tracker has moved to debbugs.gnu.org
	* README (KNOWN BUGS):
	* doc/grep.in.1:
	* doc/grep.texi (Reporting Bugs): Document this.

	grep: fix false matches with -P '...$' and invalid UTF-8
	* tests/pcre-invalid-utf8-input: Add a test for that.

	grep: fix false matches with -P '...$' and invalid UTF-8
	* src/pcresearch.c (Pexecute): Use PCRE_NOTEOL when matching
	initial substrings of a line.

2014-09-10  Jim Meyering  <meyering@fb.com>

	tests: add expect-to-fail test for a glibc regexp bug
	* tests/triple-backref: New file.
	* tests/Makefile.am (TESTS): Add it.
	(XFAIL_TESTS): List it as a known, always-failing test.
	Based on the bug report from Paul Eggert:
	https://sourceware.org/bugzilla/show_bug.cgi?id=17356

	maint: avoid distcheck failure
	* Makefile.am (EXTRA_DIST): Add .mailmap.

2014-09-10  Paul Eggert  <eggert@cs.ucla.edu>

	grep: port recent fix to older pcre version
	* src/pcresearch.c (Pexecute): Don't assume that a pcre_exec
	that returns PCRE_ERROR_NOMATCH leaves its sub argument alone.
	This assumption is false for libpcre-3 version 8.31-2ubuntu2.

2014-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: -P now treats invalid UTF-8 input as non-matching
	Problem reported by Santiago Vila in: http://bugs.gnu.org/18266
	* NEWS: Mention this.
	* src/pcresearch.c (Pexecute): Treat UTF-8 encoding errors
	as non-matching data, instead of exiting 'grep'.
	* tests/pcre-infloop: grep now exits with status 1, not 2.
	* tests/pcre-invalid-utf8-input: grep now exits with status 0, not 2.

2014-08-14  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix integer-width bugs in undossify_input etc.
	undossify_input bug reported by Vincent Lefevre in:
	http://bugs.gnu.org/18269
	* src/dosbuf.c (undossify_input): Return size_t, not int.
	* src/grep.c (fillbuf): Work portably even if safe_read returns a
	value greater than SSIZE_MAX, e.g., if there's an I/O error.

2014-08-03  Paul Eggert  <eggert@cs.ucla.edu>

	doc: document LANGUAGE
	Reported by Benno Schulenberg in: http://bugs.gnu.org/18185
	* doc/grep.texi (Environment Variables): Document LANGUAGE.

	doc: prefer @env to @code
	Reported by Benno Schulenberg in: http://bugs.gnu.org/18184
	* doc/grep.texi: Avoid @code in favor of @env, or of nothing at all.

2014-07-11  Paul Eggert  <eggert@cs.ucla.edu>

	doc: Document -r vs --exclude more carefully.
	Problem reported by Hugues Andreux in: http://bugs.gnu.org/17763
	* doc/grep.texi (File and Directory Selection): Be more careful
	about documenting the interaction between recursive searching,
	--include, --exclude, and --exclude-dir.

2014-06-27  Jim Meyering  <meyering@fb.com>

	maint: split long lines, and enforce the 80-column limit
	* cfg.mk (sc_long_lines): New rule, from coreutils; exempt tests/*
	* src/grep.c (usage): Tweak -F wording to shorten a line.
	Correct grammar in a comment.
	Split the --exclude-file=... description to fit within 80 columns.
	Use emit_bug_reporting_address, eliminating another long line.
	* src/dfa.c: Split long lines.  No semantic change.
	* doc/grep.texi: Likewise.
	* tests/include-exclude: Split a long line.
	* tests/backref: Split long lines.
	* tests/empty: Likewise.
	* tests/fmbtest: Likewise.

	doc: update HACKING
	* HACKING: Update from coreutils.

	maint: generate distributed THANKS from VC'd THANKS.in
	* Makefile.am (THANKS): New rule.
	* THANKS.in: New file.
	* THANKS: Remove.  Now it's generated from the combination of
	THANKS.in and git logs.
	* .mailmap: New file.
	* cfg.mk (sc_THANKS_in_duplicates): New syntax-check rule, from
	coreutils.
	* .gitignore: Add THANKS.
	* thanks-gen: New file, from coreutils.

2014-06-27  Paul Eggert  <eggert@cs.ucla.edu>

	grep: with -E, unmatched ')' matches itself
	Problem reported by Nathan Weeks in: http://bugs.gnu.org/17856
	* src/grep.c (Ecompile): Also specify RE_UNMATCHED_RIGHT_PAREN_ORD.
	* doc/grep.texi (Fundamental Structure), NEWS: Document this.
	* tests/ere.tests: Add a couple of tests for this.
	* tests/spencer1.tests: Fix exit status.

2014-06-17  Paul Eggert  <eggert@cs.ucla.edu>

	build: avoid -Wstack-protector
	This allows the use of --enable-gcc-warnings on Gentoo and Ubuntu.
	See: http://bugs.gnu.org/17793
	* configure.ac (WERROR_CFLAGS): Avoid -Wstack-protector.

	This can be worked around, but the cure is worse than the disease.

2014-06-17  Paul Eggert  <eggert@cs.ucla.edu>

	build: don't make output files read-only
	This led to problems, such as the prompt "mv: try to overwrite
	'egrep', overriding mode 0555 (r-xr-xr-x)? " during a build.
	It can be worked around, but the cure is worse than the disease;
	making output files read-only is more trouble than it's worth.
	* doc/Makefile.am (grep.1, egrep.1, fgrep.1):
	* lib/Makefile.am (colorize.c):
	* src/Makefile.am (egrep fgrep):
	Don't make output files read-only.  Prefer separate commands to
	'&&' when either will do.

2014-06-08  Paul Eggert  <eggert@cs.ucla.edu>

	maint: remove grep.spec
	* grep.spec: Remove; obsolete and evidently not used.

2014-06-07  Paul Eggert  <eggert@cs.ucla.edu>

	doc: use gnulib fdl module
	* bootstrap.conf (gnulib_modules): Add fdl.
	* doc/fdl.texi: Remove, as this now comes from gnulib.
	* doc/.gitignore: Update to match current sources.

2014-06-06  Jim Meyering  <meyering@fb.com>

	build: improve rule to generate egrep+fgrep scripts
	* src/Makefile.am (egrep fgrep): chmod a=rx generated files,
	and remove $@-t before attempting to redirect to it, in case it
	is read-only.

	build: don't redirect directly to $@
	* lib/Makefile.am (colorize.c): Don't redirect directly to target, $@.
	Otherwise, we could create a corrupt colorize.c file with a
	timestamp that indicates it is up to date.
	Also, make the generated file read-only.

2014-06-05  Paul Eggert  <eggert@cs.ucla.edu>

	grep: undo part of previous change
	* src/dfa.c (enlist): Undo part of previous change that doesn't
	look correct and doesn't help performance much anyway.

	grep: use system strstr if available and fast
	Problem reported by Norihiro Tanaka in: http://bugs.gnu.org/17700
	* NEWS: Document this.
	* bootstrap.conf (gnulib_modules): Add strstr.
	* src/dfa.c (istrstr): Remove.
	(enlist): Use strstr instead.  Wait until we need memory before
	allocating it; this can save an unnecessary allocate and free.

	build: update gnulib submodule to latest

2014-06-03  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.20
	* NEWS: Record release date.

2014-05-30  Jim Meyering  <meyering@fb.com>

	grep: fix --max-count=N (-m N) to stop reading after Nth match
	With --max-count=N (-m N), grep is supposed to stop reading input
	after it has found the Nth match.  However, a recent context-
	related change made it so grep would always read to end of file.
	* src/grep.c (prtext): Don't let a negative "out_after" value
	make "pending" line count negative.
	* tests/max-count-overread: New test, for this.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Mention it.
	* THANKS: Add names of two recent bug reporters.
	This bug was introduced by commit v2.18-139-g5122195.
	Reported by Marc Aldorasi in http://bugs.gnu.org/17640.

2014-05-29  Jim Meyering  <meyering@fb.com>

	dfa: fix off-by-one under-allocation from recent change
	Commit v2.19-10-gc32ff67 mistakenly made this change:
	  -realloc_trans_if_necessary (d, 1);
	  +realloc_trans_if_necessary (d, 0);
	which led to a heap buffer overflow.
	* src/dfa.c (dfaexec): Allocate space for one state, as before.

2014-05-28  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: fix bug with regex containing multiple begin/end-line constraints
	grep -E 'a(b$|c$)' would mistakenly match "aa".
	* src/dfa.c (dfamust): When resetting 'is' in OR, also reset
	'begline' and 'endline' of 'must'.
	* NEWS (Bug fixes): Mention it.
	This bug was introduced via commit v2.18-85-g2c94326.
	Reported by Péter Radics in <http://bugs.gnu.org/17617>.

2014-05-26  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: simplify building initial state
	build_state_zero doesn't need the struct dfa to be initialized,
	so remove the initialization and simplify.
	* src/dfa.c (build_state_zero): Remove.
	(dfaexec): Call realloc_trans_if_necessary and build_state directly.

	dfa: revert "grep: do not count newline before the start of buffer"
	This reverts commit 5dc3af2806d21455b818be3f9da26c372e4a7f8d.
	The previous change renders that commit unnecessary.

	dfa: do not clear the first state of a transition table
	If number of DFA states reaches 1024, build_state clears transition
	tables to save memory.  However, the initial state is always used,
	so clearing it just wastes time.
	* src/dfa.c (build_state): Do not clear the initial state's
	transition and failure tables.

	grep: remove unnecessary argument
	* src/grep.c (do_execute): Remove argument 'start_ptr'.  It's always null.
	All uses changed.

2014-05-24  Paul Eggert  <eggert@cs.ucla.edu>

	grep: --exclude-dir=FOO/ now ignores the trailing slash
	Problem reported by Khaled Ziyaeen; see: http://bugs.gnu.org/17481
	* NEWS, doc/grep.texi (File and Directory Selection): Document this.
	* src/grep.c (main): Implement this.
	* tests/include-exclude: Test this.

	dist: don't distribute lib/colorize.c
	'configure' creates this file, so it shouldn't be distributed; see:
	http://bugs.gnu.org/17480
	* configure.ac (COLORIZE_SOURCE): New macro.
	Don't use AC_CONFIG_LINKS for lib/colorize.c.
	* lib/Makefile.am (nodist_libgreputils_a_SOURCES): New macro.
	(libgreputils_a_SOURCES): Remove colorize.c.
	(CLEANFILES): Add colorize.c
	(colorize.c): New rule.

2014-05-23  behoffski  <behoffski@grouse.com.au>

	maint: uncapitalize first letter of two dfaerror message strings
	* dfa.c (lex): Make two message strings consistent with all of
	the others: do not capitalize the first letter of the first word.

2014-05-23  Jim Meyering  <meyering@fb.com>

	maint: revert "grep: port mb_next_wc to RHEL 6.5 x86-64"
	This reverts commit v2.18-148-ga6ae68d.
	Now that we have gnulib change v0.1-131-g2a045bc, "mbrlen, mbrtowc:
	fix bug with empty input", this work-around is no longer needed.

	gnulib: update, for mbrlen/mbrtowc empty input bug fix

2014-05-22  Jim Meyering  <meyering@fb.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.19
	* NEWS: Record release date.

2014-05-21  Jim Meyering  <meyering@fb.com>

	maint: avoid new false-positive syntax-check failure
	* cfg.mk (exclude_file_name_regexp--sc_prohibit_doubled_word):
	Exempt new test file that contains legitimate use of "in in".

2014-05-17  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	tests: add test case for newline-count fix
	* tests/count-newline: New test.
	* tests/Makefile.am (TESTS): Add it.

2014-05-16  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: do not count newline before the start of buffer
	* src/dfa.c (build_state): When checking whether the previous
	character was a newline, do not count any newline before the
	start of the buffer.

2014-05-15  Paul Eggert  <eggert@cs.ucla.edu>

	grep: port mb_next_wc to RHEL 6.5 x86-64
	* src/searchutils.c (mb_next_wc): Work around glibc bug 16950; see:
	https://sourceware.org/bugzilla/show_bug.cgi?id=16950
	This bug was masked in the other GNU/Linux tests I made.  It was
	exposed on RHEL 6.5 x86-64, where the compiler (GCC Red Hat 4.4.7-4)
	happened to use temporaries in a different way.
	Also see recent changes to the Gnulib documentation in this area:
	http://lists.gnu.org/archive/html/bug-gnulib/2014-05/msg00013.html

	tests: port mb-non-UTF8-performance to RHEL 6.5
	* tests/mb-non-UTF8-performance (timeout): Use an integer,
	as 'timeout 1.234' doesn't work in EUC locales.

2014-05-12  Paul Eggert  <eggert@cs.ucla.edu>

	egrep, fgrep: port to Solaris 10 /bin/sh
	This old shell doesn't grok ${0%/*}; see: http://bugs.gnu.org/17471
	* src/Makefile.am (egrep fgrep): Don't assume the shell does substrings.
	* src/egrep.sh (dir): New var, so that the substring calculation is
	done only once (which is a small win even with newer shells),
	and so that the calculation is easier to edit on older shells.

2014-05-10  Jim Meyering  <meyering@fb.com>

	maint: NEWS: adjust wording to reflect move
	* NEWS (Improvements): Correct direction-relative wording,
	now that the referent is below, not above.

	maint: NEWS: move "Improvements" to the top
	* NEWS: Move the small "Improvements" section to precede
	the longer "Bug fixes" one.

	gnulib: update submodule to latest, and bootstrap
	* gnulib: Update submodule.
	* bootstrap: Update from gnulib.

2014-05-10  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: omit double includes
	* src/dfa.c: Don't include stddef.h or stdbool.h, as dfa.h includes
	them already, and it's the same module as we are.
	Suggested by Aharon Robbins in: http://bugs.gnu.org/17458

	dfa: fix bug with \< etc in multibyte locales
	Problem reported by Stephane Chazelas in: http://bugs.gnu.org/16867
	* NEWS: Document the fix.
	* src/dfa.c (dfaoptimize): Remove any superset if changing from
	UTF-8 to unibyte, and if the pattern has no backreferences.
	(dfassbuild): In multibyte locales, treat \< \> \b \B as
	backreferences in the DFA, since the DFA relies on unibyte
	tests to check them.
	(dfacomp): Optimize after building the superset, so that
	dfassbuild can depend on d->multibyte.  A downside is that
	dfaoptimize must remove supersets that are likely slower than the
	DFA after optimization, but that's been done in the
	above-described change.
	* tests/Makefile.am (XFAIL_TESTS): Remove word-delim-multibyte,
	since the test works now.

	tests: add test case for -C 0 change
	* tests/context-0: New test.
	* tests/Makefile.am (TESTS): Add it.

	grep: -A 0, -B 0, -C 0 now output a separator
	Problem reported by Dan Jacobson in: http://bugs.gnu.org/17380
	* NEWS:
	* doc/grep.texi (Context Line Control): Document this.
	* src/grep.c (prtext): Output a separator even if context is zero.
	(main): Default context is now -1, not 0.

2014-05-09  Paul Eggert  <eggert@cs.ucla.edu>

	grep: minor improvements to retry-DFA-superset patch
	* src/dfasearch.c (EGexecute): Avoid unnecessary test in a context
	where memrchr cannot return a null pointer.

2014-05-09  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: retry DFA superset after matching multiple lines
	* src/dfasearch.c (EGexecute): Without this patch, the code reverts
	to KWset when the DFA superset matches multiple lines.
	However, if the DFA superset matches multiple lines, it most likely
	also matches a single line, and reverting to KWset means dfafast
	won't work effectively.  Change the code so that it retries the DFA
	superset immediately after it matches multipline lines.  On my platform
	this improves the performance of "LC_ALL=C grep '\(ab\)cd\1d' k" from
	3.48 to 2.14 seconds realtime, where k contains the output of
	"yes abcdabc | head -50000000".

	dfa: fix inconsistency in multibyte locales
	* src/dfa.c (dfaexec): Use the same exit condition in multibyte
	locales as in unibyte.

2014-05-08  Jim Meyering  <meyering@fb.com>

	maint: mark some breakless cases with /* fallthrough */ comment
	* src/dfa.c (addtok_mb, dfaanalyze): Add comment so that it is
	clear that the "break" statement is deliberately omitted.

2014-05-08  Paul Eggert  <eggert@cs.ucla.edu>

	dfa: assume C89 for CHAR_BIT
	* src/dfa.c (CHARBITS): Remove.  All uses replaced by CHAR_BIT.
	(NOTCHAR): Now an enum, since it need not be a macro.

	dfa: don't assume unsigned int is exactly 32 bits wide
	Sun C 5.12 (sparc) warns of the potential unportability.
	* src/dfa.c (charclass_word): New type, for clarity.
	All relevant uses of 'unsigned' changed.
	(CHARCLASS_WORD_BITS): Rename from INTBITS.  All uses changed.
	Now an enum, since it needn't be a macro.
	(CHARCLASS_WORD_MASK): New macro.
	(CHARCLASS_WORDS): Rename from CHARCLASS_INTS.  All uses changed.
	(setbit, clrbit): Cast 1 to charclass_word, for clarity.
	(notset, add_utf8_anychar, dfastats):
	Don't assume unsigned int is exactly 32 bits wide.
	(dfastate): Don't rely on implementation-defined conversion of
	greater-than-INT_MAX unsigned to int.  Change bit test to resemble
	tstbit more.

	maint: fix indenting to pacify 'prohibit_tab_based_indentation'
	* src/dfa.c: Use spaces and not tabs to indent some lines.

	grep: simplify and clarify invert-related code
	* src/grep.c (out_invert, prtext): Use bool for booleans.
	(prline): Remove unnecessary '!!' on a value that is always 0 or 1.
	(prtext): Remove last arg NLINESP; use !out_invert instead.  All uses
	changed.  Move decls to nearer uses, since we can assume C99 here.
	Update 'outleft' and 'after_last_match' here; it's simpler.
	(grepbuf): Compute return value by subtracting new from old 'outleft',
	rather than by keeping a separate running total.  Avoid code duplication
	by arranging for prtext to be called from one place, not three.

2014-05-08  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	grep: improve performance of -v when combined with -L, -l or -q
	Problem reported by Jörn Hees in: http://bugs.gnu.org/17427
	* src/grep.c (grepbuf, grep): When -v is combined with -L, -l, or -q,
	don't read data unnecessarily after a non-match is found.

2014-05-06  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention performance changes
	* NEWS: Discuss recent performance improvements and downgrades.

	dfa: clarify use of "if"
	The phrase "Y is true if X" is logically equivalent to "X implies Y",
	but often "X if and only if Y" was intended.
	* src/dfa.c, src/dfa.h: Reword to avoid the incorrect use of "if".

	dfa: minor performance improvement for previous change
	* src/dfa.c (struct dfa): New member 'fast'.  Remove 'has_backref'.
	All uses changed.

2014-05-06  Norihiro Tanaka  <noritnk@kcn.ne.jp>

	dfa: speed up 'dfaisfast'
	* src/dfa.c (struct dfa): New member 'has_backref'.
	(addtok_mb): Set it.
	(dfaisfast): Use it.

2014-05-05  Paul Eggert  <eggert@cs.ucla.edu>

	grep: fix -w match next to a multibyte letter
	* NEWS: Document this.
	* src/dfasearch.c, src/kwsearch.c (WCHAR): Remove.
	(wordchar): New static function.
	* src/dfasearch.c (EGexecute):
	* src/kwsearch.c (Fexecute): Use the new functions, so that the
	code works correctly if a multibyte character adjacent to the
	match has two or more bytes.
	* src/search.h, src/searchutils.c (mb_prev_wc, mb_next_wc):
	New functions.
	* tests/word-delim-multibyte: Add a test for grep -w (which now
	passes), and a test for \> (which still fails).  The \< test also
	still fails.

	grep: improve internal API for multibyte boundary
	* src/search.h, src/searchutils.c (mb_goback): Rename from
	is_mb_middle.  Omit last arg.  Return number of bytes to go back,
